// PIO compatible header file STC12x54.h 20210829.
// For use with STC12C54xx STC12C54xxAD STC12LE54xx STC12LE54xxAD series.

#ifndef STC12x54_H
#define STC12x54_H
#include <compiler.h>

SFR(P0, 0x80);
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(SPSTAT, 0x84);
SFR(SPCTL, 0x85);
SFR(SPDAT, 0x86);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(AUXR, 0x8E);
SFR(WAKE_CLKO, 0x8F);
SFR(P1, 0x90);
   SBIT(CLKOUT0, 0x90, 0); //Clock Out 0
   SBIT(CLKOUT1, 0x90, 1); //Clock Out 1
   SBIT(SS,      0x90, 4); //Slave Select
   SBIT(MOSI,    0x90, 5); //Master Out Slave In
   SBIT(MISO,    0x90, 6); //Master In Slave Out
   SBIT(SCLK,    0x90, 7); //Serial Clock
   SBIT(ACH0, 0x90, 0); //ADC Channel 0
   SBIT(ACH1, 0x90, 1); //ADC Channel 1
   SBIT(ACH2, 0x90, 2); //ADC Channel 2
   SBIT(ACH3, 0x90, 3); //ADC Channel 3
   SBIT(ACH4, 0x90, 4); //ADC Channel 4
   SBIT(ACH5, 0x90, 5); //ADC Channel 5
   SBIT(ACH6, 0x90, 6); //ADC Channel 6
   SBIT(ACH7, 0x90, 7); //ADC Channel 7
   SBIT(ADC0, 0x90, 0); //AtoD Channel 0
   SBIT(ADC1, 0x90, 1); //AtoD Channel 1
   SBIT(ADC2, 0x90, 2); //AtoD Channel 2
   SBIT(ADC3, 0x90, 3); //AtoD Channel 3
   SBIT(ADC4, 0x90, 4); //AtoD Channel 4
   SBIT(ADC5, 0x90, 5); //AtoD Channel 5
   SBIT(ADC6, 0x90, 6); //AtoD Channel 6
   SBIT(ADC7, 0x90, 7); //AtoD Channel 7
   SBIT(AIN0, 0x90, 0); //Analog Input 0
   SBIT(AIN1, 0x90, 1); //Analog Input 1
   SBIT(AIN2, 0x90, 2); //Analog Input 2
   SBIT(AIN3, 0x90, 3); //Analog Input 3
   SBIT(AIN4, 0x90, 4); //Analog Input 4
   SBIT(AIN5, 0x90, 5); //Analog Input 5
   SBIT(AIN6, 0x90, 6); //Analog Input 6
   SBIT(AIN7, 0x90, 7); //Analog Input 7
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(P1M0, 0x91);
SFR(P1M1, 0x92);
SFR(P0M0, 0x93);
SFR(P0M1, 0x94);
SFR(P2M0, 0x95);
SFR(P2M1, 0x96);
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error
SFR(SBUF, 0x99);
SFR(P2, 0xA0);
   SBIT(PCA2, 0xA0, 0);
   SBIT(PWM2, 0xA0, 0);
   SBIT(PCA3, 0xA0, 4);
   SBIT(PWM3, 0xA0, 4);
   SBIT(P20, 0xA0, 0);
   SBIT(P21, 0xA0, 1);
   SBIT(P22, 0xA0, 2);
   SBIT(P23, 0xA0, 3);
   SBIT(P24, 0xA0, 4);
   SBIT(P25, 0xA0, 5);
   SBIT(P26, 0xA0, 6);
   SBIT(P27, 0xA0, 7);
SFR(IE, 0xA8);
   SBIT(EX0,      0xA8, 0); //Enable External 0
   SBIT(ET0,      0xA8, 1); //Enable Timer 0
   SBIT(EX1,      0xA8, 2); //Enable External 1
   SBIT(ET1,      0xA8, 3); //Enable Timer 1
   SBIT(ES,       0xA8, 4); //Enable Serial
   SBIT(EADC_SPI, 0xA8, 5); //Enable Analog to Digital Converter Serial Peripheral Interface
   SBIT(EPCA_LVD, 0xA8, 6); //Enable Programmable Counter Array Low Voltage Detect
   SBIT(EA,       0xA8, 7); //Enable All
SFR(SADDR, 0xA9);
SFR(P3, 0xB0);
   SBIT(RXD,  0xB0, 0); //Receive Data
   SBIT(TXD,  0xB0, 1); //Transmit Data
   SBIT(INT0, 0xB0, 2); //Interrupt 0
   SBIT(INT1, 0xB0, 3); //Interrupt 1
   SBIT(T0,   0xB0, 4); //Timer 0
   SBIT(ECI,  0xB0, 4); //External Clock In
   SBIT(T1,   0xB0, 5); //Timer 1
   SBIT(PCA1, 0xB0, 5); //Programmable Counter Array 1
   SBIT(PWM1, 0xB0, 5); //Pulse Width Modulator 1
   SBIT(PCA0, 0xB0, 7); //Programmable Counter Array 0
   SBIT(PWM0, 0xB0, 7); //Pulse Width Modulator 0
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
SFR(P3M0, 0xB1);
SFR(P3M1, 0xB2);
SFR(IPH, 0xB7);
SFR(IP, 0xB8);
   SBIT(PX0,      0xB8, 0); //Priority External 0
   SBIT(PT0,      0xB8, 1); //Priority Timer 0
   SBIT(PX1,      0xB8, 2); //Priority External 1
   SBIT(PT1,      0xB8, 3); //Priority Timer 1
   SBIT(PS,       0xB8, 4); //Priority Serial
   SBIT(PADC_SPI, 0xB8, 5); //Priority Analog to Digital Converter Serial Peripheral Interface
   SBIT(PPCA_LVD, 0xB8, 6); //Priority Programmable Counter Array Low Voltage Detect
SFR(SADEN, 0xB9);
SFR(ADC_LOW2, 0xBE);
SFR(ADC_CONTR, 0xC5);
SFR(ADC_DATA, 0xC6);
SFR(CLK_DIV, 0xC7);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(CCON, 0xD8);
   SBIT(CCF0, 0xD8, 0);
   SBIT(CCF1, 0xD8, 1);
   SBIT(CCF2, 0xD8, 2);
   SBIT(CCF3, 0xD8, 3);
   SBIT(CR,   0xD8, 6);
   SBIT(CF,   0xD8, 7);
SFR(CMOD, 0xD9);
SFR(CCAPM0, 0xDA);
SFR(CCAPM1, 0xDB);
SFR(CCAPM2, 0xDC);
SFR(CCAPM3, 0xDD);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(WDT_CONTR, 0xE1);
SFR(ISP_DATA, 0xE2);
SFR(ISP_ADDRH, 0xE3);
SFR(ISP_ADDRL, 0xE4);
SFR(ISP_CMD, 0xE5);
SFR(ISP_TRIG, 0xE6);
SFR(ISP_CONTR, 0xE7);
SFR(CL, 0xE9);
SFR(CCAP0L, 0xEA);
SFR(CCAP1L, 0xEB);
SFR(CCAP2L, 0xEC);
SFR(CCAP3L, 0xED);
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(PCA_PWM0, 0xF2);
SFR(PCA_PWM1, 0xF3);
SFR(PCA_PWM2, 0xF4);
SFR(PCA_PWM3, 0xF5);
SFR(CH, 0xF9);
SFR(CCAP0H, 0xFA);
SFR(CCAP1H, 0xFB);
SFR(CCAP2H, 0xFC);
SFR(CCAP3H, 0xFD);

//Interrupt_Address = ( Interrupt_Number * 8 ) + 3
//Vectors are named after their corresponding IE, IP or IR register bit so
//that we don't have to invent names and can be more consistent across MCUs.
   #define X0_VECTOR      0  // 0x03  External Interrupt 0
   #define T0_VECTOR      1  // 0x0B  Timer 0
   #define X1_VECTOR      2  // 0x13  External Interrupt 1
   #define T1_VECTOR      3  // 0x1B  Timer 1
   #define S_VECTOR       4  // 0x23  Serial Port 1
   #define ADC_SPI_VECTOR 5  // 0x2B  Analog to Digitak Converter & Serial Peripheral Interface
   #define PCA_LVD_VECTOR 6  // 0x33  Programmable Counter Array and Low Voltage Detect

#endif
