// PIO compatible header file STC8H.h 20210829.
// For use with all STC8Hxx series.

#ifndef STC8H_H
#define STC8H_H
#include <compiler.h>

// SFR Definition               Description

SFR(P0, 0x80);                  //Port 0
// SBIT(ACH0, 0x80, 0); //ADC Channel 8
// SBIT(ACH1, 0x80, 1); //ADC Channel 9
// SBIT(ACH2, 0x80, 2); //ADC Channel 10
// SBIT(ACH3, 0x80, 3); //ADC Channel 11
// SBIT(ACH4, 0x80, 4); //ADC Channel 12
// SBIT(ACH5, 0x80, 5); //ADC Channel 13
// SBIT(ACH6, 0x80, 6); //ADC Channel 14
// SBIT(ADC0, 0x80, 0); //AtoD Channel 8
// SBIT(ADC1, 0x80, 1); //AtoD Channel 9
// SBIT(ADC2, 0x80, 2); //AtoD Channel 10
// SBIT(ADC3, 0x80, 3); //AtoD Channel 11
// SBIT(ADC4, 0x80, 4); //AtoD Channel 12
// SBIT(ADC5, 0x80, 5); //AtoD Channel 13
// SBIT(ADC6, 0x80, 6); //AtoD Channel 14
// SBIT(AIN0, 0x80, 0); //Analog Input 8
// SBIT(AIN1, 0x80, 1); //Analog Input 9
// SBIT(AIN2, 0x80, 2); //Analog Input 10
// SBIT(AIN3, 0x80, 3); //Analog Input 11
// SBIT(AIN4, 0x80, 4); //Analog Input 12
// SBIT(AIN5, 0x80, 5); //Analog Input 13
// SBIT(AIN6, 0x80, 6); //Analog Input 14
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
// See device specific data sheet for additional pin names.

SFR(SP, 0x81);                  //Stack Pointer

SFR(DPTR, 0x82);               //Date Pointer Word
SFR(DPL, 0x82);                 //Data Pointer Low Byte

SFR(DPH, 0x83);                 //Data Pointer High Byte

SFR(S4CON, 0x84);               //Serial Port 4 Control Register
   #define S4RI  0x01 //Serial Port 4 Receive Interrupt Flag
   #define S4TI  0x02 //Serial Port 4 Transmit Interrupt Flag
   #define S4RB8 0x04 //Serial Port 4 Receive Bit 8 Data
   #define S4TB8 0x08 //Serial Port 4 Transmit Bit 8 Data
   #define S4REN 0x10 //Serial Port 4 Receive Enable
   #define S4SM2 0x20 //Serial Port 4 Select Mode Bit 2
   #define S4ST4 0x40 //Serial Port 4 Select Timer 4
   #define S4SM0 0x80 //Serial Port 4 Select Mode Bit 0

SFR(S4BUF, 0x85);               //Serial Port 4 Data Register

SFR(PCON, 0x87);                //Power Control Register
   #define IDL   0x01 //Idle Mode Control
   #define PD    0x02 //Power Down Mode Control
   #define GF0   0x04 //User Defined Gereral Purpose Flag 0
   #define GF1   0x08 //User Defined General Purpose Flag 1
   #define POF   0x10 //Power On Flag
   #define LVDF  0x20 //Low Voltage Detect Flag
   #define SMOD0 0x40 //Frame Error Detection Control
   #define SMOD  0x80 //Double Baudrate of Serial Port 1

SFR(TCON, 0x88);                //Timer Control
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag

SFR(TMOD, 0x89);                //Timer Mode
   #define T0_M0   0x01 //Timer 0 Mode 0
   #define T0_M1   0x02 //Timer 0 Mode 1
   #define T0_M    0x03 //Timer 0 Mode
   #define T0_CT   0x04 //Timer 0 Counter Timer
   #define T0_GATE 0x08 //Timer 0 Gate
   #define T1_M0   0x10 //Timer 1 Mode 0
   #define T1_M1   0x20 //Timer 1 Mode 1
   #define T1_M    0x30 //Timer 1 Mode
   #define T1_CT   0x40 //Timer 1 Counter Timer
   #define T1_GATE 0x80 //Timer 1 Gate
   #define M00   0x01 //Mode 0 Timer 0
   #define M10   0x02 //Mode 1 Timer 0
   #define M0    0x03 //Timer 0 Mode
   #define CT0   0x04 //Counter Timer 0
   #define GATE0 0x08 //Gate 0
   #define M01   0x10 //Mode 1 Timer 1
   #define M11   0x20 //Mode 1 Timer 1
   #define M1    0x30 //Timer 1 Mode
   #define CT1   0x40 //Counter Timer 1
   #define GATE1 0x80 //Gate 1

SFR(TL0, 0x8A);                 //T0 Low Byte

SFR(TL1, 0x8B);                 //T1 Low Byte

SFR(TH0, 0x8C);                 //T0 High Byte

SFR(TH1, 0x8D);                 //T1 High Byte

SFR(AUXR, 0x8E);                //Auxiliary Register
   #define S1ST2     0x01 //Serial Port 1 Baud Rate Generator Select
   #define EXTRAM    0x02 //Extended RAM Access Control
   #define T2x12     0x04 //Timer 2 Clock x12 Prescaler Bypass
   #define T2_CT     0x08 //Timer 2 Counter or Timer Mode Select
   #define T2R       0x10 //Timer 2 Run Control
   #define UART_M0x6 0x20 //UART 1 Mode 0 Baudrate Prescaler Select
   #define T1x12     0x40 //Timer 1 Clock x12 Prescaler Bypass
   #define T0x12     0x80 //Timer 0 Clock x12 Prescaler Bypass

SFR(INTCLKO, 0x8F);             //Interrupt and Clock Output Control Register
   #define T0CLKO 0x01 //Timer 0 Clock Output Control
   #define T1CLKO 0x02 //Timer 1 Clock Output Control
   #define T2CLKO 0x04 //Timer 2 Clock Output Control
   #define EX2    0x10 //External Interrupt 3 Enable
   #define EX3    0x20 //External Interrupt 2 Enable
   #define EX4    0x40 //External Interrupt 4 Enable

SFR(P1, 0x90);                  //Port 1
   SBIT(ACH0, 0x90, 0); //ADC Channel 0
   SBIT(ACH1, 0x90, 1); //ADC Channel 1
   SBIT(ACH2, 0x90, 2); //ADC Channel 2
   SBIT(ACH3, 0x90, 3); //ADC Channel 3
   SBIT(ACH4, 0x90, 4); //ADC Channel 4
   SBIT(ACH5, 0x90, 5); //ADC Channel 5
   SBIT(ACH6, 0x90, 6); //ADC Channel 6
   SBIT(ACH7, 0x90, 7); //ADC Channel 7
   SBIT(ADC0, 0x90, 0); //AtoD Channel 0
   SBIT(ADC1, 0x90, 1); //AtoD Channel 1
   SBIT(ADC2, 0x90, 2); //AtoD Channel 2
   SBIT(ADC3, 0x90, 3); //AtoD Channel 3
   SBIT(ADC4, 0x90, 4); //AtoD Channel 4
   SBIT(ADC5, 0x90, 5); //AtoD Channel 5
   SBIT(ADC6, 0x90, 6); //AtoD Channel 6
   SBIT(ADC7, 0x90, 7); //AtoD Channel 7
   SBIT(AIN0, 0x90, 0); //Analog Input 0
   SBIT(AIN1, 0x90, 1); //Analog Input 1
   SBIT(AIN2, 0x90, 2); //Analog Input 2
   SBIT(AIN3, 0x90, 3); //Analog Input 3
   SBIT(AIN4, 0x90, 4); //Analog Input 4
   SBIT(AIN5, 0x90, 5); //Analog Input 5
   SBIT(AIN6, 0x90, 6); //Analog Input 6
   SBIT(AIN7, 0x90, 7); //Analog Input 7
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
// See device specific data sheet for additional pin names.

SFR(P1M1, 0x91);                //Port 1 Mode Register 1
   #define P10M1 0x01 //Port 1 bit 0 Mode 1
   #define P11M1 0x02 //Port 1 bit 1 Mode 1
   #define P12M1 0x04 //Port 1 bit 2 Mode 1
   #define P13M1 0x08 //Port 1 bit 3 Mode 1
   #define P14M1 0x10 //Port 1 bit 4 Mode 1
   #define P15M1 0x20 //Port 1 bit 5 Mode 1
   #define P16M1 0x40 //Port 1 bit 6 Mode 1
   #define P17M1 0x80 //Port 1 bit 7 Mode 1

SFR(P1M0, 0x92);                //Port 1 Mode Register 0
   #define P10M0 0x01 //Port 1 bit 0 Mode 0
   #define P11M0 0x02 //Port 1 bit 1 Mode 0
   #define P12M0 0x04 //Port 1 bit 2 Mode 0
   #define P13M0 0x08 //Port 1 bit 3 Mode 0
   #define P14M0 0x10 //Port 1 bit 4 Mode 0
   #define P15M0 0x20 //Port 1 bit 5 Mode 0
   #define P16M0 0x40 //Port 1 bit 6 Mode 0
   #define P17M0 0x80 //Port 1 bit 7 Mode 0

SFR(P0M1, 0x93);                //Port 0 Mode Register 1
   #define P00M1 0x01 //Port 0 bit 0 Mode 1
   #define P01M1 0x02 //Port 0 bit 1 Mode 1
   #define P02M1 0x04 //Port 0 bit 2 Mode 1
   #define P03M1 0x08 //Port 0 bit 3 Mode 1
   #define P04M1 0x10 //Port 0 bit 4 Mode 1
   #define P05M1 0x20 //Port 0 bit 5 Mode 1
   #define P06M1 0x40 //Port 0 bit 6 Mode 1
   #define P07M1 0x80 //Port 0 bit 7 Mode 1

SFR(P0M0, 0x94);                //Port 0 Mode Register 0
   #define P00M0 0x01 //Port 0 bit 0 Mode 0
   #define P01M0 0x02 //Port 0 bit 1 Mode 0
   #define P02M0 0x04 //Port 0 bit 2 Mode 0
   #define P03M0 0x08 //Port 0 bit 3 Mode 0
   #define P04M0 0x10 //Port 0 bit 4 Mode 0
   #define P05M0 0x20 //Port 0 bit 5 Mode 0
   #define P06M0 0x40 //Port 0 bit 6 Mode 0
   #define P07M0 0x80 //Port 0 bit 7 Mode 0

SFR(P2M1, 0x95);                //Port 2 Mode Register 1
   #define P20M1 0x01 //Port 2 bit 0 Mode 1
   #define P21M1 0x02 //Port 2 bit 1 Mode 1
   #define P22M1 0x04 //Port 2 bit 2 Mode 1
   #define P23M1 0x08 //Port 2 bit 3 Mode 1
   #define P24M1 0x10 //Port 2 bit 4 Mode 1
   #define P25M1 0x20 //Port 2 bit 5 Mode 1
   #define P26M1 0x40 //Port 2 bit 6 Mode 1
   #define P27M1 0x80 //Port 2 bit 7 Mode 1

SFR(P2M0, 0x96);                //Port 2 Mode Register 0
   #define P20M0 0x01 //Port 2 bit 0 Mode 0
   #define P21M0 0x02 //Port 2 bit 1 Mode 0
   #define P22M0 0x04 //Port 2 bit 2 Mode 0
   #define P23M0 0x08 //Port 2 bit 3 Mode 0
   #define P24M0 0x10 //Port 2 bit 4 Mode 0
   #define P25M0 0x20 //Port 2 bit 5 Mode 0
   #define P26M0 0x40 //Port 2 bit 6 Mode 0
   #define P27M0 0x80 //Port 2 bit 7 Mode 0

SFR(SCON, 0x98);                //Serial Control
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error

SFR(SBUF, 0x99);                //Serial Port 1 Data Register

SFR(S2CON, 0x9A);               //Serial Port 2 Control Register
   #define S2RI  0x01 //Serial Port 2 Receive Interrupt Flag
   #define S2TI  0x02 //Serial Port 2 Transmit Interrupt Flag
   #define S2RB8 0x04 //Serial Port 2 Receive Bit 8 Data
   #define S2TB8 0x08 //Serial Port 2 Transmit Bit 8 Data
   #define S2REN 0x10 //Serial Port 2 Receive Enable
   #define S2SM2 0x20 //Serial Port 2 Select Mode Bit 2
   #define S2SM0 0x80 //Serial Port 2 Select Mode Bit 0

SFR(S2BUF, 0x9B);               //Serial Port 2 Data Register

SFR(IRCBAND, 0x9D);             //Internal RC Clock Frequency Band Selection
   #define IRCBSEL 0x01 //Select RC Clock Frequency

SFR(LIRTRIM, 0x9E);             //Internal RC Clock Frequency Trimming Register

SFR(IRTRIM, 0x9F);              //Internal RC Clock Frequency Adjustment Register

SFR(P2, 0xA0);                  //Port 2
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P27, 0xA0, 7); //Port 2 Bit 7
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_7, 0xA0, 7); //Port 2 Bit 7
// See device specific data sheet for additional pin names.

SFR(BUS_SPEED, 0xA1);           //Bus Speed Control Register
   #define BUSSPEED 0x07 //Bus Read-Write Speed Control
   #define RW_S     0xC0 //Read-Write Control Pin Select

SFR(P_SW1, 0xA2);               //Peripheral Port Switching Register 1
   #define SPI_S 0xC0 //Serial Peripheral Interface Pin Select
   #define CCP_S 0x30 //PCA Pin Select
   #define S1_S  0xC0 //Serial Port 1 Pin Select

SFR(IE, 0xA8);                  //Interrupt Enable
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EADC, 0xA8, 5); //Enable ADC
   SBIT(ELVD, 0xA8, 6); //Enable Low Voltage Detect
   SBIT(EA,   0xA8, 7); //Enable All

SFR(SADDR, 0xA9);               //Slave Address Register

SFR(WKTCL, 0xAA);               //Power Down Wakeup Timer Low Byte

SFR(WKTCH, 0xAB);               //Power Down Wakeup Timer High Byte
   #define WKTEN 0x80 //Power Down Wakeup Timer Enable

SFR(S3CON, 0xAC);               //Serial Port 3 Control Register
   #define S3RI  0x01 //Serial Port 3 Receive Interrupt Flag
   #define S3TI  0x02 //Serial Port 3 Transmit Interrupt Flag
   #define S3RB8 0x04 //Serial Port 3 Receive Bit 8 Data
   #define S3TB8 0x08 //Serial Port 3 Transmit Bit 8 Data
   #define S3REN 0x10 //Serial Port 3 Receive Enable
   #define S3SM2 0x20 //Serial Port 3 Select Mode Bit 2
   #define S3ST3 0x40 //Serial Port 3 Select Timer 3
   #define S3SM0 0x80 //Serial Port 3 Select Mode Bit 0

SFR(S3BUF, 0xAD);               //Serial Port 3 Data Register

SFR(TA, 0xAE);                  //Data Pointer Control Register

SFR(IE2, 0xAF);                 //Interrupt Control Register 2
   #define ES2  0x01 //Enable Serial Port 2 Interrupt
   #define ESPI 0x02 //Enable Serial Peripheral Interface Interrupt
   #define ET2  0x04 //Enable Timer 2 Interrupt
   #define ES3  0x08 //Enable Serial Port 3 Interrupt
   #define ES4  0x10 //Enable Serial Port 4 Interrupt
   #define ET3  0x20 //Enable Timer 3 Interrupt
   #define ET4  0x40 //Enable Timer 4 Interrupt
   #define ECAN 0x80 //Enable CAN Interrupt

SFR(P3, 0xB0);                  //Port 3
// SBIT(ACH0, 0xB0, 0); //ADC Channel 8
// SBIT(ACH1, 0xB0, 1); //ADC Channel 9
// SBIT(ACH2, 0xB0, 2); //ADC Channel 10
// SBIT(ACH3, 0xB0, 3); //ADC Channel 11
// SBIT(ACH4, 0xB0, 4); //ADC Channel 12
// SBIT(ACH5, 0xB0, 5); //ADC Channel 13
// SBIT(ACH6, 0xB0, 6); //ADC Channel 14
// SBIT(ADC0, 0xB0, 0); //AtoD Channel 8
// SBIT(ADC1, 0xB0, 1); //AtoD Channel 9
// SBIT(ADC2, 0xB0, 2); //AtoD Channel 10
// SBIT(ADC3, 0xB0, 3); //AtoD Channel 11
// SBIT(ADC4, 0xB0, 4); //AtoD Channel 12
// SBIT(ADC5, 0xB0, 5); //AtoD Channel 13
// SBIT(ADC6, 0xB0, 6); //AtoD Channel 14
// SBIT(AIN0, 0xB0, 0); //Analog Input 8
// SBIT(AIN1, 0xB0, 1); //Analog Input 9
// SBIT(AIN2, 0xB0, 2); //Analog Input 10
// SBIT(AIN3, 0xB0, 3); //Analog Input 11
// SBIT(AIN4, 0xB0, 4); //Analog Input 12
// SBIT(AIN5, 0xB0, 5); //Analog Input 13
// SBIT(AIN6, 0xB0, 6); //Analog Input 14
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
// See device specific data sheet for additional pin names.

SFR(P3M1, 0xB1);                //Port 3 Mode Register 1
   #define P30M1 0x01 //Port 3 bit 0 Mode 1
   #define P31M1 0x02 //Port 3 bit 1 Mode 1
   #define P32M1 0x04 //Port 3 bit 2 Mode 1
   #define P33M1 0x08 //Port 3 bit 3 Mode 1
   #define P34M1 0x10 //Port 3 bit 4 Mode 1
   #define P35M1 0x20 //Port 3 bit 5 Mode 1
   #define P36M1 0x40 //Port 3 bit 6 Mode 1
   #define P37M1 0x80 //Port 3 bit 7 Mode 1

SFR(P3M0, 0xB2);                //Port 3 Mode Register 0
   #define P30M0 0x01 //Port 3 bit 0 Mode 0
   #define P31M0 0x02 //Port 3 bit 1 Mode 0
   #define P32M0 0x04 //Port 3 bit 2 Mode 0
   #define P33M0 0x08 //Port 3 bit 3 Mode 0
   #define P34M0 0x10 //Port 3 bit 4 Mode 0
   #define P35M0 0x20 //Port 3 bit 5 Mode 0
   #define P36M0 0x40 //Port 3 bit 6 Mode 0
   #define P37M0 0x80 //Port 3 bit 7 Mode 0

SFR(P4M1, 0xB3);                //Port 4 Mode Register 1
   #define P40M1 0x01 //Port 4 bit 0 Mode 1
   #define P41M1 0x02 //Port 4 bit 1 Mode 1
   #define P42M1 0x04 //Port 4 bit 2 Mode 1
   #define P43M1 0x08 //Port 4 bit 3 Mode 1
   #define P44M1 0x10 //Port 4 bit 4 Mode 1
   #define P45M1 0x20 //Port 4 bit 5 Mode 1
   #define P46M1 0x40 //Port 4 bit 6 Mode 1
   #define P47M1 0x80 //Port 4 bit 7 Mode 1

SFR(P4M0, 0xB4);                //Port 4 Mode Register 0
   #define P40M0 0x01 //Port 4 bit 0 Mode 0
   #define P41M0 0x02 //Port 4 bit 1 Mode 0
   #define P42M0 0x04 //Port 4 bit 2 Mode 0
   #define P43M0 0x08 //Port 4 bit 3 Mode 0
   #define P44M0 0x10 //Port 4 bit 4 Mode 0
   #define P45M0 0x20 //Port 4 bit 5 Mode 0
   #define P46M0 0x40 //Port 4 bit 6 Mode 0
   #define P47M0 0x80 //Port 4 bit 7 Mode 0

SFR(IP2, 0xB5);                 //Interrupt Priority Register 2
   #define PS2    0x01 //Serial Port 2 Interrupt Priority
   #define PSPI   0x02 //Serial Peripheral Interface Interrupt Priority
   #define PPWM   0x04 //PWM Interrupt Priority
   #define PPWMFD 0x08 //PWM Fault Detect Interrupt Priority
   #define PX4    0x10 //External Interrupt 4 Priority
   #define PCMP   0x20 //Comparator Interrupt Priority
   #define PI2C   0x40 //I2C Interrupt Priority
   #define PCAN   0x80 //CAN Interrupt Priority
   #define PUSB   0x80 //USB Interrupt Priority
   #define PTKSU  0x80 //Touch Sensor Interrupt Priority

SFR(IP2H, 0xB6);                //High Interrupt Priority Register 2
   #define PS2H    0x01 //Serial Port 2 Interrupt Priority High
   #define PSPIH   0x02 //Serial Peripheral Interface Interrupt Priority High
   #define PPWMH   0x04 //PWM Interrupt Priority High
   #define PPWMFDH 0x08 //PWM Fault Detect Interrupt Priority High
   #define PX4H    0x10 //External Interrupt 4 Priority High
   #define PCMPH   0x20 //Comparator Interrupt Priority High
   #define PI2CH   0x40 //I2C Interrupt Priority High
   #define PCANH   0x80 //CAN Interrupt Priority High
   #define PUSBH   0x80 //USB Interrupt Priority High
   #define PTKSUH  0x80 //Touch Sensor Interrupt Priority High

SFR(IPH, 0xB7);                 //High Interrupt Priority Register
   #define PX0H  0x01 //External Interrupt 0 Priority High
   #define PT0H  0x02 //Timer 0 Interrupt Priority High
   #define PX1H  0x04 //External Interrupt 1 Priority High
   #define PT1H  0x08 //Timer 1 Interrupt Priority High
   #define PSH   0x10 //Serial Port 1 Interrupt Priority High
   #define PADCH 0x20 //ADC Interrupt Priority High
   #define PLVDH 0x40 //Low Voltage Detect Interrupt Priority High
   #define PPCAH 0x80 //CCP-PCA Interrupt Priority High

SFR(IP, 0xB8);                  //Interrupt Priority
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PADC, 0xB8, 5); //Priority ADC
   SBIT(PLVD, 0xB8, 6); //Priority Low Voltage Detect
   SBIT(PPCA, 0xB8, 7); //Priority CCP-PCA

SFR(SADEN, 0xB9);               //Slave Address Mask Register

SFR(P_SW2, 0xBA);               //Peripheral Port Switching Register 2
   #define S2_S   0x10 //Serial Port 2 Pin Select
   #define S3_S   0x20 //Serial Port 3 Pin Select
   #define S4_S   0x40 //Serial Port 4 Pin Select
   #define CMPO_S 0x80 //Comparator Output Pin Select
   #define I2C_S  0x30 //I2C Pin Select
   #define CAN_S  0x40 //CAN Pin Select
   #define EAXFR  0x80 //Extended RAM Area Transfer Enable

SFR(ADC_CONTR, 0xBC);           //Analog to Digital Converter Control Register
   #define ADC_CHS   0x0F //ADC Analog Channel Select
   #define ADC_EPWMT 0x10 //ADC Enable PWM Trigger
   #define ADC_FLAG  0x20 //ADC Conversion Complete Flag
   #define ADC_START 0x40 //ADC Start Command
   #define ADC_POWER 0x80 //ADC Power Control

SFR(ADC_RES, 0xBD);             //Analog to Digital Converter Result High 8 Bits

SFR(ADC_RESL, 0xBE);            //Analog to Digital Converter Result Low 2 Bits

SFR(P4, 0xC0);                  //Port 4
   SBIT(P40, 0xC0, 0); //Port 4 Bit 0
   SBIT(P41, 0xC0, 1); //Port 4 Bit 1
   SBIT(P42, 0xC0, 2); //Port 4 Bit 2
   SBIT(P43, 0xC0, 3); //Port 4 Bit 3
   SBIT(P44, 0xC0, 4); //Port 4 Bit 4
   SBIT(P45, 0xC0, 5); //Port 4 Bit 5
   SBIT(P46, 0xC0, 6); //Port 4 Bit 6
   SBIT(P47, 0xC0, 7); //Port 4 Bit 7
   SBIT(P4_0, 0xC0, 0); //Port 4 Bit 0
   SBIT(P4_1, 0xC0, 1); //Port 4 Bit 1
   SBIT(P4_2, 0xC0, 2); //Port 4 Bit 2
   SBIT(P4_3, 0xC0, 3); //Port 4 Bit 3
   SBIT(P4_4, 0xC0, 4); //Port 4 Bit 4
   SBIT(P4_5, 0xC0, 5); //Port 4 Bit 5
   SBIT(P4_6, 0xC0, 6); //Port 4 Bit 6
   SBIT(P4_7, 0xC0, 7); //Port 4 Bit 7
// See device specific data sheet for additional pin names.

SFR(WDT_CONTR, 0xC1);           //Watchdog Control Register
   #define WDTPS0   0x01 //Watchdog Timer Prescaler 0
   #define WDTPS1   0x02 //Watchdog Timer Prescaler 1
   #define WDTPS2   0x04 //Watchdog Timer Prescaler 2
   #define WDT_PS   0x07 //Watchdog Timer Prescaler
   #define IDL_WDT  0x08 //Watchdog Timer Idle Mode Behavior
   #define CLR_WDT  0x10 //Clear Watchdog Timer
   #define EN_WDT   0x20 //Enable Watchdog Timer
   #define WDT_FLAG 0x80 //Watchdog Timer Overflow Flag

SFR(IAP_DATA, 0xC2);            //In Application Programming Data
SFR(ISP_DATA, 0xC2);            //In System Programming Data

SFR(IAP_ADDRH, 0xC3);           //In Application Programming Address High
SFR(ISP_ADDRH, 0xC3);           //In System Programming Address High

SFR(IAP_ADDRL, 0xC4);           //In Application Programming Address Low
SFR(ISP_ADDRL, 0xC4);           //In System Programming Address Low

SFR(IAP_CMD, 0xC5);             //In Application Programming Command
SFR(ISP_CMD, 0xC5);             //In System Programming Command
   #define MS0    0x01 //Mode Select 0
   #define MS1    0x02 //Mode Select 1
   #define IAPCMD 0x03 //In Application Programming Command
// Valid commands follow
#define IAP_IDL   0x00
#define IAP_READ  0x01
#define IAP_WRITE 0x02
#define IAP_ERASE 0x03
// End of valid commands

SFR(IAP_TRIG, 0xC6);            //In Application Programming Trigger
SFR(ISP_TRIG, 0xC6);            //In System Programming Trigger

SFR(IAP_CONTR, 0xC7);           //In Application Programming Control
SFR(ISP_CONTR, 0xC7);           //In System Programming Control
   #define WT0      0x01 //Wait 0
   #define WT1      0x02 //Wait 1
   #define WT2      0x04 //Wait 2
   #define IAP_WT   0x07 //In Application Programming Wait
   #define CMD_FAIL 0x10 //Command Fail
   #define SWRST    0x20 //Software Reset Trigger
   #define SWBS     0x40 //Software Boot Selection
   #define IAPEN    0x80 //In Application Programming Enable

SFR(P5, 0xC8);                  //Port 5
   SBIT(P50, 0xC8, 0); //Port 5 Bit 0
   SBIT(P51, 0xC8, 1); //Port 5 Bit 1
   SBIT(P52, 0xC8, 2); //Port 5 Bit 2
   SBIT(P53, 0xC8, 3); //Port 5 Bit 3
   SBIT(P54, 0xC8, 4); //Port 5 Bit 4
   SBIT(P55, 0xC8, 5); //Port 5 Bit 5
   SBIT(P5_0, 0xC8, 0); //Port 5 Bit 0
   SBIT(P5_1, 0xC8, 1); //Port 5 Bit 1
   SBIT(P5_2, 0xC8, 2); //Port 5 Bit 2
   SBIT(P5_3, 0xC8, 3); //Port 5 Bit 3
   SBIT(P5_4, 0xC8, 4); //Port 5 Bit 4
   SBIT(P5_5, 0xC8, 5); //Port 5 Bit 5
// See device specific data sheet for additional pin names.

SFR(P5M1, 0xC9);                //Port 5 Mode Register 1
   #define P50M1 0x01 //Port 5 bit 0 Mode 1
   #define P51M1 0x02 //Port 5 bit 1 Mode 1
   #define P52M1 0x04 //Port 5 bit 2 Mode 1
   #define P53M1 0x08 //Port 5 bit 3 Mode 1
   #define P54M1 0x10 //Port 5 bit 4 Mode 1
   #define P55M1 0x20 //Port 5 bit 5 Mode 1

SFR(P5M0, 0xCA);                //Port 5 Mode Register 0
   #define P50M0 0x01 //Port 5 bit 0 Mode 0
   #define P51M0 0x02 //Port 5 bit 1 Mode 0
   #define P52M0 0x04 //Port 5 bit 2 Mode 0
   #define P53M0 0x08 //Port 5 bit 3 Mode 0
   #define P54M0 0x10 //Port 5 bit 4 Mode 0
   #define P55M0 0x20 //Port 5 bit 5 Mode 0

SFR(P6M1, 0xCB);                //Port 6 Mode Register 1
   #define P60M1 0x01 //Port 6 bit 0 Mode 1
   #define P61M1 0x02 //Port 6 bit 1 Mode 1
   #define P62M1 0x04 //Port 6 bit 2 Mode 1
   #define P63M1 0x08 //Port 6 bit 3 Mode 1
   #define P64M1 0x10 //Port 6 bit 4 Mode 1
   #define P65M1 0x20 //Port 6 bit 5 Mode 1
   #define P66M1 0x40 //Port 6 bit 6 Mode 1
   #define P67M1 0x80 //Port 6 bit 7 Mode 1

SFR(P6M0, 0xCC);                //Port 6 Mode Register 0
   #define P60M0 0x01 //Port 6 bit 0 Mode 0
   #define P61M0 0x02 //Port 6 bit 1 Mode 0
   #define P62M0 0x04 //Port 6 bit 2 Mode 0
   #define P63M0 0x08 //Port 6 bit 3 Mode 0
   #define P64M0 0x10 //Port 6 bit 4 Mode 0
   #define P65M0 0x20 //Port 6 bit 5 Mode 0
   #define P66M0 0x40 //Port 6 bit 6 Mode 0
   #define P67M0 0x80 //Port 6 bit 7 Mode 0

SFR(SPSTAT, 0xCD);              //Serial Peripheral Status Register
   #define WCOL 0x40 //Write Collision
   #define SPIF 0x80 //Serial Peripheral Interface Flag

SFR(SPCTL, 0xCE);               //Serial Peripheral Control Register
   #define SPR0 0x00 //Serial Peripheral Rate 0
   #define SPR1 0x01 //Serial Peripheral Rate 1
   #define SPR  0x03 //Serial Peripheral Rate
   #define CPHA 0x04 //Clock Phase
   #define CPOL 0x08 //Clock Polarity
   #define MSTR 0x10 //Master
   #define DORD 0x20 //Data Order
   #define SPEN 0x40 //Serial Peripheral Enable
   #define SSIG 0x80 //Slave Select Signal

SFR(SPDAT, 0xCF);               //Serial Peripheral Data

SFR(PSW, 0xD0);                 //Program status word
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry

SFR(T4T3M, 0xD1);               //T4 and T3 Mode Register
   #define T3CLKO 0x01 //Timer 3 Clock Output Control
   #define T3x12  0x02 //Timer 3 Clock x12 Prescaler Bypass
   #define T3_CT  0x04 //Timer 3 Counter or Timer Mode Select
   #define T3R    0x08 //Timer 3 Run Control
   #define T4CLKO 0x10 //Timer 4 Clock Output Control
   #define T4x12  0x20 //Timer 4 Clock x12 Prescaler Bypass
   #define T4_CT  0x40 //Timer 4 Counter or Timer Mode Select
   #define T4R    0x80 //Timer 4 Run Control

SFR(T4H, 0xD2);                 //T4 High Byte
SFR(TH4, 0xD2);

SFR(T4L, 0xD3);                 //T4 Low Byte
SFR(TL4, 0xD3);

SFR(T3H, 0xD4);                 //T3 High Byte
SFR(TH3, 0xD4);

SFR(T3L, 0xD5);                 //T3 Low Byte
SFR(TL3, 0xD5);

SFR(T2H, 0xD6);                 //T2 High Byte
SFR(TH2, 0xD6);

SFR(T2L, 0xD7);                 //T2 Low Byte
SFR(TL2, 0xD7);

SFR(USBCLK, 0xDC);              //USB Clock Control Register
   #define PHYTST  0x03 //PHY Test Mode
   #define TST_PHY 0x04 //Test PHY Enable
   #define TST_USB 0x08 //Test USB Enable
   #define CRE     0x10 //Clock Recovery Enable
   #define PCKI    0x60 //PLL Clock Selection
   #define ENCKM   0x80 //Enable Clock Multiplier

SFR(ADCCFG, 0xDE);              //ADC Configuration Register
   #define ADCSPEED  0x0F //Clock Speed Control
   #define RESFMT    0x20 //Result Format Control

SFR(IP3, 0xDF);                 //Interrupt Priority Register 3
   #define PS3  0x01 //Serial Port 3 Interrupt Priority
   #define PS4  0x02 //Serial Port 4 Interrupt Priority
   #define PRTC 0x04 //RTC Interrupt Priority Control

SFR(ACC, 0xE0);                 //Accumulator
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7

SFR(P7M1, 0xE1);                //Port 7 Mode Register 1
   #define P70M1 0x01 //Port 7 bit 0 Mode 1
   #define P71M1 0x02 //Port 7 bit 1 Mode 1
   #define P72M1 0x04 //Port 7 bit 2 Mode 1
   #define P73M1 0x08 //Port 7 bit 3 Mode 1
   #define P74M1 0x10 //Port 7 bit 4 Mode 1
   #define P75M1 0x20 //Port 7 bit 5 Mode 1
   #define P76M1 0x40 //Port 7 bit 6 Mode 1
   #define P77M1 0x80 //Port 7 bit 7 Mode 1

SFR(P7M0, 0xE2);                //Port 7 Mode Register 0
   #define P70M0 0x01 //Port 7 bit 0 Mode 0
   #define P71M0 0x02 //Port 7 bit 1 Mode 0
   #define P72M0 0x04 //Port 7 bit 2 Mode 0
   #define P73M0 0x08 //Port 7 bit 3 Mode 0
   #define P74M0 0x10 //Port 7 bit 4 Mode 0
   #define P75M0 0x20 //Port 7 bit 5 Mode 0
   #define P76M0 0x40 //Port 7 bit 6 Mode 0
   #define P77M0 0x80 //Port 7 bit 7 Mode 0

SFR(DPS, 0xE3);                 //DPTR Pointer Selector
   #define SEL 0x01 //Data Pointer Select
   #define AU0 0x08 //Auto Increment-Decrement Data Pointer 0
   #define AU1 0x10 //Auto Increment-Decrement Data Pointer 1
   #define TSL 0x20 //Auto Toggle Data Pointer Select
   #define ID0 0x40 //Increment or Decrement Data Pointer 0
   #define ID1 0x80 //Increment or Decrement Data Pointer 1

SFR(DPL1, 0xE4);                //Second Data Pointer Low Byte
SFR(DPTR1, 0xE4);               //Second Data Pointer Word

SFR(DPH1, 0xE5);                //Second Data Pointer High Byte

SFR(CMPCR1, 0xE6);              //Comparator Control Register 1
   #define CMPRES 0x01 //Comparator Result
   #define CMPOE  0x02 //Comparator Output Enable
   #define NIS    0x04 //Negative Input Source Selection
   #define PIS    0x08 //Positive Input Source Selection
   #define NIE    0x10 //Falling Edge Interrupt Enable
   #define PIE    0x20 //Rising Edge Interrupt Enable
   #define CMPIF  0x40 //Comparator Interrupt Flag
   #define CMPEN  0x80 //Comparator Enable

SFR(CMPCR2, 0xE7);              //Comparator Control Register 2
   #define LCDTY   0x3F //Digital Filter Control
   #define DISFLT  0x40 //Analog Filter Control
   #define INVCMPO 0x80 //Comparator Output Control

SFR(P6, 0xE8);                  //Port 6
   SBIT(P60, 0xE8, 0); //Port 6 Bit 0
   SBIT(P61, 0xE8, 1); //Port 6 Bit 1
   SBIT(P62, 0xE8, 2); //Port 6 Bit 2
   SBIT(P63, 0xE8, 3); //Port 6 Bit 3
   SBIT(P64, 0xE8, 4); //Port 6 Bit 4
   SBIT(P65, 0xE8, 5); //Port 6 Bit 5
   SBIT(P66, 0xE8, 6); //Port 6 Bit 6
   SBIT(P67, 0xE8, 7); //Port 6 Bit 7
   SBIT(P6_0, 0xE8, 0); //Port 6 Bit 0
   SBIT(P6_1, 0xE8, 1); //Port 6 Bit 1
   SBIT(P6_2, 0xE8, 2); //Port 6 Bit 2
   SBIT(P6_3, 0xE8, 3); //Port 6 Bit 3
   SBIT(P6_4, 0xE8, 4); //Port 6 Bit 4
   SBIT(P6_5, 0xE8, 5); //Port 6 Bit 5
   SBIT(P6_6, 0xE8, 6); //Port 6 Bit 6
   SBIT(P6_7, 0xE8, 7); //Port 6 Bit 7
// See device specific data sheet for additional pin names.

SFR(USBDATA, 0xEC);             //USB Data Register
SFR(USBDAT, 0xEC);
   #define UDAT  0xFF //USB Indirect Register Data

SFR(IP3H, 0xEE);                //High Interrupt Priority Register 3
   #define PS3H  0x01 //Serial Port 3 Interrupt Priority
   #define PS4H  0x02 //Serial Port 4 Interrupt Priority
   #define PRTCH 0x04 //RTC Interrupt Priority Control

SFR(AUXINTIF, 0xEF);            //Auxiliary Interrupt Flag Register
   #define T2IF   0x01 //Timer 2 Overflow Interrupt
   #define T3IF   0x02 //Timer 1 Overflow Interrupt
   #define T4IF   0x04 //Timer 0 Overflow Interrupt
   #define INT2IF 0x10 //External Interrupt 2 Request Flag
   #define INT3IF 0x20 //External Interrupt 3 Request Flag
   #define INT4IF 0x40 //External Interrupt 4 Request Flag

SFR(B, 0xF0);                   //B
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7

SFR(USBCON, 0xF4);              //USB Control Register
   #define DM     0x01 //D- Logic Level Indicator
   #define DP     0x02 //D+ Logic Level Indicator
   #define DFREC  0x04 //Differential Receive Status
   #define PDEN   0x08 //Pull Down Resistor Enable
   #define PUEN   0x10 //Pull Up Resistor Enable
   #define PS2M   0x20 //PS2 Mode Enable
   #define ENRST  0x40 //USB Reset Enable
   #define ENUSB  0x80 //Enable USB and Clock

SFR(IAP_TPS, 0xF5);             //IAP Wait Time Control Register
   #define IAPTPS 0x3F //Set Wait Time Per Operating Frequency

SFR(P7, 0xF8);                  //Port 7
   SBIT(P70, 0xF8, 0); //Port 7 Bit 0
   SBIT(P71, 0xF8, 1); //Port 7 Bit 1
   SBIT(P72, 0xF8, 2); //Port 7 Bit 2
   SBIT(P73, 0xF8, 3); //Port 7 Bit 3
   SBIT(P74, 0xF8, 4); //Port 7 Bit 4
   SBIT(P75, 0xF8, 5); //Port 7 Bit 5
   SBIT(P76, 0xF8, 6); //Port 7 Bit 6
   SBIT(P77, 0xF8, 7); //Port 7 Bit 7
   SBIT(P7_0, 0xF8, 0); //Port 7 Bit 0
   SBIT(P7_1, 0xF8, 1); //Port 7 Bit 1
   SBIT(P7_2, 0xF8, 2); //Port 7 Bit 2
   SBIT(P7_3, 0xF8, 3); //Port 7 Bit 3
   SBIT(P7_4, 0xF8, 4); //Port 7 Bit 4
   SBIT(P7_5, 0xF8, 5); //Port 7 Bit 5
   SBIT(P7_6, 0xF8, 6); //Port 7 Bit 6
   SBIT(P7_7, 0xF8, 7); //Port 7 Bit 7
// See device specific data sheet for additional pin names.

SFR(USBADDR, 0xFC);             //USB Address Register
SFR(USBADR, 0xFC);
   #define UADR   0x3F // USB Indirect Register Address
   #define AUTORD 0x04 // USB Register Automatic Read Flag
   #define BUSY   0x08 // USB Register Busy Flag

SFR(RSTCFG, 0xFF);              //Reset Configuration Register
   #define LVDS   0x03 //Low Voltage Detection Threshold
   #define P54RST 0x10 //Port 5 Pin 4 Reset Pin Enable
   #define ENLVR  0x40 //Enable Low Voltage Reset

// The following SB Controller Registers SIE support USB functionality.
// They are accessed indirectly via the USBDATA and USBADDR registers.
#define FADDR 0x00              //Function Address Register
   #define UADDR  0x7F //USB 7 Bit Function Address
   #define UPDATE 0x80 //Function Address Update Flag
#define POWER 0x01              //Power Management Register
   #define ENSUS   0x01 //Enable Suspend Detection
   #define USBSUS  0x02 //USB Suspend Control
   #define USBRSU  0x04 //USB Resume Control
   #define USBRST 0x08 //USB Asynchronous Reset Control
   #define ISOUD   0x80 //ISO Update Control
#define INTRIN1 0x02            //Endpoint In1 Interrupt Flags
   #define EP0IF   0x01 //Endpoint 0 In1-Out1 Interrupt Flag
   #define EP1INIF 0x02 //Endpoint 1 In1 Interrupt Flag
   #define EP2INIF 0x04 //Endpoint 2 In1 Interrupt Flag
   #define EP3INIF 0x08 //Endpoint 3 In1 Interrupt Flag
   #define EP4INIF 0x10 //Endpoint 4 In1 Interrupt Flag
   #define EP5INIF 0x20 //Endpoint 5 In1 Interrupt Flag
#define INTROUT1 0x04           //Endpoint Out1 Interrupt Flags
   #define EP1OUTIF 0x02 //Endpoint 1 Out1 Interrupt Flag
   #define EP2OUTIF 0x04 //Endpoint 2 Out1 Interrupt Flag
   #define EP3OUTIF 0x08 //Endpoint 3 Out1 Interrupt Flag
   #define EP4OUTIF 0x10 //Endpoint 4 Out1 Interrupt Flag
   #define EP5OUTIF 0x20 //Endpoint 5 Out1 Interrupt Flag
#define INTRUSB 0x06            //USB Power Interrupt Flag
   #define SUSIF 0x01 //Suspend Signal Interrupt Flag
   #define RSUIF 0x02 //Recovery Signal Interrupt Flag
   #define RSTIF 0x04 //Reset Signal Interrupt Flag
   #define SOFIF 0x08 //Start Of Frame Interrupt Flag
#define INTRIN1E 0x07           //Endpoint In1 Interrupt Enable
   #define EP0IE   0x01 //Endpoint 0 In1-Out1 Interrupt Enable
   #define EP1INIE 0x02 //Endpoint 1 In1 Interrupt Enable
   #define EP2INIE 0x04 //Endpoint 2 In1 Interrupt Enable
   #define EP3INIE 0x08 //Endpoint 3 In1 Interrupt Enable
   #define EP4INIE 0x10 //Endpoint 4 In1 Interrupt Enable
   #define EP5INIE 0x20 //Endpoint 5 In1 Interrupt Enable
#define INTROUT1E 0x09          //Endpoint Out1 Interrupt Enable
   #define EP1OUTIE 0x02 //Endpoint 1 Out1 Interrupt Enable
   #define EP2OUTIE 0x04 //Endpoint 2 Out1 Interrupt Enable
   #define EP3OUTIE 0x08 //Endpoint 3 Out1 Interrupt Enable
   #define EP4OUTIE 0x10 //Endpoint 4 Out1 Interrupt Enable
   #define EP5OUTIE 0x20 //Endpoint 5 Out1 Interrupt Enable
#define INTRUSBE 0x0B           //USB Power Interrupt Enable
   #define SUSIE 0x01 //Suspend Signal Interrupt Enable
   #define RSUIE 0x02 //Recovery Signal Interrupt Enable
   #define RSTIE 0x04 //Reset Signal Interrupt Enable
   #define SOFIE 0x08 //Start Of Frame Interrupt Enable
#define FRAME1 0x0C             //Data Frame Number Register Low Byte
#define FRAME2 0x0D             //Data Frame Number Register High Bits
#define INDEX 0x0E              //Target Endpoint Index Register
#define INMAXP 0x10             //Maximum In-Endpoint Packet Size
#define CSR0 0x11               //Endpoint 0 Control Status Register
   #define OPRDY  0x01 //OUT Packet Ready
   #define IPRDY  0x02 //IN Packet Ready
   #define STSTLF 0x04 //Sent Stall Signal
   #define DATEND 0x08 //Data End Signal
   #define SUEND  0x10 //Setup End Signal
   #define SDSTL  0x20 //Send Stall Signal
   #define SOPRDY 0x40 //OPRDY Serviced Flag
   #define SSUEND 0x80 //Setup End Event Serviced Flag
#define INCSR1 0x11             //In-Endpoint Control Status Register 1
   #define IPRDYF 0x01 //In Packet Ready Flag
   #define FIFONE 0x02 //In-Endpoint FIFO Not Empty
   #define UNDRUN 0x04 //Data-In Underrun Flag
   #define FLUSH  0x10 //Purge Next Input FIFO Packet
   #define SDSTL  0x20 //Send Stall Signal Trigger
   #define STSTL  0x40 //Stall Signal Sent Completion Flag
   #define CLRDT  0x80 //Clear In-Data Toggle
#define INCSR2 0x12             //In-Endpoint Control Status Register 2
   #define FCDT    0x08 //Force Data0-Data1 Switch Settings
   #define ENDMAI  0x10 //Enable In-Endpoint DMA
   #define MODE    0x20 //Mode (Endpoint Direction) Setting
   #define ISO     0x40 //Synchronous Transmission Enable
   #define AUTOSET 0x80 //Automatically Set IPRDY Flag
#define OUTMAXP 0x13            //Maximum Out-Endpoint Packet Size
#define OUTCSR1 0x14            //Out-Endpoint Control Status Register 1
   #define OPRDY   0x01 //Out Packet Ready Flag
   #define FIFOFUL 0x02 //Out-Endpoint FIFO is Full
   #define OVRRUN  0x04 //Data-Out Overrun Flag
   #define DATERR  0x08 //Data Error Detected Flag
   #define FLUSH   0x10 //Purge Next Output FIFO Packet
   #define SDSTL   0x20 //Send Stall Signal Trigger
   #define STSTL   0x40 //Stall Signal Sent Completion Flag
   #define CLRDT   0x80 //Clear Out-Data Toggle
#define OUTCSR2 0x15            //Out-Endpoint Control Status Register 2
   #define DMAMD   0x10 //DMA Mode Control
   #define ENDMAO  0x20 //Enable Out-Endpoint DMA
   #define ISO     0x40 //Synchronous Transmission Enable
   #define AUTOCLR 0x80 //Automatically Clears OPRDY Flag
#define COUNT0 0x16             //Endpoint 0 Out Length
   #define OUTCNT0 0x7F //Endpoint 0 Out Byte Count
#define OUTCOUNT1 0x16          //Out Length of Endpoints Low Byte
#define OUTCOUNT2 0x17          //Out Length of Endpoints High Bits
#define FIFO0 0x20              //Endpoint Data FIFO 0
#define FIFO1 0x21              //Endpoint Data FIFO 1
#define FIFO2 0x22              //Endpoint Data FIFO 2
#define FIFO3 0x23              //Endpoint Data FIFO 3
#define FIFO4 0x24              //Endpoint Data FIFO 4
#define FIFO5 0x25              //Endpoint Data FIFO 5
#define UTRKCTL 0x30            //USB Tracking Control
   #define RES   0x07 //Utrack Adjustment Resolution
   #define ENST5 0x08 //Calibration Limit Select
   #define INTV  0x30 //Utrack Update Cycle Time
   #define FTM0  0x40 //Fine Tuning Mode Selection 0
   #define FTM1  0x80 //Fine Tuning Mode Selection 1
#define UTRKSTS 0x31            //USB Track Status Register
   #define UTRK_RDY 0x01 //USB Track Calibrated & Ready
   #define TST_UTRK 0x02 //USB Track Test Mode Control
   #define STS      0x0C //USB Track Status
   #define INTVCNT  0xF0 //Internal Count Status

// The following special function registers are in the extended RAM area.
// You need to set bit7 of P_SW2 EAXFR to 1 to read and write them normally.
#define BMM_M2M_CFG (*(unsigned char volatile xdata *)0xfa00) //Bulk Mem Move Mem 2 Mem Config Register
   #define M2MPTY 0x03 //Mem 2 Mem Data Bus Access Priority
   #define M2MIP  0x0C //Mem 2 Mem Interrupt Priority
   #define RXACO  0x01 //Destination Address Direction
   #define TXACO  0x02 //Source Address Direction
   #define M2MIE  0x80 //Mem 2 Mem Interrupt Enable
#define BMM_M2M_CR (*(unsigned char volatile xdata *)0xfa01) //Bulk Mem Move Mem 2 Mem Control Register
   #define TRIGM2M 0x40 //Trigger Mem 2 Mem DMA Task
   #define ENM2M   0x80 //Enable Mem 2 Mem DMA Function
#define BMM_M2M_STA (*(unsigned char volatile xdata *)0xfa02) //Bulk Mem Move Mem 2 Mem Status Register
   #define M2MIF 0x01 //Mem 2 Mem DMA Interrupt Request Flag
#define BMM_M2M_AMT (*(unsigned char volatile xdata *)0xfa03) //Bulk Mem Move Mem 2 Mem Amount to Move
#define BMM_M2M_DONE (*(unsigned char volatile xdata *)0xfa04) //Bulk Mem Move Mem 2 Mem Done Byte Count
#define BMM_M2M_TXAH (*(unsigned char volatile xdata *)0xfa05) //Bulk Mem Move Mem 2 Mem Read Address High
#define BMM_M2M_TXAL (*(unsigned char volatile xdata *)0xfa06) //Bulk Mem Move Mem 2 Mem Read Address Low
#define BMM_M2M_RXAH (*(unsigned char volatile xdata *)0xfa07) //Bulk Mem Move Mem 2 Mem Write Address High
#define BMM_M2M_RXAL (*(unsigned char volatile xdata *)0xfa08) //Bulk Mem Move Mem 2 Mem Write Address Low
#define BMM_ADC_CFG (*(unsigned char volatile xdata *)0xfa10) //Bulk Mem Move ADC Config Register
   #define ADCPTY 0x03 //ADC Data Bus Access Priority
   #define ADCMIP 0x0C //ADC Interrupt Priority
   #define ADCIE  0x80 //ADC Interrupt Enable
#define BMM_ADC_CR (*(unsigned char volatile xdata *)0xfa11) //Bulk Mem Move ADC Control Register
   #define TRIGADC 0x40 //Trigger ADC DMA Task
   #define ENADC   0x80 //Enable ADC DMA Function
#define BMM_ADC_STA (*(unsigned char volatile xdata *)0xfa12) //Bulk Mem Move ADC Status Register
   #define ADCIF 0x01 //ADC DMA Interrupt Request Flag
#define BMM_ADC_RXAH (*(unsigned char volatile xdata *)0xfa17) //Bulk Mem Move ADC Write Address High
#define BMM_ADC_RXAL (*(unsigned char volatile xdata *)0xfa18) //Bulk Mem Move ADC Write Address Low
#define BMM_ADC_CFG2 (*(unsigned char volatile xdata *)0xfa19) //Bulk Mem Move ADC Config Register 2
#define BMM_ADC_CHSW0 (*(unsigned char volatile xdata *)0xfa1a) //Bulk Mem Move ADC Channel Enable Register 0
   #define CH8  0x01 //
   #define CH9  0x02 //
   #define CH10 0x04 //
   #define CH11 0x08 //
   #define CH12 0x10 //
   #define CH13 0x20 //
   #define CH14 0x40 //
   #define CH15 0x80 //
#define BMM_ADC_CHSW1 (*(unsigned char volatile xdata *)0xfa1b) //Bulk Mem Move ADC Channel Enable Register 0
   #define CH0 0x01 //
   #define CH1 0x02 //
   #define CH2 0x04 //
   #define CH3 0x08 //
   #define CH4 0x10 //
   #define CH5 0x20 //
   #define CH6 0x40 //
   #define CH7 0x80 //
#define BMM_SPI_CFG (*(unsigned char volatile xdata *)0xfa20) //Bulk Mem Move Serial Peripheral Interface Config Register
   #define SPIPTY 0x03 //Serial Peripheral Interface Data Bus Access Priority
   #define SPIIP  0x0C //Serial Peripheral Interface Interrupt Priority
   #define ACT_RX 0x20 //Activate SPI Reception via Bulk Memory Move
   #define ACT_TX 0x40 //Activate SPI Transmission via Bulk Memory Move
   #define SPIIE  0x80 //Serial Peripheral Interface Interrupt Enable
#define BMM_SPI_CR (*(unsigned char volatile xdata *)0xfa21) //Bulk Mem Move Serial Peripheral Interface Control Register
   #define CLRFIFO 0x01 //Clear SPI Recieve FIFO
   #define TRIG_S  0x20 //Trigger SPI DMA Slave Task
   #define TRIG_M  0x40 //Trigger SPI DMA Master Task
   #define ENSPI   0x80 //Enable Serial Peripheral Interface DMA Function
#define BMM_SPI_STA (*(unsigned char volatile xdata *)0xfa22) //Bulk Mem Move Serial Peripheral Interface Status Register
   #define SPIIF  0x01 //Serial Peripheral Interface DMA Interrupt Request Flag
   #define RXLOSS 0x02 //Received Data Lost Flag
   #define TXOVW  0x04 //Transmit Data Overwritten Flag
#define BMM_SPI_AMT (*(unsigned char volatile xdata *)0xfa23) //Bulk Mem Move Serial Peripheral Interface Amount to Move
#define BMM_SPI_DONE (*(unsigned char volatile xdata *)0xfa24) //Bulk Mem Move Serial Peripheral Interface Done Byte Count
#define BMM_SPI_TXAH (*(unsigned char volatile xdata *)0xfa25) //Bulk Mem Move Serial Peripheral Interface Read Address High
#define BMM_SPI_TXAL (*(unsigned char volatile xdata *)0xfa26) //Bulk Mem Move Serial Peripheral Interface Read Address Low
#define BMM_SPI_RXAH (*(unsigned char volatile xdata *)0xfa27) //Bulk Mem Move Serial Peripheral Interface Write Address High
#define BMM_SPI_RXAL (*(unsigned char volatile xdata *)0xfa28) //Bulk Mem Move Serial Peripheral Interface Write Address Low
#define BMM_SPI_CFG2 (*(unsigned char volatile xdata *)0xfa29) //Bulk Mem Move Serial Peripheral Interface Config Register 2
   #define SSS   0x03 //SS Pin Select
   #define WRPSS 0x04 //SS Pin Pulldown After Write
#define BMM_UR1T_CFG (*(unsigned char volatile xdata *)0xfa30) //Bulk Mem Move UR1T Config Register
   #define UR1TPTY 0x03 //UR1T Data Bus Access Priority
   #define UR1TIP  0x0C //UR1T Interrupt Priority
   #define UR1TIE  0x80 //UR1T Interrupt Enable
#define BMM_UR1T_CR (*(unsigned char volatile xdata *)0xfa31) //Bulk Mem Move UR1T Control Register
   #define TRIGUR1T 0x40 //Trigger UR1T DMA Task
   #define ENUR1T   0x80 //Enable UR1T DMA Function
#define BMM_UR1T_STA (*(unsigned char volatile xdata *)0xfa32) //Bulk Mem Move UR1T Status Register
   #define UR1TIF 0x01 //UR1T DMA Interrupt Request Flag
   #define TXOVW  0x04 //Transmit Data Overwritten Flag
#define BMM_UR1T_AMT (*(unsigned char volatile xdata *)0xfa33) //Bulk Mem Move UR1T Amount to Move
#define BMM_UR1T_DONE (*(unsigned char volatile xdata *)0xfa34) //Bulk Mem Move UR1T Done Byte Count
#define BMM_UR1T_TXAH (*(unsigned char volatile xdata *)0xfa35) //Bulk Mem Move UR1T Read Address High
#define BMM_UR1T_TXAL (*(unsigned char volatile xdata *)0xfa36) //Bulk Mem Move UR1T Read Address Low
#define BMM_UR1R_CFG (*(unsigned char volatile xdata *)0xfa38) //Bulk Mem Move UR1R Config Register
   #define UR1RPTY 0x03 //UR1R Data Bus Access Priority
   #define UR1RIP  0x0C //UR1R Interrupt Priority
   #define UR1RIE  0x80 //UR1R Interrupt Enable
#define BMM_UR1R_CR (*(unsigned char volatile xdata *)0xfa39) //Bulk Mem Move UR1R Control Register
   #define CLRFIFO  0x01 //Clear UR1R Receive FIFO
   #define TRIGUR1R 0x20 //Trigger UR1R DMA Task
   #define ENUR1R   0x80 //UR1R Interrupt Enable
#define BMM_UR1R_STA (*(unsigned char volatile xdata *)0xfa3a) //Bulk Mem Move UR1R Status Register
   #define UR1RIF 0x01 //UR1R DMA Interrupt Request Flag
   #define RXLOSS 0x02 //Received Data Lost Flag
#define BMM_UR1R_AMT (*(unsigned char volatile xdata *)0xfa3b) //Bulk Mem Move UR1R Amount to Move
#define BMM_UR1R_DONE (*(unsigned char volatile xdata *)0xfa3c) //Bulk Mem Move UR1R Done Byte Count
#define BMM_UR1R_RXAH (*(unsigned char volatile xdata *)0xfa3d) //Bulk Mem Move UR1R Write Address High
#define BMM_UR1R_RXAL (*(unsigned char volatile xdata *)0xfa3e) //Bulk Mem Move UR1R Write Address Low
#define BMM_UR2T_CFG (*(unsigned char volatile xdata *)0xfa40) //Bulk Mem Move UR2T Config Register
   #define UR2TPTY 0x03 //UR2T Data Bus Access Priority
   #define UR2TIP  0x0C //UR2T Interrupt Priority
   #define UR2TIE  0x80 //UR2T Interrupt Enable
#define BMM_UR2T_CR (*(unsigned char volatile xdata *)0xfa41) //Bulk Mem Move UR2T Control Register
   #define TRIGUR2T 0x40 //Trigger UR2T DMA Task
   #define ENUR2T   0x80 //Enable UR2T DMA Function
#define BMM_UR2T_STA (*(unsigned char volatile xdata *)0xfa42) //Bulk Mem Move UR2T Status Register
   #define UR2TIF 0x01 //UR2T DMA Interrupt Request Flag
   #define TXOVW  0x04 //Transmit Data Overwritten Flag
#define BMM_UR2T_AMT (*(unsigned char volatile xdata *)0xfa43) //Bulk Mem Move UR2T Amount to Move
#define BMM_UR2T_DONE (*(unsigned char volatile xdata *)0xfa44) //Bulk Mem Move UR2T Done Byte Count
#define BMM_UR2T_TXAH (*(unsigned char volatile xdata *)0xfa45) //Bulk Mem Move UR2T Read Address High
#define BMM_UR2T_TXAL (*(unsigned char volatile xdata *)0xfa46) //Bulk Mem Move UR2T Read Address Low
#define BMM_UR2R_CFG (*(unsigned char volatile xdata *)0xfa48) //Bulk Mem Move UR2R Config Register
   #define UR2RPTY 0x03 //UR2R Data Bus Access Priority
   #define UR2RIP  0x0C //UR2R Interrupt Priority
   #define UR2RIE  0x80 //UR2R Interrupt Enable
#define BMM_UR2R_CR (*(unsigned char volatile xdata *)0xfa49) //Bulk Mem Move UR2R Control Register
   #define CLRFIFO  0x01 //Clear UR2R Receive FIFO
   #define TRIGUR2R 0x20 //Trigger UR2R DMA Task
   #define ENUR2R   0x80 //UR2R Interrupt Enable
#define BMM_UR2R_STA (*(unsigned char volatile xdata *)0xfa4a) //Bulk Mem Move UR2R Status Register
   #define UR2RIF 0x01 //UR2R DMA Interrupt Request Flag
   #define RXLOSS 0x02 //Received Data Lost Flag
#define BMM_UR2R_AMT (*(unsigned char volatile xdata *)0xfa4b) //Bulk Mem Move UR2R Amount to Move
#define BMM_UR2R_DONE (*(unsigned char volatile xdata *)0xfa4c) //Bulk Mem Move UR2R Done Byte Count
#define BMM_UR2R_RXAH (*(unsigned char volatile xdata *)0xfa4d) //Bulk Mem Move UR2R Write Address High
#define BMM_UR2R_RXAL (*(unsigned char volatile xdata *)0xfa4e) //Bulk Mem Move UR2R Write Address Low
#define BMM_UR3T_CFG (*(unsigned char volatile xdata *)0xfa50) //Bulk Mem Move UR3T Config Register
   #define UR3TPTY 0x03 //UR3T Data Bus Access Priority
   #define UR3TIP  0x0C //UR3T Interrupt Priority
   #define UR3TIE  0x80 //UR3T Interrupt Enable
#define BMM_UR3T_CR (*(unsigned char volatile xdata *)0xfa51) //Bulk Mem Move UR3T Control Register
   #define TRIGUR3T 0x40 //Trigger UR3T DMA Task
   #define ENUR3T   0x80 //Enable UR3T DMA Function
#define BMM_UR3T_STA (*(unsigned char volatile xdata *)0xfa52) //Bulk Mem Move UR3T Status Register
   #define UR3TIF 0x01 //UR3T DMA Interrupt Request Flag
   #define TXOVW  0x04 //Transmit Data Overwritten Flag
#define BMM_UR3T_AMT (*(unsigned char volatile xdata *)0xfa53) //Bulk Mem Move UR3T Amount to Move
#define BMM_UR3T_DONE (*(unsigned char volatile xdata *)0xfa54) //Bulk Mem Move UR3T Done Byte Count
#define BMM_UR3T_TXAH (*(unsigned char volatile xdata *)0xfa55) //Bulk Mem Move UR3T Read Address High
#define BMM_UR3T_TXAL (*(unsigned char volatile xdata *)0xfa56) //Bulk Mem Move UR3T Read Address Low
#define BMM_UR3R_CFG (*(unsigned char volatile xdata *)0xfa58) //Bulk Mem Move UR3R Config Register
   #define UR3RPTY 0x03 //UR3R Data Bus Access Priority
   #define UR3RIP  0x0C //UR3R Interrupt Priority
   #define UR3RIE  0x80 //UR3R Interrupt Enable
#define BMM_UR3R_CR (*(unsigned char volatile xdata *)0xfa59) //Bulk Mem Move UR3R Control Register
   #define CLRFIFO  0x01 //Clear UR3R Receive FIFO
   #define TRIGUR3R 0x20 //Trigger UR3R DMA Task
   #define ENUR3R   0x80 //UR3R Interrupt Enable
#define BMM_UR3R_STA (*(unsigned char volatile xdata *)0xfa5a) //Bulk Mem Move UR3R Status Register
   #define UR3RIF 0x01 //UR3R DMA Interrupt Request Flag
   #define RXLOSS 0x02 //Received Data Lost Flag
#define BMM_UR3R_AMT (*(unsigned char volatile xdata *)0xfa5b) //Bulk Mem Move UR3R Amount to Move
#define BMM_UR3R_DONE (*(unsigned char volatile xdata *)0xfa5c) //Bulk Mem Move UR3R Done Byte Count
#define BMM_UR3R_RXAH (*(unsigned char volatile xdata *)0xfa5d) //Bulk Mem Move UR3R Write Address High
#define BMM_UR3R_RXAL (*(unsigned char volatile xdata *)0xfa5e) //Bulk Mem Move UR3R Write Address Low
#define BMM_UR4T_CFG (*(unsigned char volatile xdata *)0xfa60) //Bulk Mem Move UR4T Config Register
   #define UR4TPTY 0x03 //UR4T Data Bus Access Priority
   #define UR4TIP  0x0C //UR4T Interrupt Priority
   #define UR4TIE  0x80 //UR4T Interrupt Enable
#define BMM_UR4T_CR (*(unsigned char volatile xdata *)0xfa61) //Bulk Mem Move UR4T Control Register
   #define TRIGUR4T 0x40 //Trigger UR4T DMA Task
   #define ENUR4T   0x80 //Enable UR4T DMA Function
#define BMM_UR4T_STA (*(unsigned char volatile xdata *)0xfa62) //Bulk Mem Move UR4T Status Register
   #define UR4TIF 0x01 //UR4T DMA Interrupt Request Flag
   #define TXOVW  0x04 //Transmit Data Overwritten Flag
#define BMM_UR4T_AMT (*(unsigned char volatile xdata *)0xfa63) //Bulk Mem Move UR4T Amount to Move
#define BMM_UR4T_DONE (*(unsigned char volatile xdata *)0xfa64) //Bulk Mem Move UR4T Done Byte Count
#define BMM_UR4T_TXAH (*(unsigned char volatile xdata *)0xfa65) //Bulk Mem Move UR4T Read Address High
#define BMM_UR4T_TXAL (*(unsigned char volatile xdata *)0xfa66) //Bulk Mem Move UR4T Read Address Low
#define BMM_UR4R_CFG (*(unsigned char volatile xdata *)0xfa68) //Bulk Mem Move UR4R Config Register
   #define UR4RPTY 0x03 //UR4R Data Bus Access Priority
   #define UR4RIP  0x0C //UR4R Interrupt Priority
   #define UR4RIE  0x80 //UR4R Interrupt Enable
#define BMM_UR4R_CR (*(unsigned char volatile xdata *)0xfa69) //Bulk Mem Move UR4R Control Register
   #define CLRFIFO  0x01 //Clear UR4R Receive FIFO
   #define TRIGUR4R 0x20 //Trigger UR4R DMA Task
   #define ENUR4R 0x80 //UR4R Interrupt Enable
#define BMM_UR4R_STA (*(unsigned char volatile xdata *)0xfa6a) //Bulk Mem Move UR4R Status Register
   #define UR4RIF 0x01 //UR4R DMA Interrupt Request Flag
   #define RXLOSS 0x02 //Received Data Lost Flag
#define BMM_UR4R_AMT (*(unsigned char volatile xdata *)0xfa6b) //Bulk Mem Move UR4R Amount to Move
#define BMM_UR4R_DONE (*(unsigned char volatile xdata *)0xfa6c) //Bulk Mem Move UR4R Done Byte Count
#define BMM_UR4R_RXAH (*(unsigned char volatile xdata *)0xfa6d) //Bulk Mem Move UR4R Write Address High
#define BMM_UR4R_RXAL (*(unsigned char volatile xdata *)0xfa6e) //Bulk Mem Move UR4R Write Address Low
#define BMM_LCM_CFG (*(unsigned char volatile xdata *)0xfa70) //Bulk Mem Move LC Module Config Register
   #define LCMPTY 0x03 //LC Module Data Bus Access Priority
   #define LCMIP  0x0C //LC Module Interrupt Priority
   #define ACT_RX_LCM 0x80 //Activate LC Module Reception via Bulk Memory Move
   #define ACT_TX_LCM 0x80 //Activate LC Module Transmission via Bulk Memory Move
   #define LCMIE  0x80 //LC Module Interrupt Enable
#define BMM_LCM_CR (*(unsigned char volatile xdata *)0xfa71) //Bulk Mem Move LC Module Control Register
   #define CLRFIFO 0x01 //Clear LC Module Receive FIFO
   #define TRIGRD  0x08 //Trigger Read Data Mode DMA Task
   #define TRIGRC  0x10 //Trigger Read Command Mode DMA Task
   #define TRIGWD  0x20 //Trigger Write Data Mode DMA Task
   #define TRIGWC  0x40 //Trigger Write Command Mode DMA Task
   #define ENLCM   0x80 //Enable LC Module DMA Function
#define BMM_LCM_STA (*(unsigned char volatile xdata *)0xfa72) //Bulk Mem Move LC Module Status Register
   #define LCMIF    0x01 //LC Module DMA Interrupt Request Flag
   #define LCMTXOVW 0x02 //LCMIFDAT Overwritten Flag
#define BMM_LCM_AMT (*(unsigned char volatile xdata *)0xfa73) //Bulk Mem Move LC Module Amount to Move
#define BMM_LCM_DONE (*(unsigned char volatile xdata *)0xfa74) //Bulk Mem Move LC Module Done Byte Count
#define BMM_LCM_TXAH (*(unsigned char volatile xdata *)0xfa75) //Bulk Mem Move LC Module Read Address High
#define BMM_LCM_TXAL (*(unsigned char volatile xdata *)0xfa76) //Bulk Mem Move LC Module Read Address Low
#define BMM_LCM_RXAH (*(unsigned char volatile xdata *)0xfa77) //Bulk Mem Move LC Module Write Address High
#define BMM_LCM_RXAL (*(unsigned char volatile xdata *)0xfa78) //Bulk Mem Move LC Module Write Address Low
#define COMEN (*(unsigned char volatile xdata *)0xfb00) //LED Common Enable
   #define C0EN 0x01 //
   #define C1EN 0x02 //
   #define C2EN 0x04 //
   #define C3EN 0x08 //
   #define C4EN 0x10 //
   #define C5EN 0x20 //
   #define C6EN 0x40 //
   #define C7EN 0x80 //
#define SEGENL (*(unsigned char volatile xdata *)0xfb01) //Segment Enable Low Byte
   #define S0EN 0x01 //
   #define S1EN 0x02 //
   #define S2EN 0x04 //
   #define S3EN 0x08 //
   #define S4EN 0x10 //
   #define S5EN 0x20 //
   #define S6EN 0x40 //
   #define S7EN 0x80 //
#define SEGENH (*(unsigned char volatile xdata *)0xfb02) //Segment Enable High Byte
   #define S8EN  0x01 //
   #define S9EN  0x02 //
   #define S10EN 0x04 //
   #define S11EN 0x08 //
   #define S12EN 0x10 //
   #define S13EN 0x20 //
   #define S14EN 0x40 //
   #define S15EN 0x80 //
#define LEDCTRL (*(unsigned char volatile xdata *)0xfb03) //LED Control
   #define LEDDUTY 0x07 //LED Duty Cycle Adjustment
   #define LEDMODE 0x30 //LED Driver Mode
   #define LEDON   0x80 //LED Driver Enable
#define LEDCKS (*(unsigned char volatile xdata *)0xfb04) //LED Clock Division
#define COM0_DA_L (*(unsigned char volatile xdata *)0xfb10) //Common Anode阳 Display Data 0
#define COM1_DA_L (*(unsigned char volatile xdata *)0xfb11) //Common Anode阳 Display Data 1
#define COM2_DA_L (*(unsigned char volatile xdata *)0xfb12) //Common Anode阳 Display Data 2
#define COM3_DA_L (*(unsigned char volatile xdata *)0xfb13) //Common Anode阳 Display Data 3
#define COM4_DA_L (*(unsigned char volatile xdata *)0xfb14) //Common Anode阳 Display Data 4
#define COM5_DA_L (*(unsigned char volatile xdata *)0xfb15) //Common Anode阳 Display Data 5
#define COM6_DA_L (*(unsigned char volatile xdata *)0xfb16) //Common Anode阳 Display Data 6
#define COM7_DA_L (*(unsigned char volatile xdata *)0xfb17) //Common Anode阳 Display Data 7
#define COM0_DA_H (*(unsigned char volatile xdata *)0xfb18) //Common Anode阳 Display Data 8
#define COM1_DA_H (*(unsigned char volatile xdata *)0xfb19) //Common Anode阳 Display Data 9
#define COM2_DA_H (*(unsigned char volatile xdata *)0xfb1a) //Common Anode阳 Display Data 10
#define COM3_DA_H (*(unsigned char volatile xdata *)0xfb1b) //Common Anode阳 Display Data 11
#define COM4_DA_H (*(unsigned char volatile xdata *)0xfb1c) //Common Anode阳 Display Data 12
#define COM5_DA_H (*(unsigned char volatile xdata *)0xfb1d) //Common Anode阳 Display Data 13
#define COM6_DA_H (*(unsigned char volatile xdata *)0xfb1e) //Common Anode阳 Display Data 14
#define COM7_DA_H (*(unsigned char volatile xdata *)0xfb1f) //Common Anode阳 Display Data 15
#define COM0_DC_L (*(unsigned char volatile xdata *)0xfb20) //Common Cathode阴 Display Data 0
#define COM1_DC_L (*(unsigned char volatile xdata *)0xfb21) //Common Cathode阴 Display Data 1
#define COM2_DC_L (*(unsigned char volatile xdata *)0xfb22) //Common Cathode阴 Display Data 2
#define COM3_DC_L (*(unsigned char volatile xdata *)0xfb23) //Common Cathode阴 Display Data 3
#define COM4_DC_L (*(unsigned char volatile xdata *)0xfb24) //Common Cathode阴 Display Data 4
#define COM5_DC_L (*(unsigned char volatile xdata *)0xfb25) //Common Cathode阴 Display Data 5
#define COM6_DC_L (*(unsigned char volatile xdata *)0xfb26) //Common Cathode阴 Display Data 6
#define COM7_DC_L (*(unsigned char volatile xdata *)0xfb27) //Common Cathode阴 Display Data 7
#define COM0_DC_H (*(unsigned char volatile xdata *)0xfb28) //Common Cathode阴 Display Data 8
#define COM1_DC_H (*(unsigned char volatile xdata *)0xfb29) //Common Cathode阴 Display Data 9
#define COM2_DC_H (*(unsigned char volatile xdata *)0xfb2a) //Common Cathode阴 Display Data 10
#define COM3_DC_H (*(unsigned char volatile xdata *)0xfb2b) //Common Cathode阴 Display Data 11
#define COM4_DC_H (*(unsigned char volatile xdata *)0xfb2c) //Common Cathode阴 Display Data 12
#define COM5_DC_H (*(unsigned char volatile xdata *)0xfb2d) //Common Cathode阴 Display Data 13
#define COM6_DC_H (*(unsigned char volatile xdata *)0xfb2e) //Common Cathode阴 Display Data 14
#define COM7_DC_H (*(unsigned char volatile xdata *)0xfb2f) //Common Cathode阴 Display Data 15
#define TSCHEN1 (*(unsigned char volatile xdata *)0xfb40) //Touch Sensor Enable Register 1
   #define TKEN0 0x01 //
   #define TKEN1 0x02 //
   #define TKEN2 0x04 //
   #define TKEN3 0x08 //
   #define TKEN4 0x10 //
   #define TKEN5 0x20 //
   #define TKEN6 0x40 //
   #define TKEN7 0x80 //
#define TSCHEN2 (*(unsigned char volatile xdata *)0xfb41) //Touch Sensor Enable Register 2
   #define TKEN8  0x01 //
   #define TKEN9  0x02 //
   #define TKEN10 0x04 //
   #define TKEN11 0x08 //
   #define TKEN12 0x10 //
   #define TKEN13 0x20 //
   #define TKEN14 0x40 //
   #define TKEN15 0x80 //
#define TSCFG1 (*(unsigned char volatile xdata *)0xfb42) //Touch Sensor Config Register 1
   #define DT  0x07 //Discharge Time
   #define SCR 0x70 //Switched Capacitor Rate
#define TSCFG2 (*(unsigned char volatile xdata *)0xfb43) //Touch Sensor Config Register 2
   #define TSVR 0x03 //Touch Sensor Voltage Reference
#define TSWUTC (*(unsigned char volatile xdata *)0xfb44) //Touch Sensor Wakeup Control
#define TSCTRL (*(unsigned char volatile xdata *)0xfb45) //Touch Sensor Control
   #define TSSAMP 0x03 //Touch Sensor Multiple Scan Averaging
   #define TSWUEN 0x04 //Touch Sensor Wakeup Enable
   #define TSDCEN 0x08 //Touch Sensor Digital Comparator Enable
   #define TSWUCS 0x10 //Touch Sensor Wakeup Clock Select
   #define TSWAIT 0x20 //Touch Sensor WAIT Control
   #define SINGLE 0x40 //Single Scan Mode Control
   #define TSGO   0x80 //Touch Sensor Enable
#define TSSTA1 (*(unsigned char volatile xdata *)0xfb46) //Touch Sensor Status Register 1
   #define TSWKCHN 0x0F //Touch Sensor Scan Status Flags
   #define LEDWK   0x80 //LED Working Status
#define TSSTA2 (*(unsigned char volatile xdata *)0xfb47) //Touch Sensor Status Register 2
   #define TSDNCHN 0x0F //Touch Sensor Channel Completion Status
   #define TSDOV   0x40 //Touch Sensor Data Overflow Flag
   #define TSIF    0x80 //Touch Sensor Interrup Flag
#define TSRT (*(unsigned char volatile xdata *)0xfb48) //Touch Sensor Time Control
#define TSDAT (*(unsigned int  volatile xdata *)0xfb49) //Touch Sensor Data Word
#define TSDATH (*(unsigned char volatile xdata *)0xfb49) //Touch Sensor Data High Byte
#define TSDATL (*(unsigned char volatile xdata *)0xfb4a) //Touch Sensor Data Low Byte
#define TSTH00 (*(unsigned int  volatile xdata *)0xfb50) //Touch Sensor 0 Threshold Word
#define TSTH00H (*(unsigned char volatile xdata *)0xfb50) //Touch Sensor 0 Threshold High Byte
#define TSTH00L (*(unsigned char volatile xdata *)0xfb51) //Touch Sensor 0 Threshold Low Byte
#define TSTH01 (*(unsigned int  volatile xdata *)0xfb52) //Touch Sensor 1 Threshold Word
#define TSTH01H (*(unsigned char volatile xdata *)0xfb52) //Touch Sensor 1 Threshold High Byte
#define TSTH01L (*(unsigned char volatile xdata *)0xfb53) //Touch Sensor 1 Threshold Low Byte
#define TSTH02 (*(unsigned int  volatile xdata *)0xfb54) //Touch Sensor 2 Threshold Word
#define TSTH02H (*(unsigned char volatile xdata *)0xfb54) //Touch Sensor 2 Threshold High Byte
#define TSTH02L (*(unsigned char volatile xdata *)0xfb55) //Touch Sensor 2 Threshold Low Byte
#define TSTH03 (*(unsigned int  volatile xdata *)0xfb56) //Touch Sensor 3 Threshold Word
#define TSTH03H (*(unsigned char volatile xdata *)0xfb56) //Touch Sensor 3 Threshold High Byte
#define TSTH03L (*(unsigned char volatile xdata *)0xfb57) //Touch Sensor 3 Threshold Low Byte
#define TSTH04 (*(unsigned int  volatile xdata *)0xfb58) //Touch Sensor 4 Threshold Word
#define TSTH04H (*(unsigned char volatile xdata *)0xfb58) //Touch Sensor 4 Threshold High Byte
#define TSTH04L (*(unsigned char volatile xdata *)0xfb59) //Touch Sensor 4 Threshold Low Byte
#define TSTH05 (*(unsigned int  volatile xdata *)0xfb5a) //Touch Sensor 5 Threshold Word
#define TSTH05H (*(unsigned char volatile xdata *)0xfb5a) //Touch Sensor 5 Threshold High Byte
#define TSTH05L (*(unsigned char volatile xdata *)0xfb5b) //Touch Sensor 5 Threshold Low Byte
#define TSTH06 (*(unsigned int  volatile xdata *)0xfb5c) //Touch Sensor 6 Threshold Word
#define TSTH06H (*(unsigned char volatile xdata *)0xfb5c) //Touch Sensor 6 Threshold High Byte
#define TSTH06L (*(unsigned char volatile xdata *)0xfb5d) //Touch Sensor 6 Threshold Low Byte
#define TSTH07 (*(unsigned int  volatile xdata *)0xfb5e) //Touch Sensor 7 Threshold Word
#define TSTH07H (*(unsigned char volatile xdata *)0xfb5e) //Touch Sensor 7 Threshold High Byte
#define TSTH07L (*(unsigned char volatile xdata *)0xfb5f) //Touch Sensor 7 Threshold Low Byte
#define TSTH08 (*(unsigned int  volatile xdata *)0xfb60) //Touch Sensor 8 Threshold Word
#define TSTH08H (*(unsigned char volatile xdata *)0xfb60) //Touch Sensor 8 Threshold High Byte
#define TSTH08L (*(unsigned char volatile xdata *)0xfb61) //Touch Sensor 8 Threshold Low Byte
#define TSTH09 (*(unsigned int  volatile xdata *)0xfb62) //Touch Sensor 9 Threshold Word
#define TSTH09H (*(unsigned char volatile xdata *)0xfb62) //Touch Sensor 9 Threshold High Byte
#define TSTH09L (*(unsigned char volatile xdata *)0xfb63) //Touch Sensor 9 Threshold Low Byte
#define TSTH10 (*(unsigned int  volatile xdata *)0xfb64) //Touch Sensor 10 Threshold Word
#define TSTH10H (*(unsigned char volatile xdata *)0xfb64) //Touch Sensor 10 Threshold High Byte
#define TSTH10L (*(unsigned char volatile xdata *)0xfb65) //Touch Sensor 10 Threshold Low Byte
#define TSTH11 (*(unsigned int  volatile xdata *)0xfb66) //Touch Sensor 11 Threshold Word
#define TSTH11H (*(unsigned char volatile xdata *)0xfb66) //Touch Sensor 11 Threshold High Byte
#define TSTH11L (*(unsigned char volatile xdata *)0xfb67) //Touch Sensor 11 Threshold Low Byte
#define TSTH12 (*(unsigned int  volatile xdata *)0xfb68) //Touch Sensor 12 Threshold Word
#define TSTH12H (*(unsigned char volatile xdata *)0xfb68) //Touch Sensor 12 Threshold High Byte
#define TSTH12L (*(unsigned char volatile xdata *)0xfb69) //Touch Sensor 12 Threshold Low Byte
#define TSTH13 (*(unsigned int  volatile xdata *)0xfb6a) //Touch Sensor 13 Threshold Word
#define TSTH13H (*(unsigned char volatile xdata *)0xfb6a) //Touch Sensor 13 Threshold High Byte
#define TSTH13L (*(unsigned char volatile xdata *)0xfb6b) //Touch Sensor 13 Threshold Low Byte
#define TSTH14 (*(unsigned int  volatile xdata *)0xfb6c) //Touch Sensor 14 Threshold Word
#define TSTH14H (*(unsigned char volatile xdata *)0xfb6c) //Touch Sensor 14 Threshold High Byte
#define TSTH14L (*(unsigned char volatile xdata *)0xfb6d) //Touch Sensor 14 Threshold Low Byte
#define TSTH15 (*(unsigned int  volatile xdata *)0xfb6e) //Touch Sensor 15 Threshold Word
#define TSTH15H (*(unsigned char volatile xdata *)0xfb6e) //Touch Sensor 15 Threshold High Byte
#define TSTH15L (*(unsigned char volatile xdata *)0xfb6f) //Touch Sensor 15 Threshold Low Byte
#define LCDCFG (*(unsigned char volatile xdata *)0xfb80) //LCD Configuration Register
   #define VLCDSEL  0x07 //LCD Voltage Select
   #define VRLPSEL  0x08 //Undefined
   #define LCDCKSEL 0x80 //LCD Clock Source Select
#define LCDCFG2 (*(unsigned char volatile xdata *)0xfb81) //LCD Configuration Register 2
   #define SEG0PS 0x01 //Enable Port 0 for LCD Segments
   #define SEG1PS 0x02 //Enable Port 1 for LCD Segments
   #define SEG2PS 0x04 //Enable Port 2 for LCD Segments
   #define SEG3PS 0x08 //Enable Port 3 for LCD Segments
#define DBLEN (*(unsigned char volatile xdata *)0xfb82) //LCD Deadtime Length
#define COMLENL (*(unsigned char volatile xdata *)0xfb83) //COM Time Lenght Low Byte
#define COMLENM (*(unsigned char volatile xdata *)0xfb84) //COM Time Lenght Middle Byte
#define COMLENH (*(unsigned char volatile xdata *)0xfb85) //COM Time Lenght High Bits
   #define COMLEN 0x0F //COM Time Lenght High Bits
#define BLINKRATE (*(unsigned char volatile xdata *)0xfb86) //Blink Rate Register
#define LCDCR (*(unsigned char volatile xdata *)0xfb87) //LCD Control Register
   #define ENLCD   0x01 //Enable LCD Function
   #define ACTMODE 0x06 //LCD Display Mode
#define COMON (*(unsigned char volatile xdata *)0xfb88) //Common Line Enable
   #define COM0 0x01 //Enable Port 0 for LCD Common Line
   #define COM1 0x02 //Enable Port 1 for LCD Common Line
   #define COM2 0x04 //Enable Port 2 for LCD Common Line
   #define COM3 0x08 //Enable Port 3 for LCD Common Line
#define SEGON1 (*(unsigned char volatile xdata *)0xfb8a) //Enable Segment On 1
   #define SEG0 0x01 //
   #define SEG1 0x02 //
   #define SEG2 0x04 //
   #define SEG3 0x08 //
   #define SEG4 0x10 //
   #define SEG5 0x20 //
   #define SEG6 0x40 //
   #define SEG7 0x80 //
#define SEGON2 (*(unsigned char volatile xdata *)0xfb8b) //Enable Segment On 2
   #define SEG8  0x01 //
   #define SEG9  0x02 //
   #define SEG10 0x04 //
   #define SEG11 0x08 //
   #define SEG12 0x10 //
   #define SEG13 0x20 //
   #define SEG14 0x40 //
   #define SEG15 0x80 //
#define SEGON3 (*(unsigned char volatile xdata *)0xfb8c) //Enable Segment On 3
   #define SEG16 0x01 //
   #define SEG17 0x02 //
   #define SEG18 0x04 //
   #define SEG19 0x08 //
   #define SEG20 0x10 //
   #define SEG21 0x20 //
   #define SEG22 0x40 //
   #define SEG23 0x80 //
#define SEGON4 (*(unsigned char volatile xdata *)0xfb8d) //Enable Segment On 4
   #define SEG24 0x01 //
   #define SEG25 0x02 //
   #define SEG26 0x04 //
   #define SEG27 0x08 //
   #define SEG28 0x10 //
   #define SEG29 0x20 //
   #define SEG30 0x40 //
   #define SEG31 0x80 //
#define SEGON5 (*(unsigned char volatile xdata *)0xfb8e) //Enable Segment On 5
   #define SEG32 0x01 //
   #define SEG33 0x02 //
   #define SEG34 0x04 //
   #define SEG35 0x08 //
   #define SEG36 0x10 //
   #define SEG37 0x20 //
   #define SEG38 0x40 //
   #define SEG39 0x80 //
#define C0SEGV0 (*(unsigned char volatile xdata *)0xfb90) //LCD C0 Data Register 0
   #define C0S0 0x01 //
   #define C0S1 0x02 //
   #define C0S2 0x04 //
   #define C0S3 0x08 //
   #define C0S4 0x10 //
   #define C0S5 0x20 //
   #define C0S6 0x40 //
   #define C0S7 0x80 //
#define C0SEGV1 (*(unsigned char volatile xdata *)0xfb91) //LCD C0 Data Register 1
   #define C0S8  0x01 //
   #define C0S9  0x02 //
   #define C0S10 0x04 //
   #define C0S11 0x08 //
   #define C0S12 0x10 //
   #define C0S13 0x20 //
   #define C0S14 0x40 //
   #define C0S15 0x80 //
#define C0SEGV2 (*(unsigned char volatile xdata *)0xfb92) //LCD C0 Data Register 2
   #define C0S16 0x01 //
   #define C0S17 0x02 //
   #define C0S18 0x04 //
   #define C0S19 0x08 //
   #define C0S20 0x10 //
   #define C0S21 0x20 //
   #define C0S22 0x40 //
   #define C0S23 0x80 //
#define C0SEGV3 (*(unsigned char volatile xdata *)0xfb93) //LCD C0 Data Register 3
   #define C0S24 0x01 //
   #define C0S25 0x02 //
   #define C0S26 0x04 //
   #define C0S27 0x08 //
   #define C0S28 0x10 //
   #define C0S29 0x20 //
   #define C0S30 0x40 //
   #define C0S31 0x80 //
#define C0SEGV4 (*(unsigned char volatile xdata *)0xfb94) //LCD C0 Data Register 4
   #define C0S32 0x01 //
   #define C0S33 0x02 //
   #define C0S34 0x04 //
   #define C0S35 0x08 //
   #define C0S36 0x10 //
   #define C0S37 0x20 //
   #define C0S38 0x40 //
   #define C0S39 0x80 //
#define C1SEGV0 (*(unsigned char volatile xdata *)0xfb98) //LCD C1 Data Register 0
   #define C1S0 0x01 //
   #define C1S1 0x02 //
   #define C1S2 0x04 //
   #define C1S3 0x08 //
   #define C1S4 0x10 //
   #define C1S5 0x20 //
   #define C1S6 0x40 //
   #define C1S7 0x80 //
#define C1SEGV1 (*(unsigned char volatile xdata *)0xfb99) //LCD C1 Data Register 1
   #define C1S8  0x01 //
   #define C1S9  0x02 //
   #define C1S10 0x04 //
   #define C1S11 0x08 //
   #define C1S12 0x10 //
   #define C1S13 0x20 //
   #define C1S14 0x40 //
   #define C1S15 0x80 //
#define C1SEGV2 (*(unsigned char volatile xdata *)0xfb9a) //LCD C1 Data Register 2
   #define C1S16 0x01 //
   #define C1S17 0x02 //
   #define C1S18 0x04 //
   #define C1S19 0x08 //
   #define C1S20 0x10 //
   #define C1S21 0x20 //
   #define C1S22 0x40 //
   #define C1S23 0x80 //
#define C1SEGV3 (*(unsigned char volatile xdata *)0xfb9b) //LCD C1 Data Register 3
   #define C1S24 0x01 //
   #define C1S25 0x02 //
   #define C1S26 0x04 //
   #define C1S27 0x08 //
   #define C1S28 0x10 //
   #define C1S29 0x20 //
   #define C1S30 0x40 //
   #define C1S31 0x80 //
#define C1SEGV4 (*(unsigned char volatile xdata *)0xfb9c) //LCD C1 Data Register 4
   #define C1S32 0x01 //
   #define C1S33 0x02 //
   #define C1S34 0x04 //
   #define C1S35 0x08 //
   #define C1S36 0x10 //
   #define C1S37 0x20 //
   #define C1S38 0x40 //
   #define C1S39 0x80 //
#define C2SEGV0 (*(unsigned char volatile xdata *)0xfba0) //LCD C2 Data Register 0
   #define C2S0   0x01 //
   #define C2S1   0x02 //
   #define C2S2   0x04 //
   #define C2S3   0x08 //
   #define C2S4   0x10 //
   #define C2SC25 0x20 //
   #define C2S6   0x40 //
   #define C2S7   0x80 //
#define C2SEGV1 (*(unsigned char volatile xdata *)0xfba1) //LCD C2 Data Register 1
   #define C2S8  0x01 //
   #define C2S9  0x02 //
   #define C2S10 0x04 //
   #define C2S11 0x08 //
   #define C2S12 0x10 //
   #define C2S13 0x20 //
   #define C2S14 0x40 //
   #define C2S15 0x80 //
#define C2SEGV2 (*(unsigned char volatile xdata *)0xfba2) //LCD C2 Data Register 2
   #define C2S16 0x01 //
   #define C2S17 0x02 //
   #define C2S18 0x04 //
   #define C2S19 0x08 //
   #define C2S20 0x10 //
   #define C2S21 0x20 //
   #define C2S22 0x40 //
   #define C2S23 0x80 //
#define C2SEGV3 (*(unsigned char volatile xdata *)0xfba3) //LCD C2 Data Register 3
   #define C2S24 0x01 //
   #define C2S25 0x02 //
   #define C2S26 0x04 //
   #define C2S27 0x08 //
   #define C2S28 0x10 //
   #define C2S29 0x20 //
   #define C2S30 0x40 //
   #define C2S31 0x80 //
#define C2SEGV4 (*(unsigned char volatile xdata *)0xfba4) //LCD C2 Data Register 4
   #define C2S32 0x01 //
   #define C2S33 0x02 //
   #define C2S34 0x04 //
   #define C2S35 0x08 //
   #define C2S36 0x10 //
   #define C2S37 0x20 //
   #define C2S38 0x40 //
   #define C2S39 0x80 //
#define C3SEGV0 (*(unsigned char volatile xdata *)0xfba8) //LCD C3 Data Register 0
   #define C3S0 0x01 //
   #define C3S1 0x02 //
   #define C3S2 0x04 //
   #define C3S3 0x08 //
   #define C3S4 0x10 //
   #define C3S5 0x20 //
   #define C3S6 0x40 //
   #define C3S7 0x80 //
#define C3SEGV1 (*(unsigned char volatile xdata *)0xfba9) //LCD C3 Data Register 1
   #define C3S8  0x01 //
   #define C3S9  0x02 //
   #define C3S10 0x04 //
   #define C3S11 0x08 //
   #define C3S12 0x10 //
   #define C3S13 0x20 //
   #define C3S14 0x40 //
   #define C3S15 0x80 //
#define C3SEGV2 (*(unsigned char volatile xdata *)0xfbaa) //LCD C3 Data Register 2
   #define C3S16 0x01 //
   #define C3S17 0x02 //
   #define C3S18 0x04 //
   #define C3S19 0x08 //
   #define C3S20 0x10 //
   #define C3S21 0x20 //
   #define C3S22 0x40 //
   #define C3S23 0x80 //
#define C3SEGV3 (*(unsigned char volatile xdata *)0xfbab) //LCD C3 Data Register 3
   #define C3S24 0x01 //
   #define C3S25 0x02 //
   #define C3S26 0x04 //
   #define C3S27 0x08 //
   #define C3S28 0x10 //
   #define C3S29 0x20 //
   #define C3S30 0x40 //
   #define C3S31 0x80 //
#define C3SEGV4 (*(unsigned char volatile xdata *)0xfbac) //LCD C3 Data Register 4
   #define C3S32 0x01 //
   #define C3S33 0x02 //
   #define C3S34 0x04 //
   #define C3S35 0x08 //
   #define C3S36 0x10 //
   #define C3S37 0x20 //
   #define C3S38 0x40 //
   #define C3S39 0x80 //
#define MD3 (*(unsigned char volatile xdata *)0xfcf0) //Operand 3 Data Register
#define MD2 (*(unsigned char volatile xdata *)0xfcf1) //Operand 2 Data Register
#define MD1 (*(unsigned char volatile xdata *)0xfcf2) //Operand 1 Data Register
#define MD0 (*(unsigned char volatile xdata *)0xfcf3) //Operand 0 Data Register
#define MD5 (*(unsigned char volatile xdata *)0xfcf4) //Operand 5 Data Register
#define MD4 (*(unsigned char volatile xdata *)0xfcf5) //Operand 4 Data Register
#define ARCON (*(unsigned char volatile xdata *)0xfcf6) //Multiply Divide Unit Array Control
   #define SC     0x1F //Shift Count
   #define ARMODE 0xE0 //Mode Select
#define OPCON (*(unsigned char volatile xdata *)0xfcf7) //Multiply Divide Unit Operation Control
   #define ENOP 0x01 //Enable Operation
   #define RST  0x02 //Software Reset
   #define MDOV 0x40 //Overflow Flag
#define P0INTE (*(unsigned char volatile xdata *)0xfd00) //Port 0 Interrupt Enable Register
   #define P00INTE 0x01 //
   #define P01INTE 0x02 //
   #define P02INTE 0x04 //
   #define P03INTE 0x08 //
   #define P04INTE 0x10 //
   #define P05INTE 0x20 //
   #define P06INTE 0x40 //
   #define P07INTE 0x80 //
#define P1INTE (*(unsigned char volatile xdata *)0xfd01) //Port 1 Interrupt Enable Register
   #define P10INTE 0x01 //
   #define P11INTE 0x02 //
   #define P12INTE 0x04 //
   #define P13INTE 0x08 //
   #define P14INTE 0x10 //
   #define P15INTE 0x20 //
   #define P16INTE 0x40 //
   #define P17INTE 0x80 //
#define P2INTE (*(unsigned char volatile xdata *)0xfd02) //Port 2 Interrupt Enable Register
   #define P20INTE 0x01 //
   #define P21INTE 0x02 //
   #define P22INTE 0x04 //
   #define P23INTE 0x08 //
   #define P24INTE 0x10 //
   #define P25INTE 0x20 //
   #define P26INTE 0x40 //
   #define P27INTE 0x80 //
#define P3INTE (*(unsigned char volatile xdata *)0xfd03) //Port 3 Interrupt Enable Register
   #define P30INTE 0x01 //
   #define P31INTE 0x02 //
   #define P32INTE 0x04 //
   #define P33INTE 0x08 //
   #define P34INTE 0x10 //
   #define P35INTE 0x20 //
   #define P36INTE 0x40 //
   #define P37INTE 0x80 //
#define P4INTE (*(unsigned char volatile xdata *)0xfd04) //Port 4 Interrupt Enable Register
   #define P40INTE 0x01 //
   #define P41INTE 0x02 //
   #define P42INTE 0x04 //
   #define P43INTE 0x08 //
   #define P44INTE 0x10 //
   #define P45INTE 0x20 //
   #define P46INTE 0x40 //
   #define P47INTE 0x80 //
#define P5INTE (*(unsigned char volatile xdata *)0xfd05) //Port 5 Interrupt Enable Register
   #define P50INTE 0x01 //
   #define P51INTE 0x02 //
   #define P52INTE 0x04 //
   #define P53INTE 0x08 //
   #define P54INTE 0x10 //
   #define P55INTE 0x20 //
#define P6INTE (*(unsigned char volatile xdata *)0xfd06) //Port 6 Interrupt Enable Register
   #define P60INTE 0x01 //
   #define P61INTE 0x02 //
   #define P62INTE 0x04 //
   #define P63INTE 0x08 //
   #define P64INTE 0x10 //
   #define P65INTE 0x20 //
   #define P66INTE 0x40 //
   #define P67INTE 0x80 //
#define P7INTE (*(unsigned char volatile xdata *)0xfd07) //Port 7 Interrupt Enable Register
   #define P70INTE 0x01 //
   #define P71INTE 0x02 //
   #define P72INTE 0x04 //
   #define P73INTE 0x08 //
   #define P74INTE 0x10 //
   #define P75INTE 0x20 //
   #define P76INTE 0x40 //
   #define P77INTE 0x80 //
#define P0INTF (*(unsigned char volatile xdata *)0xfd10) //Port 0 Interrupt Flag Register
   #define P00INTF 0x01 //
   #define P01INTF 0x02 //
   #define P02INTF 0x04 //
   #define P03INTF 0x08 //
   #define P04INTF 0x10 //
   #define P05INTF 0x20 //
   #define P06INTF 0x40 //
   #define P07INTF 0x80 //
#define P1INTF (*(unsigned char volatile xdata *)0xfd11) //Port 1 Interrupt Flag Register
   #define P10INTF 0x01 //
   #define P11INTF 0x02 //
   #define P12INTF 0x04 //
   #define P13INTF 0x08 //
   #define P14INTF 0x10 //
   #define P15INTF 0x20 //
   #define P16INTF 0x40 //
   #define P17INTF 0x80 //
#define P2INTF (*(unsigned char volatile xdata *)0xfd12) //Port 2 Interrupt Flag Register
   #define P20INTF 0x01 //
   #define P21INTF 0x02 //
   #define P22INTF 0x04 //
   #define P23INTF 0x08 //
   #define P24INTF 0x10 //
   #define P25INTF 0x20 //
   #define P26INTF 0x40 //
   #define P27INTF 0x80 //
#define P3INTF (*(unsigned char volatile xdata *)0xfd13) //Port 3 Interrupt Flag Register
   #define P30INTF 0x01 //
   #define P31INTF 0x02 //
   #define P32INTF 0x04 //
   #define P33INTF 0x08 //
   #define P34INTF 0x10 //
   #define P35INTF 0x20 //
   #define P36INTF 0x40 //
   #define P37INTF 0x80 //
#define P4INTF (*(unsigned char volatile xdata *)0xfd14) //Port 4 Interrupt Flag Register
   #define P40INTF 0x01 //
   #define P41INTF 0x02 //
   #define P42INTF 0x04 //
   #define P43INTF 0x08 //
   #define P44INTF 0x10 //
   #define P45INTF 0x20 //
   #define P46INTF 0x40 //
   #define P47INTF 0x80 //
#define P5INTF (*(unsigned char volatile xdata *)0xfd15) //Port 5 Interrupt Flag Register
   #define P50INTF 0x01 //
   #define P51INTF 0x02 //
   #define P52INTF 0x04 //
   #define P53INTF 0x08 //
   #define P54INTF 0x10 //
   #define P55INTF 0x20 //
#define P6INTF (*(unsigned char volatile xdata *)0xfd16) //Port 6 Interrupt Flag Register
   #define P60INTF 0x01 //
   #define P61INTF 0x02 //
   #define P62INTF 0x04 //
   #define P63INTF 0x08 //
   #define P64INTF 0x10 //
   #define P65INTF 0x20 //
   #define P66INTF 0x40 //
   #define P67INTF 0x80 //
#define P7INTF (*(unsigned char volatile xdata *)0xfd17) //Port 7 Interrupt Flag Register
   #define P70INTF 0x01 //
   #define P71INTF 0x02 //
   #define P72INTF 0x04 //
   #define P73INTF 0x08 //
   #define P74INTF 0x10 //
   #define P75INTF 0x20 //
   #define P76INTF 0x40 //
   #define P77INTF 0x80 //
#define P0IM0 (*(unsigned char volatile xdata *)0xfd20) //Port 0 Interrupt Mode Register 0
   #define P00IM0 0x01 //
   #define P01IM0 0x02 //
   #define P02IM0 0x04 //
   #define P03IM0 0x08 //
   #define P04IM0 0x10 //
   #define P05IM0 0x20 //
   #define P06IM0 0x40 //
   #define P07IM0 0x80 //
#define P1IM0 (*(unsigned char volatile xdata *)0xfd21) //Port 1 Interrupt Mode Register 0
   #define P10IM0 0x01 //
   #define P11IM0 0x02 //
   #define P12IM0 0x04 //
   #define P13IM0 0x08 //
   #define P14IM0 0x10 //
   #define P15IM0 0x20 //
   #define P16IM0 0x40 //
   #define P17IM0 0x80 //
#define P2IM0 (*(unsigned char volatile xdata *)0xfd22) //Port 2 Interrupt Mode Register 0
   #define P20IM0 0x01 //
   #define P21IM0 0x02 //
   #define P22IM0 0x04 //
   #define P23IM0 0x08 //
   #define P24IM0 0x10 //
   #define P25IM0 0x20 //
   #define P26IM0 0x40 //
   #define P27IM0 0x80 //
#define P3IM0 (*(unsigned char volatile xdata *)0xfd23) //Port 3 Interrupt Mode Register 0
   #define P30IM0 0x01 //
   #define P31IM0 0x02 //
   #define P32IM0 0x04 //
   #define P33IM0 0x08 //
   #define P34IM0 0x10 //
   #define P35IM0 0x20 //
   #define P36IM0 0x40 //
   #define P37IM0 0x80 //
#define P4IM0 (*(unsigned char volatile xdata *)0xfd24) //Port 4 Interrupt Mode Register 0
   #define P40IM0 0x01 //
   #define P41IM0 0x02 //
   #define P42IM0 0x04 //
   #define P43IM0 0x08 //
   #define P44IM0 0x10 //
   #define P45IM0 0x20 //
   #define P46IM0 0x40 //
   #define P47IM0 0x80 //
#define P5IM0 (*(unsigned char volatile xdata *)0xfd25) //Port 5 Interrupt Mode Register 0
   #define P50IM0 0x01 //
   #define P51IM0 0x02 //
   #define P52IM0 0x04 //
   #define P53IM0 0x08 //
   #define P54IM0 0x10 //
   #define P55IM0 0x20 //
#define P6IM0 (*(unsigned char volatile xdata *)0xfd26) //Port 6 Interrupt Mode Register 0
   #define P60IM0 0x01 //
   #define P61IM0 0x02 //
   #define P62IM0 0x04 //
   #define P63IM0 0x08 //
   #define P64IM0 0x10 //
   #define P65IM0 0x20 //
   #define P66IM0 0x40 //
   #define P67IM0 0x80 //
#define P7IM0 (*(unsigned char volatile xdata *)0xfd27) //Port 7 Interrupt Mode Register 0
   #define P70IM0 0x01 //
   #define P71IM0 0x02 //
   #define P72IM0 0x04 //
   #define P73IM0 0x08 //
   #define P74IM0 0x10 //
   #define P75IM0 0x20 //
   #define P76IM0 0x40 //
   #define P77IM0 0x80 //
#define P0IM1 (*(unsigned char volatile xdata *)0xfd30) //Port 0 Interrupt Mode Register 1
   #define P00IM1 0x01 //
   #define P01IM1 0x02 //
   #define P02IM1 0x04 //
   #define P03IM1 0x08 //
   #define P04IM1 0x10 //
   #define P05IM1 0x20 //
   #define P06IM1 0x40 //
   #define P07IM1 0x80 //
#define P1IM1 (*(unsigned char volatile xdata *)0xfd31) //Port 1 Interrupt Mode Register 1
   #define P10IM1 0x01 //
   #define P11IM1 0x02 //
   #define P12IM1 0x04 //
   #define P13IM1 0x08 //
   #define P14IM1 0x10 //
   #define P15IM1 0x20 //
   #define P16IM1 0x40 //
   #define P17IM1 0x80 //
#define P2IM1 (*(unsigned char volatile xdata *)0xfd32) //Port 2 Interrupt Mode Register 1
   #define P20IM1 0x01 //
   #define P21IM1 0x02 //
   #define P22IM1 0x04 //
   #define P23IM1 0x08 //
   #define P24IM1 0x10 //
   #define P25IM1 0x20 //
   #define P26IM1 0x40 //
   #define P27IM1 0x80 //
#define P3IM1 (*(unsigned char volatile xdata *)0xfd33) //Port 3 Interrupt Mode Register 1
   #define P30IM1 0x01 //
   #define P31IM1 0x02 //
   #define P32IM1 0x04 //
   #define P33IM1 0x08 //
   #define P34IM1 0x10 //
   #define P35IM1 0x20 //
   #define P36IM1 0x40 //
   #define P37IM1 0x80 //
#define P4IM1 (*(unsigned char volatile xdata *)0xfd34) //Port 4 Interrupt Mode Register 1
   #define P40IM1 0x01 //
   #define P41IM1 0x02 //
   #define P42IM1 0x04 //
   #define P43IM1 0x08 //
   #define P44IM1 0x10 //
   #define P45IM1 0x20 //
   #define P46IM1 0x40 //
   #define P47IM1 0x80 //
#define P5IM1 (*(unsigned char volatile xdata *)0xfd35) //Port 5 Interrupt Mode Register 1
   #define P50IM1 0x01 //
   #define P51IM1 0x02 //
   #define P52IM1 0x04 //
   #define P53IM1 0x08 //
   #define P54IM1 0x10 //
   #define P55IM1 0x20 //
#define P6IM1 (*(unsigned char volatile xdata *)0xfd36) //Port 6 Interrupt Mode Register 1
   #define P60IM1 0x01 //
   #define P61IM1 0x02 //
   #define P62IM1 0x04 //
   #define P63IM1 0x08 //
   #define P64IM1 0x10 //
   #define P65IM1 0x20 //
   #define P66IM1 0x40 //
   #define P67IM1 0x80 //
#define P7IM1 (*(unsigned char volatile xdata *)0xfd37) //Port 7 Interrupt Mode Register 1
   #define P70IM1 0x01 //
   #define P71IM1 0x02 //
   #define P72IM1 0x04 //
   #define P73IM1 0x08 //
   #define P74IM1 0x10 //
   #define P75IM1 0x20 //
   #define P76IM1 0x40 //
   #define P77IM1 0x80 //
#define P0WKUE (*(unsigned char volatile xdata *)0xfd40) //Port 0 Wake-up Enable Register
   #define P00WKUE 0x01 //
   #define P01WKUE 0x02 //
   #define P02WKUE 0x04 //
   #define P03WKUE 0x08 //
   #define P04WKUE 0x10 //
   #define P05WKUE 0x20 //
   #define P06WKUE 0x40 //
   #define P07WKUE 0x80 //
#define P1WKUE (*(unsigned char volatile xdata *)0xfd41) //Port 1 Wake-up Enable Register
   #define P10WKUE 0x01 //
   #define P11WKUE 0x02 //
   #define P12WKUE 0x04 //
   #define P13WKUE 0x08 //
   #define P14WKUE 0x10 //
   #define P15WKUE 0x20 //
   #define P16WKUE 0x40 //
   #define P17WKUE 0x80 //
#define P2WKUE (*(unsigned char volatile xdata *)0xfd42) //Port 2 Wake-up Enable Register
   #define P20WKUE 0x01 //
   #define P21WKUE 0x02 //
   #define P22WKUE 0x04 //
   #define P23WKUE 0x08 //
   #define P24WKUE 0x10 //
   #define P25WKUE 0x20 //
   #define P26WKUE 0x40 //
   #define P27WKUE 0x80 //
#define P3WKUE (*(unsigned char volatile xdata *)0xfd43) //Port 3 Wake-up Enable Register
   #define P30WKUE 0x01 //
   #define P31WKUE 0x02 //
   #define P32WKUE 0x04 //
   #define P33WKUE 0x08 //
   #define P34WKUE 0x10 //
   #define P35WKUE 0x20 //
   #define P36WKUE 0x40 //
   #define P37WKUE 0x80 //
#define P4WKUE (*(unsigned char volatile xdata *)0xfd44) //Port 4 Wake-up Enable Register
   #define P40WKUE 0x01 //
   #define P41WKUE 0x02 //
   #define P42WKUE 0x04 //
   #define P43WKUE 0x08 //
   #define P44WKUE 0x10 //
   #define P45WKUE 0x20 //
   #define P46WKUE 0x40 //
   #define P47WKUE 0x80 //
#define P5WKUE (*(unsigned char volatile xdata *)0xfd45) //Port 5 Wake-up Enable Register
   #define P50WKUE 0x01 //
   #define P51WKUE 0x02 //
   #define P52WKUE 0x04 //
   #define P53WKUE 0x08 //
   #define P54WKUE 0x10 //
   #define P55WKUE 0x20 //
#define P6WKUE (*(unsigned char volatile xdata *)0xfd46) //Port 6 Wake-up Enable Register
   #define P60WKUE 0x01 //
   #define P61WKUE 0x02 //
   #define P62WKUE 0x04 //
   #define P63WKUE 0x08 //
   #define P64WKUE 0x10 //
   #define P65WKUE 0x20 //
   #define P66WKUE 0x40 //
   #define P67WKUE 0x80 //
#define P7WKUE (*(unsigned char volatile xdata *)0xfd47) //Port 7 Wake-up Enable Register
   #define P70WKUE 0x01 //
   #define P71WKUE 0x02 //
   #define P72WKUE 0x04 //
   #define P73WKUE 0x08 //
   #define P74WKUE 0x10 //
   #define P75WKUE 0x20 //
   #define P76WKUE 0x40 //
   #define P77WKUE 0x80 //
#define PINIPL (*(unsigned char volatile xdata *)0xfd60) //IO Port Interrupt Priority Low
   #define P0IP 0x01 //
   #define P1IP 0x02 //
   #define P2IP 0x04 //
   #define P3IP 0x08 //
   #define P4IP 0x10 //
   #define P5IP 0x20 //
   #define P6IP 0x40 //
   #define P7IP 0x80 //
#define PINIPH (*(unsigned char volatile xdata *)0xfd61) //IO Port Interrupt Priority High
   #define P0IPH 0x01 //
   #define P1IPH 0x02 //
   #define P2IPH 0x04 //
   #define P3IPH 0x08 //
   #define P4IPH 0x10 //
   #define P5IPH 0x20 //
   #define P6IPH 0x40 //
   #define P7IPH 0x80 //
#define CKSEL (*(unsigned char volatile xdata *)0xfe00) //Clock Select Register
   #define MCKSEL 0x03 //Main Clock Source Selection
#define CLKDIV (*(unsigned char volatile xdata *)0xfe01) //Clock Frequency Division Register 
#define HIRCCR (*(unsigned char volatile xdata *)0xfe02) //High Accuracy Internal RC Control Register
   #define HIRCST 0x01 //Internal High Speed/Precision Oscillator Stability Indicator
   #define ENHIRC 0x80 //Enable Internal High Speed/Precision Clock Source
#define XOSCCR (*(unsigned char volatile xdata *)0xfe03) //External Oscillator Control Register
   #define XOSCST   0x01 //External Crystal Oscillator Stability Indicator
   #define XITYPE   0x40 //External Clock Source Type
   #define GAIN     0x80 //External Crystal Oscillator Gain Control
   #define XCFILTER 0x30 //External Crystal Oscillator Filter Control
   #define XITYPE   0x40 //External Clock Source Type Select
   #define ENXOSC   0x80 //Enable External Crystal Clock Source
#define IRC32KCR (*(unsigned char volatile xdata *)0xfe04) //Internal 32K Oscillator Control Register
   #define IRC32KST 0x01 //Internal RC 32 KHz Oscillator Stability Indicator
   #define ENIRC32K 0x80 //Enable Internal RC 32 KHz Clock Source
#define MCLKOCR (*(unsigned char volatile xdata *)0xfe05) //Main Clock Output Control Register
   #define MCLKODIV 0x7F //Main Clock Output Division Coefficient
   #define MCLKO_S    0x80 //Main Clock Output Pin Selection
#define IRCDB (*(unsigned char volatile xdata *)0xfe06) //Internal RC High Speed Oscillator
   #define IRCDB_PAR 0xFF //
#define IRC48MCR (*(unsigned char volatile xdata *)0xfe07) //Internal 48M Oscillator Control Register
   #define IRC48MST 0x01 //Internal RC 48 MHz Oscillator Stability Indicator
   #define ENIRC48M 0x80 //Enable Internal RC 48 MHz Clock Source
#define X32KCR (*(unsigned char volatile xdata *)0xfe08) //External 32 KHz Oscillator Control Register
   #define X32KST  0x01 //External 32 KHz Crystal Oscillator Stability Indicator
   #define GAIN32K 0x40 //External 32 KHz Crystal Oscillator Gain Control
   #define ENX32K  0x80 //Enable External 32 KHz Crystal Oscillator
#define SPFUNC (*(unsigned char volatile xdata *)0xfe08) //Special Function Control Register
   #define BKSWR 0x01 //Undefined
#define RSTFLAG (*(unsigned char volatile xdata *)0xfe09) //Reset Flag Register
   #define EXRST 0x01 //Undefined
   #define ROMOV 0x02 //Undefined
   #define SWR   0x04 //Undefined
#define P0PU (*(unsigned char volatile xdata *)0xfe10) //Port 0 Pull-up Resistor Control Register
   #define P00PU 0x01 //
   #define P01PU 0x02 //
   #define P02PU 0x04 //
   #define P03PU 0x08 //
   #define P04PU 0x10 //
   #define P05PU 0x20 //
   #define P06PU 0x40 //
   #define P07PU 0x80 //
#define P1PU (*(unsigned char volatile xdata *)0xfe11) //Port 1 Pull-up Resistor Control Register
   #define P10PU 0x01 //
   #define P11PU 0x02 //
   #define P12PU 0x04 //
   #define P13PU 0x08 //
   #define P14PU 0x10 //
   #define P15PU 0x20 //
   #define P16PU 0x40 //
   #define P17PU 0x80 //
#define P2PU (*(unsigned char volatile xdata *)0xfe12) //Port 2 Pull-up Resistor Control Register
   #define P20PU 0x01 //
   #define P21PU 0x02 //
   #define P22PU 0x04 //
   #define P23PU 0x08 //
   #define P24PU 0x10 //
   #define P25PU 0x20 //
   #define P26PU 0x40 //
   #define P27PU 0x80 //
#define P3PU (*(unsigned char volatile xdata *)0xfe13) //Port 3 Pull-up Resistor Control Register
   #define P30PU 0x01 //
   #define P31PU 0x02 //
   #define P32PU 0x04 //
   #define P33PU 0x08 //
   #define P34PU 0x10 //
   #define P35PU 0x20 //
   #define P36PU 0x40 //
   #define P37PU 0x80 //
#define P4PU (*(unsigned char volatile xdata *)0xfe14) //Port 4 Pull-up Resistor Control Register
   #define P40PU 0x01 //
   #define P41PU 0x02 //
   #define P42PU 0x04 //
   #define P43PU 0x08 //
   #define P44PU 0x10 //
   #define P45PU 0x20 //
   #define P46PU 0x40 //
   #define P47PU 0x80 //
#define P5PU (*(unsigned char volatile xdata *)0xfe15) //Port 5 Pull-up Resistor Control Register
   #define P50PU 0x01 //
   #define P51PU 0x02 //
   #define P52PU 0x04 //
   #define P53PU 0x08 //
   #define P54PU 0x10 //
   #define P55PU 0x20 //
#define P6PU (*(unsigned char volatile xdata *)0xfe16) //Port 6 Pull-up Resistor Control Register
   #define P60PU 0x01 //
   #define P61PU 0x02 //
   #define P62PU 0x04 //
   #define P63PU 0x08 //
   #define P64PU 0x10 //
   #define P65PU 0x20 //
   #define P66PU 0x40 //
   #define P67PU 0x80 //
#define P7PU (*(unsigned char volatile xdata *)0xfe17) //Port 7 Pull-up Resistor Control Register
   #define P70PU 0x01 //
   #define P71PU 0x02 //
   #define P72PU 0x04 //
   #define P73PU 0x08 //
   #define P74PU 0x10 //
   #define P75PU 0x20 //
   #define P76PU 0x40 //
   #define P77PU 0x80 //
#define P0NCS (*(unsigned char volatile xdata *)0xfe18) //Port 0 Schmidt Trigger Control Register
   #define P00NCS 0x01 //
   #define P01NCS 0x02 //
   #define P02NCS 0x04 //
   #define P03NCS 0x08 //
   #define P04NCS 0x10 //
   #define P05NCS 0x20 //
   #define P06NCS 0x40 //
   #define P07NCS 0x80 //
#define P1NCS (*(unsigned char volatile xdata *)0xfe19) //Port 1 Schmidt Trigger Control Register
   #define P10NCS 0x01 //
   #define P11NCS 0x02 //
   #define P12NCS 0x04 //
   #define P13NCS 0x08 //
   #define P14NCS 0x10 //
   #define P15NCS 0x20 //
   #define P16NCS 0x40 //
   #define P17NCS 0x80 //
#define P2NCS (*(unsigned char volatile xdata *)0xfe1a) //Port 2 Schmidt Trigger Control Register
   #define P20NCS 0x01 //
   #define P21NCS 0x02 //
   #define P22NCS 0x04 //
   #define P23NCS 0x08 //
   #define P24NCS 0x10 //
   #define P25NCS 0x20 //
   #define P26NCS 0x40 //
   #define P27NCS 0x80 //
#define P3NCS (*(unsigned char volatile xdata *)0xfe1b) //Port 3 Schmidt Trigger Control Register
   #define P30NCS 0x01 //
   #define P31NCS 0x02 //
   #define P32NCS 0x04 //
   #define P33NCS 0x08 //
   #define P34NCS 0x10 //
   #define P35NCS 0x20 //
   #define P36NCS 0x40 //
   #define P37NCS 0x80 //
#define P4NCS (*(unsigned char volatile xdata *)0xfe1c) //Port 4 Schmidt Trigger Control Register
   #define P40NCS 0x01 //
   #define P41NCS 0x02 //
   #define P42NCS 0x04 //
   #define P43NCS 0x08 //
   #define P44NCS 0x10 //
   #define P45NCS 0x20 //
   #define P46NCS 0x40 //
   #define P47NCS 0x80 //
#define P5NCS (*(unsigned char volatile xdata *)0xfe1d) //Port 5 Schmidt Trigger Control Register
   #define P50NCS 0x01 //
   #define P51NCS 0x02 //
   #define P52NCS 0x04 //
   #define P53NCS 0x08 //
   #define P54NCS 0x10 //
   #define P55NCS 0x20 //
#define P6NCS (*(unsigned char volatile xdata *)0xfe1e) //Port 6 Schmidt Trigger Control Register
   #define P60NCS 0x01 //
   #define P61NCS 0x02 //
   #define P62NCS 0x04 //
   #define P63NCS 0x08 //
   #define P64NCS 0x10 //
   #define P65NCS 0x20 //
   #define P66NCS 0x40 //
   #define P67NCS 0x80 //
#define P7NCS (*(unsigned char volatile xdata *)0xfe1f) //Port 7 Schmidt Trigger Control Register
   #define P70NCS 0x01 //
   #define P71NCS 0x02 //
   #define P72NCS 0x04 //
   #define P73NCS 0x08 //
   #define P74NCS 0x10 //
   #define P75NCS 0x20 //
   #define P76NCS 0x40 //
   #define P77NCS 0x80 //
#define P0SR (*(unsigned char volatile xdata *)0xfe20) //Port 0 Slew Rate Control Register
   #define P00SR 0x01 //
   #define P01SR 0x02 //
   #define P02SR 0x04 //
   #define P03SR 0x08 //
   #define P04SR 0x10 //
   #define P05SR 0x20 //
   #define P06SR 0x40 //
   #define P07SR 0x80 //
#define P1SR (*(unsigned char volatile xdata *)0xfe21) //Port 1 Slew Rate Control Register
   #define P10SR 0x01 //
   #define P11SR 0x02 //
   #define P12SR 0x04 //
   #define P13SR 0x08 //
   #define P14SR 0x10 //
   #define P15SR 0x20 //
   #define P16SR 0x40 //
   #define P17SR 0x80 //
#define P2SR (*(unsigned char volatile xdata *)0xfe22) //Port 2 Slew Rate Control Register
   #define P20SR 0x01 //
   #define P21SR 0x02 //
   #define P22SR 0x04 //
   #define P23SR 0x08 //
   #define P24SR 0x10 //
   #define P25SR 0x20 //
   #define P26SR 0x40 //
   #define P27SR 0x80 //
#define P3SR (*(unsigned char volatile xdata *)0xfe23) //Port 3 Slew Rate Control Register
   #define P30SR 0x01 //
   #define P31SR 0x02 //
   #define P32SR 0x04 //
   #define P33SR 0x08 //
   #define P34SR 0x10 //
   #define P35SR 0x20 //
   #define P36SR 0x40 //
   #define P37SR 0x80 //
#define P4SR (*(unsigned char volatile xdata *)0xfe24) //Port 4 Slew Rate Control Register
   #define P40SR 0x01 //
   #define P41SR 0x02 //
   #define P42SR 0x04 //
   #define P43SR 0x08 //
   #define P44SR 0x10 //
   #define P45SR 0x20 //
   #define P46SR 0x40 //
   #define P47SR 0x80 //
#define P5SR (*(unsigned char volatile xdata *)0xfe25) //Port 5 Slew Rate Control Register
   #define P50SR 0x01 //
   #define P51SR 0x02 //
   #define P52SR 0x04 //
   #define P53SR 0x08 //
   #define P54SR 0x10 //
   #define P55SR 0x20 //
#define P6SR (*(unsigned char volatile xdata *)0xfe26) //Port 6 Slew Rate Control Register
   #define P60SR 0x01 //
   #define P61SR 0x02 //
   #define P62SR 0x04 //
   #define P63SR 0x08 //
   #define P64SR 0x10 //
   #define P65SR 0x20 //
   #define P66SR 0x40 //
   #define P67SR 0x80 //
#define P7SR (*(unsigned char volatile xdata *)0xfe27) //Port 7 Slew Rate Control Register
   #define P70SR 0x01 //
   #define P71SR 0x02 //
   #define P72SR 0x04 //
   #define P73SR 0x08 //
   #define P74SR 0x10 //
   #define P75SR 0x20 //
   #define P76SR 0x40 //
   #define P77SR 0x80 //
#define P0DR (*(unsigned char volatile xdata *)0xfe28) //Port 0 Drive Current Control Register
   #define P00DR 0x01 //
   #define P01DR 0x02 //
   #define P02DR 0x04 //
   #define P03DR 0x08 //
   #define P04DR 0x10 //
   #define P05DR 0x20 //
   #define P06DR 0x40 //
   #define P07DR 0x80 //
#define P1DR (*(unsigned char volatile xdata *)0xfe29) //Port 1 Drive Current Control Register
   #define P10DR 0x01 //
   #define P11DR 0x02 //
   #define P12DR 0x04 //
   #define P13DR 0x08 //
   #define P14DR 0x10 //
   #define P15DR 0x20 //
   #define P16DR 0x40 //
   #define P17DR 0x80 //
#define P2DR (*(unsigned char volatile xdata *)0xfe2a) //Port 2 Drive Current Control Register
   #define P20DR 0x01 //
   #define P21DR 0x02 //
   #define P22DR 0x04 //
   #define P23DR 0x08 //
   #define P24DR 0x10 //
   #define P25DR 0x20 //
   #define P26DR 0x40 //
   #define P27DR 0x80 //
#define P3DR (*(unsigned char volatile xdata *)0xfe2b) //Port 3 Drive Current Control Register
   #define P30DR 0x01 //
   #define P31DR 0x02 //
   #define P32DR 0x04 //
   #define P33DR 0x08 //
   #define P34DR 0x10 //
   #define P35DR 0x20 //
   #define P36DR 0x40 //
   #define P37DR 0x80 //
#define P4DR (*(unsigned char volatile xdata *)0xfe2c) //Port 4 Drive Current Control Register
   #define P40DR 0x01 //
   #define P41DR 0x02 //
   #define P42DR 0x04 //
   #define P43DR 0x08 //
   #define P44DR 0x10 //
   #define P45DR 0x20 //
   #define P46DR 0x40 //
   #define P47DR 0x80 //
#define P5DR (*(unsigned char volatile xdata *)0xfe2d) //Port 5 Drive Current Control Register
   #define P50DR 0x01 //
   #define P51DR 0x02 //
   #define P52DR 0x04 //
   #define P53DR 0x08 //
   #define P54DR 0x10 //
   #define P55DR 0x20 //
#define P6DR (*(unsigned char volatile xdata *)0xfe2e) //Port 6 Drive Current Control Register
   #define P60DR 0x01 //
   #define P61DR 0x02 //
   #define P62DR 0x04 //
   #define P63DR 0x08 //
   #define P64DR 0x10 //
   #define P65DR 0x20 //
   #define P66DR 0x40 //
   #define P67DR 0x80 //
#define P7DR (*(unsigned char volatile xdata *)0xfe2f) //Port 7 Drive Current Control Register
   #define P70DR 0x01 //
   #define P71DR 0x02 //
   #define P72DR 0x04 //
   #define P73DR 0x08 //
   #define P74DR 0x10 //
   #define P75DR 0x20 //
   #define P76DR 0x40 //
   #define P77DR 0x80 //
#define P0IE (*(unsigned char volatile xdata *)0xfe30) //Port 0 Digital Input Enable Register
   #define P00IE 0x01 //
   #define P01IE 0x02 //
   #define P02IE 0x04 //
   #define P03IE 0x08 //
   #define P04IE 0x10 //
   #define P05IE 0x20 //
   #define P06IE 0x40 //
   #define P07IE 0x80 //
#define P1IE (*(unsigned char volatile xdata *)0xfe31) //Port 1 Digital Input Enable Register
   #define P10IE 0x01 //
   #define P11IE 0x02 //
   #define P12IE 0x04 //
   #define P13IE 0x08 //
   #define P14IE 0x10 //
   #define P15IE 0x20 //
   #define P16IE 0x40 //
   #define P17IE 0x80 //
#define P2IE (*(unsigned char volatile xdata *)0xfe32) //Port 2 Digital Input Enable Register
   #define P20IE 0x01 //
   #define P21IE 0x02 //
   #define P22IE 0x04 //
   #define P23IE 0x08 //
   #define P24IE 0x10 //
   #define P25IE 0x20 //
   #define P26IE 0x40 //
   #define P27IE 0x80 //
#define P3IE (*(unsigned char volatile xdata *)0xfe33) //Port 3 Digital Input Enable Register
   #define P30IE 0x01 //
   #define P31IE 0x02 //
   #define P32IE 0x04 //
   #define P33IE 0x08 //
   #define P34IE 0x10 //
   #define P35IE 0x20 //
   #define P36IE 0x40 //
   #define P37IE 0x80 //
#define P4IE (*(unsigned char volatile xdata *)0xfe34) //Port 4 Digital Input Enable Register
   #define P40IE 0x01 //
   #define P41IE 0x02 //
   #define P42IE 0x04 //
   #define P43IE 0x08 //
   #define P44IE 0x10 //
   #define P45IE 0x20 //
   #define P46IE 0x40 //
   #define P47IE 0x80 //
#define P5IE (*(unsigned char volatile xdata *)0xfe35) //Port 5 Digital Input Enable Register
   #define P50IE 0x01 //
   #define P51IE 0x02 //
   #define P52IE 0x04 //
   #define P53IE 0x08 //
   #define P54IE 0x10 //
   #define P55IE 0x20 //
#define P6IE (*(unsigned char volatile xdata *)0xfe36) //Port 6 Digital Input Enable Register
   #define P60IE 0x01 //
   #define P61IE 0x02 //
   #define P62IE 0x04 //
   #define P63IE 0x08 //
   #define P64IE 0x10 //
   #define P65IE 0x20 //
   #define P66IE 0x40 //
   #define P67IE 0x80 //
#define P7IE (*(unsigned char volatile xdata *)0xfe37) //Port 7 Digital Input Enable Register
   #define P70IE 0x01 //
   #define P71IE 0x02 //
   #define P72IE 0x04 //
   #define P73IE 0x08 //
   #define P74IE 0x10 //
   #define P75IE 0x20 //
   #define P76IE 0x40 //
   #define P77IE 0x80 //
#define LCMIFCFG (*(unsigned char volatile xdata *)0xfe50) //LC Module Interface Config Register
   #define M68_I80  0x01 //Mode Select Motorola-6800 or Intel-8080
   #define D16_D8   0x02 //Data Width Select 16 or 8 bits
   #define LCMIFDPS 0x0C //LC Module Interface Data Pin Select
   #define LCMIFIP  0x30 //LC Module Interface Interrupt Priority
   #define LCMIFIE  0x80 //LC Module Interface Interrupt Enable
#define LCMIFCFG2 (*(unsigned char volatile xdata *)0xfe51) //LC Module Interface Config Register 2
   #define HOLDT    0x03 //Data Hold Time Control
   #define SETUPT   0x1C //Data Setup Time Control
   #define LCMIFCPS 0x60 //LC Module Interface Control Pin Select
#define LCMIFCR (*(unsigned char volatile xdata *)0xfe52) //LC Module Interface Control Register
   #define LCMIFCMD 0x07 //LC Module Interface Trigger Command
   #define ENLCMIF  0x80 //Enable LC Module Interface
#define LCMIFSTA (*(unsigned char volatile xdata *)0xfe53) //LC Module Interface Status Register
   #define LCMIFIF 0x01 //LC Module Interface 
#define LCMIDDATL (*(unsigned char volatile xdata *)0xfe54) //LC Module Interface Low Byte Data
#define LCMIDDATH (*(unsigned char volatile xdata *)0xfe55) //LC Module Interface High Byte Data
#define RTCCR (*(unsigned char volatile xdata *)0xfe60) //Real Time Clock Control Register
   #define RUNRTC 0x01 //Real Time Clock Run-Stop
#define RTCCFG (*(unsigned char volatile xdata *)0xfe61) //Real Time Clock Config Register
   #define SETRTC 0x01 //Set Real Time Clock
   #define RTCCKS 0x02 //Real Time Clock Clock-Source Select
#define RTCIEN (*(unsigned char volatile xdata *)0xfe62) //Real Time Clock Interrupt Enable
   #define ESEC32I 0x01 //Enable 1/32s Interrupt
   #define ESEC8I  0x02 //Enable 1/8s Interrupt
   #define ESEC2I  0x04 //Enable 1/2s Interrupt
   #define ESECI   0x08 //Enable Seconds Interrupt
   #define EMINI   0x10 //Enable Minutes Interrupt
   #define EHOURI  0x20 //Enable Hourly Interrupt
   #define EDAYI   0x40 //Enable Daily Interrupt
   #define EALAI   0x80 //Enable Alarm Interrupt
#define RTCIF (*(unsigned char volatile xdata *)0xfe63) //Real Time Clock Interrupt Flag
   #define SEC32IF 0x01 //1/32s Interrupt Flag
   #define SEC8IF  0x02 //1/8s Interrupt Flag
   #define SEC2IF  0x04 //1/2s Interrupt Flag
   #define SECIF   0x08 //Seconds Interrupt Flag
   #define MINIF   0x10 //Minutes Interrupt Flag
   #define HOURIF  0x20 //Hourly Interrupt Flag
   #define DAYIF   0x40 //Daily Interrupt Flag
   #define ALAIF   0x80 //Alarm Interrupt Flag
#define ALAHOUR (*(unsigned char volatile xdata *)0xfe64) //Alarm Hour Value
#define ALAMIN (*(unsigned char volatile xdata *)0xfe65) //Alarm Minute Value
#define ALASEC (*(unsigned char volatile xdata *)0xfe66) //Alarm Second Value
#define ALASSEC (*(unsigned char volatile xdata *)0xfe67) //Alarm Subsecond 1/127s Value
#define INIYEAR (*(unsigned char volatile xdata *)0xfe68) //Initialize Year
#define INIMONTH (*(unsigned char volatile xdata *)0xfe69) //Initialize Month
#define INIDAY (*(unsigned char volatile xdata *)0xfe6a) //Initialize Day
#define INIHOUR (*(unsigned char volatile xdata *)0xfe6b) //Initialize Hour
#define INIMIN (*(unsigned char volatile xdata *)0xfe6c) //Initialize Minute
#define INISEC (*(unsigned char volatile xdata *)0xfe6d) //Initialize Second
#define INISSEC (*(unsigned char volatile xdata *)0xfe6e) //Initialize Subsecond 1/127s
#define YEAR (*(unsigned char volatile xdata *)0xfe70) //Current Year
#define MONTH (*(unsigned char volatile xdata *)0xfe71) //Current Month
#define DAY (*(unsigned char volatile xdata *)0xfe72) //Current Day
#define HOUR (*(unsigned char volatile xdata *)0xfe73) //Current Hour
#define MIN (*(unsigned char volatile xdata *)0xfe74) //Current Minute
#define SEC (*(unsigned char volatile xdata *)0xfe75) //Current Second
#define SSEC (*(unsigned char volatile xdata *)0xfe76) //Current Subsecond 1/127s
#define I2CCFG (*(unsigned char volatile xdata *)0xfe80) //I2C configuration
   #define MSSPEED 0x3F //I2C Bus Speed Selection
   #define MSSL    0x40 //Master or Slave Mode Select
   #define ENI2C   0x80 //Enable I2C Functionality
#define I2CMSCR (*(unsigned char volatile xdata *)0xfe81) //I2C Master Control
   #define MSCMD 0x0F //Master Command Execution
   #define EMSI  0x80 //Enable Master Interrupt
#define I2CMSST (*(unsigned char volatile xdata *)0xfe82) //I2C Master Status
   #define MSACKO 0x01 //Master Mode Output ACK
   #define MSACKI 0x02 //Master Mode Input ACK
   #define MSIF   0x40 //Master Mode Interrupt Flag
   #define MSBUSY 0x80 //Master Busy Flag
#define I2CSLCR (*(unsigned char volatile xdata *)0xfe83) //I2C Slave Control
   #define SLRST 0x01 //Slave Reset Mode
   #define ESTOI 0x08 //Enable Interrupt after STOP is received in Slave Mode
   #define ETXI  0x10 //Enable Interrupt after data is sent in Slave Mode
   #define ERXI  0x20 //Enable Interrupt after data is received in Slave Mode
   #define ESTAI 0x40 //Enable Interrupt after START is received in Slave Mode
#define I2CSLST (*(unsigned char volatile xdata *)0xfe84) //I2C Slave Status
   #define SLACKO 0x01 //Slave ACK Output Flag
   #define SLACKI 0x02 //Slave ACK Input Flag
   #define TXING  0x04 //Undocumented
   #define STOIF  0x08 //STOP signal Interrupt Flag
   #define TXIF   0x10 //Transmit Data Interrupt Flag
   #define RXIF   0x20 //Received Data Interrupt Flag
   #define STAIF  0x40 //START Interrupt Flag in Slave Mode
   #define SLBUSY 0x80 //Slave Busy Flag
#define I2CSLADR (*(unsigned char volatile xdata *)0xfe85) //I2C Slave Address
   #define MA    0x01 //Slave Device Address Matching
   #define SLADR 0xFE //Slave Device Address
#define I2CTXD (*(unsigned char volatile xdata *)0xfe86) //I2C Data Transmit Register
#define I2CRXD (*(unsigned char volatile xdata *)0xfe87) //I2C Data Receive Register
#define I2CMSAUX (*(unsigned char volatile xdata *)0xfe88) //I2C Master Auxiliary Control
   #define WDTA 0x01 //I2C Write Data Automatic Send Enable in Master Module
#define TM2PS (*(unsigned char volatile xdata *)0xfea2) //Timer 2 Prescaler
#define TM3PS (*(unsigned char volatile xdata *)0xfea3) //Timer 3 Prescaler
#define TM4PS (*(unsigned char volatile xdata *)0xfea4) //Timer 4 Prescaler
#define ADCTIM (*(unsigned char volatile xdata *)0xfea8) //ADC Timing Control
   #define SMPDUTY 0x1F //Analog Signal Sampling Time Control
   #define CSHOLD  0x60 //Channel Selection Hold Time Control
   #define CSSETUP 0x80 //Channel Selection Setup Time Control
#define T3T4PIN (*(unsigned char volatile xdata *)0xfeac) //T3 and T4 Pin Select
   #define T3T4SEL 0x01 //T3 and T4 Pin Select
#define ADCEXCFG (*(unsigned char volatile xdata *)0xfead) //ADC Extension Config Register
   #define CVTIMESEL 0x07 //Number of Conversions per Channel
   #define ADCETRS   0x30 //ADC External Trigger Pin Select
#define CMPEXCFG (*(unsigned char volatile xdata *)0xfeae) //Comparator Extension Config Register
   #define CMPPS 0x03 //Comparator Positive Input Pin Select
   #define CMPNS 0x04 //Comparator Negative Input Pin Select
   #define CHYS  0xC0 //Comparator Input Hysterisis Select
#define PWMA_ETRPS (*(unsigned char volatile xdata *)0xfeb0) //PWM A External Trigger Select
#define PWM1_ETRPS (*(unsigned char volatile xdata *)0xfeb0) //(alias)
   #define ETRAPS 0x03 //External Trigger PWM A Pin Select
   #define BRKAPS 0x04 //Fault Brake PWM A Input Pin or Comparator Select
#define PWMA_ENO (*(unsigned char volatile xdata *)0xfeb1) //PWM A Enable Output
#define PWM1_ENO (*(unsigned char volatile xdata *)0xfeb1) //(alias)
   #define ENO1P 0x01 //Output 1P Enable
   #define ENO1N 0x02 //Output 1N Enable
   #define ENO2P 0x04 //Output 2P Enable
   #define ENO2N 0x08 //Output 2N Enable
   #define ENO3P 0x10 //Output 3P Enable
   #define ENO3N 0x20 //Output 3N Enable
   #define ENO4P 0x40 //Output 4P Enable
   #define ENO4N 0x80 //Output 4N Enable
#define PWMA_PS (*(unsigned char volatile xdata *)0xfeb2) //PWM A Output Pin Select
#define PWM1_PS (*(unsigned char volatile xdata *)0xfeb2) //(alias)
   #define C1PS 0x03 //Pin 1N and 1P Select
   #define C2PS 0x0C //Pin 2N and 2P Select
   #define C3PS 0x30 //Pin 3N and 3P Select
   #define C4PS 0xC0 //Pin 4N and 4P Select
#define PWMA_IOAUX (*(unsigned char volatile xdata *)0xfeb3) //PWM A Auxiliary IO Register
#define PWM1_IOAUX (*(unsigned char volatile xdata *)0xfeb3) //(alias)
   #define AUX1P 0x01 //Output 1P Auxiliary Output Control Select
   #define AUX1N 0x02 //Output 1N Auxiliary Output Control Select
   #define AUX2P 0x04 //Output 2P Auxiliary Output Control Select
   #define AUX2N 0x08 //Output 2N Auxiliary Output Control Select
   #define AUX3P 0x10 //Output 3P Auxiliary Output Control Select
   #define AUX3N 0x20 //Output 3N Auxiliary Output Control Select
   #define AUX4P 0x40 //Output 4P Auxiliary Output Control Select
   #define AUX4N 0x80 //Output 4N Auxiliary Output Control Select
#define PWMB_ETRPS (*(unsigned char volatile xdata *)0xfeb4) //PWM B External Trigger Select
#define PWM2_ETRPS (*(unsigned char volatile xdata *)0xfeb4) //(alias)
   #define ETRBPS 0x03 //External Trigger PWM B Pin Select
   #define BRKBPS 0x04 //Fault Brake PWM B Input Pin or Comparator Select
#define PWMB_ENO (*(unsigned char volatile xdata *)0xfeb5) //PWM B Enable Output
#define PWM2_ENO (*(unsigned char volatile xdata *)0xfeb5) //(alias)
   #define ENO5P 0x01 //Output 5P Enable
   #define ENO6P 0x04 //Output 6P Enable
   #define ENO7P 0x10 //Output 7P Enable
   #define ENO8P 0x40 //Output 8P Enable
#define PWMB_PS (*(unsigned char volatile xdata *)0xfeb6) //PWM B Output Pin Select
#define PWM2_PS (*(unsigned char volatile xdata *)0xfeb6) //(alias)
   #define C5PS 0x03 //Pin 5P Select
   #define C6PS 0x0C //Pin 6P Select
   #define C7PS 0x30 //Pin 7P Select
   #define C8PS 0xC0 //Pin 8P Select
#define PWMB_IOAUX (*(unsigned char volatile xdata *)0xfeb7) //PWM B Auxiliary Register
#define PWM2_IOAUX (*(unsigned char volatile xdata *)0xfeb7) //(alias)
   #define AUX5P 0x01 //Output 5P Auxiliary Output Control Select
   #define AUX6P 0x04 //Output 6P Auxiliary Output Control Select
   #define AUX7P 0x10 //Output 7P Auxiliary Output Control Select
   #define AUX8P 0x40 //Output 8P Auxiliary Output Control Select
#define PWMA_CR1 (*(unsigned char volatile xdata *)0xfec0) //PWM A Control Register 1
#define PWM1_CR1 (*(unsigned char volatile xdata *)0xfec0) //(alias)
   #define CENA  0x01 //Enable the PWM A Counters
   #define UDISA 0x02 //PWM A Update Event Generation Disable
   #define URSA  0x04 //PWM A Update Interrupt Request Source
   #define OPMA  0x08 //PWM A One Pulse Mode Counter Control
   #define DIRA  0x10 //Counting Direction of PWM A Counters
   #define CMSA  0x60 //PWM A Central Alignemt Mode Selection
   #define ARPEA 0x80 //PWM A ARR Register Preload Buffer Enable
#define PWMA_CR2 (*(unsigned char volatile xdata *)0xfec1) //PWM A Control Register 2
#define PWM1_CR2 (*(unsigned char volatile xdata *)0xfec1) //(alias)
   #define CCPCA 0x01 //PWM A Capture-Compare Preload Control Selection
   #define COMSA 0x04 //PWM A Capture-Compare Control Selection
   #define MMSA  0x70 //PWM A Main Mode Select
   #define TI1S  0x80 //PWM A TI 1 Pin Selection
#define PWMA_SMCR (*(unsigned char volatile xdata *)0xfec2) //PWM A Input Mode Control Register
#define PWM1_SMCR (*(unsigned char volatile xdata *)0xfec2) //(alias)
   #define SMSA 0x07 //PWM B Clock and Trigger Mode Selection
   #define TSA  0x70 //PWM A Trigger Source Selection
   #define MSMA 0x80 //PWM A Master Mode
#define PWMA_ETR (*(unsigned char volatile xdata *)0xfec3) //PWM A External Trigger Register
#define PWM1_ETR (*(unsigned char volatile xdata *)0xfec3) //(alias)
   #define ETFA  0x0F //PWM A External Trigger Filter
   #define ETPSA 0x30 //PWM A External Trigger Prescaler
   #define ECEA  0x40 //PWM A External Clock Enable
   #define ETP1  0x80 //PWM A External Trigger Polarity
#define PWMA_IER (*(unsigned char volatile xdata *)0xfec4) //PWM A Interrupt Enable Register
#define PWM1_IER (*(unsigned char volatile xdata *)0xfec4) //(alias)
   #define UIEA   0x01 //PWM A Update Interrupt Enable
   #define CC1IE  0x02 //Capture-Compare 1 Enable
   #define CC2IE  0x04 //Capture-Compare 2 Enable
   #define CC3IE  0x08 //Capture-Compare 3 Enable
   #define CC4IE  0x10 //Capture-Compare 4 Enable
   #define COMIEA 0x20 //PWM A Compare Interrupt Enable
   #define TIEA   0x40 //PWM A Trigger Interrupt Enable
   #define BIEA   0x80 //PWM A Brake Interrupt Enable
#define PWMA_SR1 (*(unsigned char volatile xdata *)0xfec5) //PWM A Status Register 1
#define PWM1_SR1 (*(unsigned char volatile xdata *)0xfec5) //(alias)
   #define UIFA   0x01 //PWM A Update Interrupt Flag
   #define CC1IF  0x02 //Capture-Compare 1 Interrupt Flag
   #define CC2IF  0x04 //Capture-Compare 2 Interrupt Flag
   #define CC3IF  0x08 //Capture-Compare 3 Interrupt Flag
   #define CC4IF  0x10 //Capture-Compare 4 Interrupt Flag
   #define COMIFA 0x20 //PWM A Compare Interrupt Flag
   #define TIFA   0x40 //PWM A Trigger Interrupt Flag
   #define BIFA   0x80 //PWM A Brake Interrupt Flag
#define PWMA_SR2 (*(unsigned char volatile xdata *)0xfec6) //PWM A Status Register 2
#define PWM1_SR2 (*(unsigned char volatile xdata *)0xfec6) //(alias)
   #define CC1OF 0x02 //Captue-Compare 1 Duplicate Flag
   #define CC2OF 0x04 //Captue-Compare 2 Duplicate Flag
   #define CC3OF 0x08 //Captue-Compare 3 Duplicate Flag
   #define CC4OF 0x10 //Captue-Compare 4 Duplicate Flag
#define PWMA_EGR (*(unsigned char volatile xdata *)0xfec7) //PWM A Event Generation Register
#define PWM1_EGR (*(unsigned char volatile xdata *)0xfec7) //(alias)
   #define UGA   0x01 //PWM A Update Event Generation
   #define CC1G  0x02 //Capture-Compare Event 1 Generation
   #define CC2G  0x04 //Capture-Compare Event 2 Generation
   #define CC3G  0x08 //Capture-Compare Event 3 Generation
   #define CC4G  0x10 //Capture-Compare Event 4 Generation
   #define COMGA 0x20 //PWM A Capture-Compare Event Generation
   #define TGA   0x40 //PWM A Trigger Event Generation
   #define BGA   0x80 //PWM A Brake Event Generation
#define PWMA_CCMR1 (*(unsigned char volatile xdata *)0xfec8) //PWM A Capture-Compare Mode Register 1
#define PWM1_CCMR1 (*(unsigned char volatile xdata *)0xfec8) //(alias)
   #define CC1S   0x03 //Capture-Compare 1 Configuration
   #define OC1FE  0x04 //Output Compare 1 Fast Mode Enable
   #define OC1PE  0x08 //Output Compare 1 Preload Enable
   #define IC1PSC 0x0C //Input Capture 1 Prescaler
   #define OC1M   0x70 //Output Compare 1 Mode
   #define OC1CE  0x80 //Output Compare 1 Clear Enable
   #define IC1F   0xF0 //Input Capture 1 Filter
#define PWMA_CCMR2 (*(unsigned char volatile xdata *)0xfec9) //PWM A Capture-Compare Mode Register 2
#define PWM1_CCMR2 (*(unsigned char volatile xdata *)0xfec9) //(alias)
   #define CC2S   0x03 //Capture-Compare 2 Configuration
   #define OC2FE  0x04 //Output Compare 2 Fast Mode Enable
   #define OC2PE  0x08 //Output Compare 2 Preload Enable
   #define IC2PSC 0x0C //Input Capture 2 Prescaler
   #define OC2M   0x70 //Output Compare 2 Mode
   #define OC2CE  0x80 //Output Compare 2 Clear Enable
   #define IC2F   0xF0 //Input Capture 2 Filter
#define PWMA_CCMR3 (*(unsigned char volatile xdata *)0xfeca) //PWM A Capture-Compare Mode Register 3
#define PWM1_CCMR3 (*(unsigned char volatile xdata *)0xfeca) //(alias)
   #define CC3S   0x03 //Capture-Compare 3 Configuration
   #define OC3FE  0x04 //Output Compare 3 Fast Mode Enable
   #define OC3PE  0x08 //Output Compare 3 Preload Enable
   #define IC3PSC 0x0C //Input Capture 3 Prescaler
   #define OC3M   0x70 //Output Compare 3 Mode
   #define OC3CE  0x80 //Output Compare 3 Clear Enable
   #define IC3F   0xF0 //Input Capture 3 Filter
#define PWMA_CCMR4 (*(unsigned char volatile xdata *)0xfecb) //PWM A Capture-Compare Mode Register 4
#define PWM1_CCMR4 (*(unsigned char volatile xdata *)0xfecb) //(alias)
   #define CC4S   0x03 //Capture-Compare 4 Configuration
   #define OC4FE  0x04 //Output Compare 4 Fast Mode Enable
   #define OC4PE  0x08 //Output Compare 4 Preload Enable
   #define IC4PSC 0x0C //Input Capture 4 Prescaler
   #define OC4M   0x70 //Output Compare 4 Mode
   #define OC4CE  0x80 //Output Compare 4 Clear Enable
   #define IC4F   0xF0 //Input Capture 4 Filter
#define PWMA_CCER1 (*(unsigned char volatile xdata *)0xfecc) //PWM A Capture-Compare Enable Register 1
#define PWM1_CCER1 (*(unsigned char volatile xdata *)0xfecc) //(alias)
   #define CC1E  0x01 //Input Capture-Compare 1 Ouput Enable
   #define CC1P  0x02 //Input Capture-Compare 1 Output Polarity
   #define CC1NE 0x04 //Input Capture-Compare 1 Negated Output Enable
   #define CC1NP 0x08 //Input Capture-Compare 1 Negated Output Polarity
   #define CC2E  0x10 //Input Capture-Compare 2 Ouput Enable
   #define CC2P  0x20 //Input Capture-Compare 2 Output Polarity
   #define CC2NE 0x40 //Input Capture-Compare 2 Negated Output Enable
   #define CC2NP 0x80 //Input Capture-Compare 2 Negated Polarity
#define PWMA_CCER2 (*(unsigned char volatile xdata *)0xfecd) //PWM A Capture-Compare Enable Register 2
#define PWM1_CCER2 (*(unsigned char volatile xdata *)0xfecd) //(alias)
   #define CC3E  0x01 //Input Capture-Compare 3 Output Enable
   #define CC3P  0x02 //Input Capture-Compare 3 Output Polarity
   #define CC3NE 0x04 //Input Capture-Compare 3 Negated Output Enable
   #define CC3NP 0x08 //Input Capture-Compare 3 Negated Output Polarity
   #define CC4E  0x10 //Input Capture-Compare 4 Output Enable
   #define CC4P  0x20 //Input Capture-Compare 4 Output Polarity
   #define CC4NE 0x40 //Input Capture-Compare 4 Negated Output Enable
   #define CC4NP 0x80 //Input Capture-Compare 4 Negated Output Polarity
#define PWMA_CNTR (*(unsigned  int volatile xdata *)0xfece) //PWM A Counter Word
#define PWM1_CNTR (*(unsigned  int volatile xdata *)0xfece) //(alias)
#define PWMA_CNTRH (*(unsigned char volatile xdata *)0xfece) //PWM A Counter High Byte
#define PWM1_CNTRH (*(unsigned char volatile xdata *)0xfece) //(alias)
#define PWMA_CNTRL (*(unsigned char volatile xdata *)0xfecf) //PWM A Counter Low Byte
#define PWM1_CNTRL (*(unsigned char volatile xdata *)0xfecf) //(alias)
#define PWMA_PSCR (*(unsigned  int volatile xdata *)0xfed0) //PWM A Prescaler Word
#define PWM1_PSCR (*(unsigned  int volatile xdata *)0xfed0) //(alias)
#define PWMA_PSCRH (*(unsigned char volatile xdata *)0xfed0) //PWM A Prescaler High Byte
#define PWM1_PSCRH (*(unsigned char volatile xdata *)0xfed0) //(alias)
#define PWMA_PSCRL (*(unsigned char volatile xdata *)0xfed1) //PWM A Prescaler Low Byte
#define PWM1_PSCRL (*(unsigned char volatile xdata *)0xfed1) //(alias)
#define PWMA_ARR (*(unsigned  int volatile xdata *)0xfed2) //Automatic Reload Register Word
#define PWM1_ARR (*(unsigned  int volatile xdata *)0xfed2) //(alias)
#define PWMA_ARRH (*(unsigned char volatile xdata *)0xfed2) //Automatic Reload Register High Byte
#define PWM1_ARRH (*(unsigned char volatile xdata *)0xfed2) //(alias)
#define PWMA_ARRL (*(unsigned char volatile xdata *)0xfed3) //Automatic Reload Register Low Byte
#define PWM1_ARRL (*(unsigned char volatile xdata *)0xfed3) //(alias)
#define PWMA_RCR (*(unsigned char volatile xdata *)0xfed4) //Repeat Counter Register
#define PWM1_RCR (*(unsigned char volatile xdata *)0xfed4) //(alias)
#define PWMA_CCR1 (*(unsigned  int volatile xdata *)0xfed5) //Capture Compare Register 1 Word
#define PWM1_CCR1 (*(unsigned  int volatile xdata *)0xfed5) //(alias)
#define PWMA_CCR1H (*(unsigned char volatile xdata *)0xfed5) //Capture Compare Register 1 High Byte
#define PWM1_CCR1H (*(unsigned char volatile xdata *)0xfed5) //(alias)
#define PWMA_CCR1L (*(unsigned char volatile xdata *)0xfed6) //Capture Compare Register 1 Low Byte
#define PWM1_CCR1L (*(unsigned char volatile xdata *)0xfed6) //(alias)
#define PWMA_CCR2 (*(unsigned  int volatile xdata *)0xfed7) //Capture Compare Register 2 Word
#define PWM1_CCR2 (*(unsigned  int volatile xdata *)0xfed7) //(alias)
#define PWMA_CCR2H (*(unsigned char volatile xdata *)0xfed7) //Capture Compare Register 2 High Byte
#define PWM1_CCR2H (*(unsigned char volatile xdata *)0xfed7) //(alias)
#define PWMA_CCR2L (*(unsigned char volatile xdata *)0xfed8) //Capture Compare Register 2 Low Byte
#define PWM1_CCR2L (*(unsigned char volatile xdata *)0xfed8) //(alias)
#define PWMA_CCR3 (*(unsigned  int volatile xdata *)0xfed9) //Capture Compare Register 3 Word
#define PWM1_CCR3 (*(unsigned  int volatile xdata *)0xfed9) //(alias)
#define PWMA_CCR3H (*(unsigned char volatile xdata *)0xfed9) //Capture Compare Register 3 High Byte
#define PWM1_CCR3H (*(unsigned char volatile xdata *)0xfed9) //(alias)
#define PWMA_CCR3L (*(unsigned char volatile xdata *)0xfeda) //Capture Compare Register 3 Low Byte
#define PWM1_CCR3L (*(unsigned char volatile xdata *)0xfeda) //(alias)
#define PWMA_CCR4 (*(unsigned  int volatile xdata *)0xfedb) //Capture Compare Register 4 Word
#define PWM1_CCR4 (*(unsigned  int volatile xdata *)0xfedb) //(alias)
#define PWMA_CCR4H (*(unsigned char volatile xdata *)0xfedb) //Capture Compare Register 4 High Byte
#define PWM1_CCR4H (*(unsigned char volatile xdata *)0xfedb) //(alias)
#define PWMA_CCR4L (*(unsigned char volatile xdata *)0xfedc) //Capture Compare Register 4 Low Byte
#define PWM1_CCR4L (*(unsigned char volatile xdata *)0xfedc) //(alias)
#define PWMA_BKR (*(unsigned char volatile xdata *)0xfedd) //PWM A Brake Register
#define PWM1_BKR (*(unsigned char volatile xdata *)0xfedd) //(alias)
   #define LOCK 0x03 //Register Write Protect Lock Setting
   #define OSSI 0x04 //Off Status Select in Idle Mode
   #define OSSR 0x08 //Off Status Select in Run Mode
   #define BKE  0x10 //Brake Function Enable
   #define BKP  0x20 //Brake Input Polarity
   #define AOE  0x40 //Automatic Output Enable
   #define MOE  0x80 //Main Output Enable
#define PWMA_DTR (*(unsigned char volatile xdata *)0xfede) //PWM A Dead Time Control
#define PWM1_DTR (*(unsigned char volatile xdata *)0xfede) //(alias)
   #define DTGA 0xFF //Dead Time Generator A Setting
#define PWMA_OISR (*(unsigned char volatile xdata *)0xfedf) //PWM A Output Idle State Register
#define PWM1_OISR (*(unsigned char volatile xdata *)0xfedf) //(alias)
   #define OIS1  0x01 //OC1 Output Level in Idle State
   #define OIS1N 0x02 //OC1N Output Leve in Idle State
   #define OIS2  0x04 //OC2 Output Level in Idle State
   #define OIS2N 0x08 //OC2N Output Leve in Idle State
   #define OIS3  0x10 //OC3 Output Level in Idle State
   #define OIS3N 0x20 //OC3N Output Leve in Idle State
   #define OIS4  0x40 //OC4 Output Level in Idle State
   #define OIS4N 0x80 //OC4N Output Leve in Idle State
#define PWMB_CR1 (*(unsigned char volatile xdata *)0xfee0) //PWM B Control Register 1
#define PWM2_CR1 (*(unsigned char volatile xdata *)0xfee0) //(alias)
   #define CENB  0x01 //Enable the PWM B Counters
   #define UDISB 0x02 //PWM B Update Event Generation Disable
   #define URSB  0x04 //PWM B Update Interrupt Request Source
   #define OPMB  0x08 //PWM B One Pulse Mode Counter Control
   #define DIRB  0x10 //Counting Direction of PWM B Counters
   #define CMSB  0x60 //PWM B Central Alignemt Mode Selection
   #define ARPEB 0x80 //PWM B ARR Register Preload Buffer Enable
#define PWMB_CR2 (*(unsigned char volatile xdata *)0xfee1) //PWM B Control Register 2
#define PWM2_CR2 (*(unsigned char volatile xdata *)0xfee1) //(alias)
   #define CCPCB 0x01 //PWM B Capture-Compare Preload Control Selection
   #define COMSB 0x04 //PWM B Capture-Compare Control Selection
   #define MMSB  0x70 //PWM B Main Mode Select
   #define TI5S  0x80 //PWM B TI 5 Pin Selection
#define PWMB_SMCR (*(unsigned char volatile xdata *)0xfee2) //PWM B Input Mode Control Register
#define PWM2_SMCR (*(unsigned char volatile xdata *)0xfee2) //(alias)
   #define SMSB 0x07 //PWM B Clock and Trigger Mode Selection
   #define TSB  0x70 //PWM B Trigger Source Selection
   #define MSMB 0x80 //PWM B Master Mode
#define PWMB_ETR (*(unsigned char volatile xdata *)0xfee3) //PWM B External Trigger Register
#define PWM2_ETR (*(unsigned char volatile xdata *)0xfee3) //(alias)
   #define ETFB  0x0F //PWM B External Trigger Filter
   #define ETPSB 0x30 //PWM B External Trigger Prescaler
   #define ECEB  0x40 //PWM B External Clock Enable
   #define ETP2  0x80 //PWM B External Trigger Polarity
#define PWMB_IER (*(unsigned char volatile xdata *)0xfee4) //PWM B Interrupt Enable Register
#define PWM2_IER (*(unsigned char volatile xdata *)0xfee4) //(alias)
   #define UIEB   0x01 //PWM B Update Interrupt Enable
   #define CC5IE  0x02 //Capture-Compare 5 Enable
   #define CC6IE  0x04 //Capture-Compare 6 Enable
   #define CC7IE  0x08 //Capture-Compare 7 Enable
   #define CC8IE  0x10 //Capture-Compare 8 Enable
   #define COMIEB 0x20 //PWM B Compare Interrupt Enable
   #define TIEB   0x40 //PWM B Trigger Interrupt Enable
   #define BIEB   0x80 //PWM B Brake Interrupt Enable
#define PWMB_SR1 (*(unsigned char volatile xdata *)0xfee5) //PWM B Status Register 1
#define PWM2_SR1 (*(unsigned char volatile xdata *)0xfee5) //(alias)
   #define UIFB   0x01 //PWM B Update Interrupt Flag
   #define CC5IF  0x02 //Capture-Compare 5 Interrupt Flag
   #define CC6IF  0x04 //Capture-Compare 6 Interrupt Flag
   #define CC7IF  0x08 //Capture-Compare 7 Interrupt Flag
   #define CC8IF  0x10 //Capture-Compare 8 Interrupt Flag
   #define COMIFB 0x20 //PWM B Compare Interrupt Flag
   #define TIFB   0x40 //PWM B Trigger Interrupt Flag
   #define BIFB   0x80 //PWM B Brake Interrupt Flag
#define PWMB_SR2 (*(unsigned char volatile xdata *)0xfee6) //PWM B Status Register 2
#define PWM2_SR2 (*(unsigned char volatile xdata *)0xfee6) //(alias)
   #define CC5OF 0x02 //Captue-Compare 1 Duplicate Flag
   #define CC6OF 0x04 //Captue-Compare 2 Duplicate Flag
   #define CC7OF 0x08 //Captue-Compare 3 Duplicate Flag
   #define CC8OF 0x10 //Captue-Compare 4 Duplicate Flag
#define PWMB_EGR (*(unsigned char volatile xdata *)0xfee7) //PWM B Event Generation Register
#define PWM2_EGR (*(unsigned char volatile xdata *)0xfee7) //(alias)
   #define UGB   0x01 //PWM B Update Event Generation
   #define CC1G  0x02 //Capture-Compare Event 5 Generation
   #define CC2G  0x04 //Capture-Compare Event 6 Generation
   #define CC3G  0x08 //Capture-Compare Event 7 Generation
   #define CC4G  0x10 //Capture-Compare Event 8 Generation
   #define COMGB 0x20 //PWM B Capture-Compare Event Generation
   #define TGB   0x40 //PWM B  Trigger Event Generation
   #define BGB   0x80 //PWM B Brake Event Generation
#define PWMB_CCMR1 (*(unsigned char volatile xdata *)0xfee8) //PWM B Capture-Compare Mode Register 1
#define PWM2_CCMR1 (*(unsigned char volatile xdata *)0xfee8) //(alias)
   #define CC5S   0x03 //Capture-Compare Channel 5 Configuration
   #define OC5FE  0x04 //Output Compare Channel 5 Fast Mode Enable
   #define OC5PE  0x08 //Output Compare Channel 5 Preload Enable
   #define IC5PSC 0x0C //Input Capture Channel 5 Prescaler
   #define OC5M   0x70 //Output Compare Channel 5 Mode
   #define OC5CE  0x80 //Output Compare Channel 5 Clear Enable
   #define IC5F   0xF0 //Input Capture Channel 5 Filter
#define PWMB_CCMR2 (*(unsigned char volatile xdata *)0xfee9) //PWM B Capture-Compare Mode Register 2
#define PWM2_CCMR2 (*(unsigned char volatile xdata *)0xfee9) //(alias)
   #define CC6S   0x03 //Capture-Compare Channel 6 Configuration
   #define OC6FE  0x04 //Output Compare Channel 6 Fast Mode Enable
   #define OC6PE  0x08 //Output Compare Channel 6 Preload Enable
   #define IC6PSC 0x0C //Input Capture Channel 6 Prescaler
   #define OC6M   0x70 //Output Compare Channel 6 Mode
   #define OC6CE  0x80 //Output Compare Channel 6 Clear Enable
   #define IC6F   0xF0 //Input Capture Channel 6 Filter
#define PWMB_CCMR3 (*(unsigned char volatile xdata *)0xfeea) //PWM B Capture-Compare Mode Register 3
#define PWM2_CCMR3 (*(unsigned char volatile xdata *)0xfeea) //(alias)
   #define CC7S   0x03 //Capture-Compare Channel 7 Configuration
   #define OC7FE  0x04 //Output Compare Channel 7 Fast Mode Enable
   #define OC7PE  0x08 //Output Compare Channel 7 Preload Enable
   #define IC7PSC 0x0C //Input Capture Channel 7 Prescaler
   #define OC7M   0x70 //Output Compare Channel 7 Mode
   #define OC7CE  0x80 //Output Compare Channel 7 Clear Enable
   #define IC7F   0xF0 //Input Capture Channel 7 Filter
#define PWMB_CCMR4 (*(unsigned char volatile xdata *)0xfeeb) //PWM B Capture-Compare Mode Register 4
#define PWM2_CCMR4 (*(unsigned char volatile xdata *)0xfeeb) //(alias)
   #define CC8S   0x03 //Capture-Compare Channel 8 Configuration
   #define OC8FE  0x04 //Output Compare Channel 8 Fast Mode Enable
   #define OC8PE  0x08 //Output Compare Channel 8 Preload Enable
   #define IC8PSC 0x0C //Input Capture Channel 8 Prescaler
   #define OC8M   0x70 //Output Compare Channel 8 Mode
   #define OC8CE  0x80 //Output Compare Channel 8 Clear Enable
   #define IC8F   0xF0 //Input Capture Channel 8 Filter
#define PWMB_CCER1 (*(unsigned char volatile xdata *)0xfeec) //PWM B Capture-Compare Enable Register 1
#define PWM2_CCER1 (*(unsigned char volatile xdata *)0xfeec) //(alias)
   #define CC5E  0x01 //Input Capture-Compare 5 Ouput Enable
   #define CC5P  0x02 //Input Capture-Compare 5 Output Polarity
   #define CC6E  0x10 //Input Capture-Compare 6 Ouput Enable
   #define CC6P  0x20 //Input Capture-Compare 6 Output Polarity
#define PWMB_CCER2 (*(unsigned char volatile xdata *)0xfeed) //PWM B Capture-Compare Enable Register 2
#define PWM2_CCER2 (*(unsigned char volatile xdata *)0xfeed) //(alias)
   #define CC7E  0x01 //Input Capture-Compare 7 Output Enable
   #define CC7P  0x02 //Input Capture-Compare 7 Output Polarity
   #define CC8E  0x10 //Input Capture-Compare 8 Output Enable
   #define CC8P  0x20 //Input Capture-Compare 8 Output Polarity
#define PWMB_CNTR (*(unsigned  int volatile xdata *)0xfeee) //PWM B Counter Word
#define PWM2_CNTR (*(unsigned  int volatile xdata *)0xfeee) //(alias)
#define PWMB_CNTRH (*(unsigned char volatile xdata *)0xfeee) //PWM B Counter High Byte
#define PWM2_CNTRH (*(unsigned char volatile xdata *)0xfeee) //(alias)
#define PWMB_CNTRL (*(unsigned char volatile xdata *)0xfeef) //PWM B Counter Low Byte
#define PWM2_CNTRL (*(unsigned char volatile xdata *)0xfeef) //(alias)
#define PWMB_PSCR (*(unsigned  int volatile xdata *)0xfef0) //PWM B Prescaler Word
#define PWM2_PSCR (*(unsigned  int volatile xdata *)0xfef0) //(alias)
#define PWMB_PSCRH (*(unsigned char volatile xdata *)0xfef0) //PWM B Prescaler High Byte
#define PWM2_PSCRH (*(unsigned char volatile xdata *)0xfef0) //(alias)
#define PWMB_PSCRL (*(unsigned char volatile xdata *)0xfef1) //PWM B Prescaler Low Byte
#define PWM2_PSCRL (*(unsigned char volatile xdata *)0xfef1) //(alias)
#define PWMB_ARR (*(unsigned  int volatile xdata *)0xfef2) //Automatic Reload Register Word
#define PWM2_ARR (*(unsigned  int volatile xdata *)0xfef2) //(alias)
#define PWMB_ARRH (*(unsigned char volatile xdata *)0xfef2) //Automatic Reload Register High Byte
#define PWM2_ARRH (*(unsigned char volatile xdata *)0xfef2) //(alias)
#define PWMB_ARRL (*(unsigned char volatile xdata *)0xfef3) //Automatic Reload Register Low Byte
#define PWM2_ARRL (*(unsigned char volatile xdata *)0xfef3) //(alias)
#define PWMB_RCR (*(unsigned char volatile xdata *)0xfef4) //Repeat Counter Register
#define PWM2_RCR (*(unsigned char volatile xdata *)0xfef4) //(alias)
#define PWMB_CCR5 (*(unsigned  int volatile xdata *)0xfef5) //Capture Compare Register 5 Word
#define PWM2_CCR5 (*(unsigned  int volatile xdata *)0xfef5) //(alias)
#define PWMB_CCR5H (*(unsigned char volatile xdata *)0xfef5) //Capture Compare Register 5 High Byte
#define PWM2_CCR5H (*(unsigned char volatile xdata *)0xfef5) //(alias)
#define PWMB_CCR5L (*(unsigned char volatile xdata *)0xfef6) //Capture Compare Register 5 Low Byte
#define PWM2_CCR1L (*(unsigned char volatile xdata *)0xfef6) //(alias)
#define PWMB_CCR6 (*(unsigned  int volatile xdata *)0xfef7) //Capture Compare Register 6 Word
#define PWM2_CCR6 (*(unsigned  int volatile xdata *)0xfef7) //(alias)
#define PWMB_CCR6H (*(unsigned char volatile xdata *)0xfef7) //Capture Compare Register 6 High Byte
#define PWM2_CCR6H (*(unsigned char volatile xdata *)0xfef7) //(alias)
#define PWMB_CCR6L (*(unsigned char volatile xdata *)0xfef8) //Capture Compare Register 6 Low Byte
#define PWM2_CCR6L (*(unsigned char volatile xdata *)0xfef8) //(alias)
#define PWMB_CCR7 (*(unsigned  int volatile xdata *)0xfef9) //Capture Compare Register 7 Word
#define PWM2_CCR7 (*(unsigned  int volatile xdata *)0xfef9) //(alias)
#define PWMB_CCR7H (*(unsigned char volatile xdata *)0xfef9) //Capture Compare Register 7 High Byte
#define PWM2_CCR7H (*(unsigned char volatile xdata *)0xfef9) //(alias)
#define PWMB_CCR7L (*(unsigned char volatile xdata *)0xfefa) //Capture Compare Register 7 Low Byte
#define PWM2_CCR7L (*(unsigned char volatile xdata *)0xfefa) //(alias)
#define PWMB_CCR8 (*(unsigned  int volatile xdata *)0xfefb) //Capture Compare Register 8 Word
#define PWM2_CCR8 (*(unsigned  int volatile xdata *)0xfefb) //(alias)
#define PWMB_CCR8H (*(unsigned char volatile xdata *)0xfefb) //Capture Compare Register 8 High Byte
#define PWM2_CCR8H (*(unsigned char volatile xdata *)0xfefb) //(alias)
#define PWMB_CCR8L (*(unsigned char volatile xdata *)0xfefc) //Capture Compare Register 8 Low Byte
#define PWM2_CCR8L (*(unsigned char volatile xdata *)0xfefc) //(alias)
#define PWMB_BKR (*(unsigned char volatile xdata *)0xfefd) //PWM A Brake Register
#define PWM2_BKR (*(unsigned char volatile xdata *)0xfefd) //(alias)
   #define LOCK 0x03 //Register Write Protect Lock Setting
   #define OSSI 0x04 //Off Status Select in Idle Mode
   #define OSSR 0x08 //Off Status Select in Run Mode
   #define BKE  0x10 //Brake Function Enable
   #define BKP  0x20 //Brake Input Polarity
   #define AOE  0x40 //Automatic Output Enable
   #define MOE  0x80 //Main Output Enable
#define PWMB_DTR (*(unsigned char volatile xdata *)0xfefe) //PWM B Dead Time Control
#define PWM2_DTR (*(unsigned char volatile xdata *)0xfefe) //(alias)
   #define DTGB 0xFF //Dead Time Generator B Setting
#define PWMB_OISR (*(unsigned char volatile xdata *)0xfeff) //PWM B Output Idle State Register
#define PWM2_OISR (*(unsigned char volatile xdata *)0xfeff) //(alias)
   #define OIS5  0x01 //OC5 Output Level in Idle State
   #define OIS6  0x04 //OC6 Output Level in Idle State
   #define OIS7  0x10 //OC7 Output Level in Idle State
   #define OIS8  0x40 //OC8 Output Level in Idle State

//Interrupt_Address = ( Interrupt_Number * 8 ) + 3
//Vectors are named after their corresponding IE, IP or IR register bit so
//that we don't have to invent names and can be more consistent across MCUs.
   #define X0_VECTOR   0  // 0x03  External Interrupt 0
   #define T0_VECTOR   1  // 0x0B  Timer 0
   #define X1_VECTOR   2  // 0x13  External Interrupt 1
   #define T1_VECTOR   3  // 0x1B  Timer 1
   #define S_VECTOR    4  // 0x23  Serial Port 1
   #define ADC_VECTOR  5  // 0x2B  Analog to Digital Converter
   #define LVD_VECTOR  6  // 0x33  Low Voltage Detect
   #define PCA_VECTOR  7  // 0x3B  Programmable Counter Array (CCP)
   #define S2_VECTOR   8  // 0x43  Serial Port 2
   #define SPI_VECTOR  9  // 0x4B  Serial Peripheral Interface
   #define X2_VECTOR   10 // 0x53  External Interrupt 2
   #define X3_VECTOR   11 // 0x5B  External Interrupt 3
   #define T2_VECTOR   12 // 0x63  Timer 2
   //       -          13    0x6B      -
   //       -          14    0x73  System Reserved
   //       -          15    0x7B  System Reserved
   #define X4_VECTOR   16 // 0x83  External Interrupt 4
   #define S3_VECTOR   17 // 0x8B  Serial Port 3
   #define S4_VECTOR   18 // 0x93  Serial Port 4
   #define T3_VECTOR   19 // 0x9B  Timer 3
   #define T4_VECTOR   20 // 0xA3  Timer 4
   #define CMP_VECTOR  21 // 0xAB  Comparator
   //       -          22 // 0xB3      -
   //       -          23 // 0xBB      -
   #define I2C_VECTOR  24 // 0xC3  Inter-Integrated Circuit (IIC)
   #define USB_VECTOR  25 // 0xCB  Universal Serial Bus Events
   #define PWMA_VECTOR 26 // 0xD3  Pulse Width Modulator A
   #define PWMB_VECTOR 27 // 0xDB  Pulse Width Modulator B
   //       -          28 // 0xE3      -
   //       -          29 // 0xEB      -
   //       -          30 // 0xF3      -
   //       -          31 // 0xFB      -
   //       -          32 // 0x103     -
   //       -          33 // 0x10B     -
   //       -          34 // 0x113     -
   #define TK_VECTOR   35 // 0x11B Touch Key
   #define RTC_VECTOR  36 // 0x123 Real Time Clock
   #define P0_VECTOR   37 // 0x12B Port P0
   #define P1_VECTOR   38 // 0x133 Port P1
   #define P2_VECTOR   39 // 0x13B Port P2
   #define P3_VECTOR   40 // 0x143 Port P3
   #define P4_VECTOR   41 // 0x14B Port P4
   #define P5_VECTOR   42 // 0x153 Port P5
   #define P6_VECTOR   43 // 0x15B Port P6
   #define P7_VECTOR   44 // 0x163 Port P7

#endif
