// PIO compatible header file STC90xAD.h 20210829.
// For use only with STC90xxAD series suffix AD.

#ifndef STC90xAD_H
#define STC90xAD_H
#include <compiler.h>

SFR(P0, 0x80);                  //Port 0
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81);                  //Stack Pointer
SFR(DPTR, 0x82);                //Data Pointer
SFR(DPL,  0x82);                //Data Pointer Low
SFR(DPH, 0x83);                 //Data Pointer High
SFR(PCON, 0x87);                //Power Control
   #define IDL   0x01 //Idle
   #define PD    0x02 //Power Down
   #define STOP  0x02 //Stop
   #define GF0   0x04 //General Flag 0
   #define GF1   0x08 //General Flag 1
   #define POF   0x10 //Power On Flag
   #define SMOD0 0x40 //Serial Mode 0
   #define SMOD  0x80 //Serial Mode
SFR(TCON, 0x88);                //Timer Control
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);                //Timer Mode
   #define T0_M0   0x01 //Timer 0 Mode 0
   #define T0_M1   0x02 //Timer 0 Mode 1
   #define T0_M    0x03 //Timer 0 Mode
   #define T0_CT   0x04 //Timer 0 Counter Timer
   #define T0_GATE 0x08 //Timer 0 Gate
   #define T1_M0   0x10 //Timer 1 Mode 0
   #define T1_M1   0x20 //Timer 1 Mode 1
   #define T1_M    0x30 //Timer 1 Mode
   #define T1_CT   0x40 //Timer 1 Counter Timer
   #define T1_GATE 0x80 //Timer 1 Gate
   #define M00   0x01 //Mode 0 Timer 0
   #define M10   0x02 //Mode 1 Timer 0
   #define M0    0x03 //Timer 0 Mode
   #define CT0   0x04 //Counter Timer 0
   #define GATE0 0x08 //Gate 0
   #define M01   0x10 //Mode 1 Timer 1
   #define M11   0x20 //Mode 1 Timer 1
   #define M1    0x30 //Timer 1 Mode
   #define CT1   0x40 //Counter Timer 1
   #define GATE1 0x80 //Gate 1
SFR(TL0, 0x8A);                 //Timer 0 Low
SFR(TL1, 0x8B);                 //Timer 1 Low
SFR(TH0, 0x8C);                 //Timer 0 High
SFR(TH1, 0x8D);                 //Timer 1 High
SFR(AUXR, 0x8E);                //Auxiliary Register
   #define ALEOFF  0x01 //Address Latch Enable Off
   #define EXTRAM  0x02 //External RAM
   #define UART_P1 0x80 //Uart Port 1
SFR(P1, 0x90);                  //Port 1
   SBIT(T2,   0x90, 0); //Timer 2
   SBIT(T2EX, 0x90, 1); //Timer 2 Extra
   SBIT(ACH0, 0x90, 0); //ADC Channel 0
   SBIT(ACH1, 0x90, 1); //ADC Channel 1
   SBIT(ACH2, 0x90, 2); //ADC Channel 2
   SBIT(ACH3, 0x90, 3); //ADC Channel 3
   SBIT(ACH4, 0x90, 4); //ADC Channel 4
   SBIT(ACH5, 0x90, 5); //ADC Channel 5
   SBIT(ACH6, 0x90, 6); //ADC Channel 6
   SBIT(ACH7, 0x90, 7); //ADC Channel 7
   SBIT(ADC0, 0x90, 0); //AtoD Channel 0
   SBIT(ADC1, 0x90, 1); //AtoD Channel 1
   SBIT(ADC2, 0x90, 2); //AtoD Channel 2
   SBIT(ADC3, 0x90, 3); //AtoD Channel 3
   SBIT(ADC4, 0x90, 4); //AtoD Channel 4
   SBIT(ADC5, 0x90, 5); //AtoD Channel 5
   SBIT(ADC6, 0x90, 6); //AtoD Channel 6
   SBIT(ADC7, 0x90, 7); //AtoD Channel 7
   SBIT(AIN0, 0x90, 0); //Analog Input 0
   SBIT(AIN1, 0x90, 1); //Analog Input 1
   SBIT(AIN2, 0x90, 2); //Analog Input 2
   SBIT(AIN3, 0x90, 3); //Analog Input 3
   SBIT(AIN4, 0x90, 4); //Analog Input 4
   SBIT(AIN5, 0x90, 5); //Analog Input 5
   SBIT(AIN6, 0x90, 6); //Analog Input 6
   SBIT(AIN7, 0x90, 7); //Analog Input 7
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(P1_ADC_EN, 0x97);           //Port 1 Analog to Digital Converter Enable
   #define ADC_P10 0x01 //Analog to Digital Converter Port 1 Bit 0
   #define ADC_P11 0x02 //Analog to Digital Converter Port 1 Bit 1
   #define ADC_P12 0x04 //Analog to Digital Converter Port 1 Bit 2
   #define ADC_P13 0x08 //Analog to Digital Converter Port 1 Bit 3
   #define ADC_P14 0x10 //Analog to Digital Converter Port 1 Bit 4
   #define ADC_P15 0x20 //Analog to Digital Converter Port 1 Bit 5
   #define ADC_P16 0x40 //Analog to Digital Converter Port 1 Bit 6
   #define ADC_P17 0x80 //Analog to Digital Converter Port 1 Bit 7
SFR(SCON, 0x98);              //Serial Control
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error
SFR(SBUF, 0x99);                //Serial Buffer
SFR(P2, 0xA0);                  //Port 2
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P27, 0xA0, 7); //Port 2 Bit 7
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_7, 0xA0, 7); //Port 2 Bit 7
SFR(AUXR1, 0xA2);               //Auxiliary Register 1
   #define DPS 0x01 //Data Pointer Select
   #define GF2 0x08 //General Flag 2
SFR(IE, 0xA8);                  //Interrupt Enable
   SBIT(EX0, 0xA8, 0); //Enable External 0
   SBIT(ET0, 0xA8, 1); //Enable Timer 0
   SBIT(EX1, 0xA8, 2); //Enable External 1
   SBIT(ET1, 0xA8, 3); //Enable Timer 1
   SBIT(ES,  0xA8, 4); //Enable Serial
   SBIT(ET2, 0xA8, 5); //Enable Timer 2
   SBIT(EA,  0xA8, 7); //Enable All
SFR(SADDR, 0xA9);               //Slave Address
SFR(P3, 0xB0);                  //Port 3
   SBIT(RXD,  0xB0, 0); //Receive Data
   SBIT(TXD,  0xB0, 1); //Transmit Data
   SBIT(INT0, 0xB0, 2); //Interrupt 0
   SBIT(INT1, 0xB0, 3); //Interrupt 1
   SBIT(T0,   0xB0, 4); //Timer 0
   SBIT(T1,   0xB0, 5); //Timer 1
   SBIT(WR,   0xB0, 6); //Write
   SBIT(RD,   0xB0, 7); //Read
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
SFR(IPH, 0xB7);                 //Interrupt Priority High
   #define PX0H 0x01 //Priority EXternal 0 High
   #define PT0H 0x02 //Priority Timer 0 High
   #define PX1H 0x04 //Priority External 1 High
   #define PT1H 0x08 //Priority Timer 1 High
   #define PSH  0x10 //Priority Serial High
   #define PT2H 0x20 //Priority Timer 2 High
   #define PX2H 0x40 //Priority External 2 High
   #define PX3H 0x80 //Priority External 3 High
SFR(IP, 0xB8);                  //Interrupt Priority
   SBIT(PX0, 0xB8, 0); //Priority External 0
   SBIT(PT0, 0xB8, 1); //Priority Timer 0
   SBIT(PX1, 0xB8, 2); //Priority External 1
   SBIT(PT1, 0xB8, 3); //Priority Timer 1
   SBIT(PS,  0xB8, 4); //Priority Serial
   SBIT(PT2, 0xB8, 5); //Priority Timer 2
SFR(SADEN, 0xB9);               //Slave Address Enable
SFR(P4, 0xC0);                  //Port 4
   SBIT(INT3, 0xC0, 2); //Interrupt 3
   SBIT(INT2, 0xC0, 3); //Interrupt 4
   SBIT(PSEN, 0xC0, 4); //Program Store Enable
   SBIT(ALE,  0xC0, 5); //Address Latch Enable
   SBIT(EA_P, 0xC0, 6); //External Access Pin
   SBIT(P40,  0xC0, 0); //Port 4 Bit 0
   SBIT(P41,  0xC0, 1); //Port 4 Bit 1
   SBIT(P42,  0xC0, 2); //Port 4 Bit 2
   SBIT(P43,  0xC0, 3); //Port 4 Bit 3
   SBIT(P44,  0xC0, 4); //Port 4 Bit 4
   SBIT(P45,  0xC0, 5); //Port 4 Bit 5(ISP下载需勾选"ALE脚用作P4.5口")
   SBIT(P46,  0xC0, 6); //Port 4 Bit 6
   SBIT(P4_0,  0xC0, 0); //Port 4 Bit 0
   SBIT(P4_1,  0xC0, 1); //Port 4 Bit 1
   SBIT(P4_2,  0xC0, 2); //Port 4 Bit 2
   SBIT(P4_3,  0xC0, 3); //Port 4 Bit 3
   SBIT(P4_4,  0xC0, 4); //Port 4 Bit 4
   SBIT(P4_5,  0xC0, 5); //Port 4 Bit 5(ISP下载需勾选"ALE脚用作P4.5口")
   SBIT(P4_6,  0xC0, 6); //Port 4 Bit 6
SFR(ADC_CONTR, 0xC5);           //Analog to Digital Converter Control
   #define CHS0       0x01 //Channel Select 0
   #define CHS1       0x02 //Channel Select 1
   #define CHS2       0x04 //Channel Select 2
   #define ADC_CHS   0x0F //ADC Analog Channel Select
   #define ADC_START  0x08 //Analog to Digital Converter Start
   #define ADC_FLAG   0x10 //Analog to Digital Converter Flag
   #define ADC_SPEED0 0x20 //Analog to Digital Converter Speed 0
   #define ADC_SPEED1 0x40 //Analog to Digital Converter Speed 1
SFR(ADC_DATA, 0xC6);            //Analog to Digital Converter Data
SFR(ADC_LOW2, 0xC7);            //Analog to Digital Converter Low 2
SFR(T2CON, 0xC8);               //Timer 2 Control
   SBIT(CP_RL2, 0xC8, 0); //Capture Reload 2
   SBIT(C_T2,   0xC8, 1); //Counter Timer 2
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(EXEN2,  0xC8, 3); //External Enable 2
   SBIT(TCLK,   0xC8, 4); //Transmit Clock
   SBIT(RCLK,   0xC8, 5); //Receive Clock
   SBIT(EXF2,   0xC8, 6); //External Flag 2
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9);               //Timer 2 Mode
   #define DCEN 0x01 //Down Count Enable
   #define T2OE 0x02 //Timer 2 Output Enable
SFR(RCAP2L, 0xCA);              //Reload Capture 2 Low
SFR(RCAP2H, 0xCB);              //Reload Capture 2 High
SFR(TL2, 0xCC);                 //Timer 2 Low
SFR(TH2, 0xCD);                 //Timer 2 High
SFR(PSW, 0xD0);                 //Program status word
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(ACC, 0xE0);                 //Accumulator
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(WDT_CONTR, 0xE1);           //Watch-Dog-Timer Control
   #define PS0      0x01 //Prescale 0
   #define PS1      0x02 //Prescale 1
   #define PS2      0x04 //Prescale 2
   #define IDLE_WDT 0x08 //Idle Watchdog Timer
   #define CLR_WDT  0x10 //Clear Watchdog Timer
   #define EN_WDT   0x20 //Enable Watchdog Timer
SFR(IAP_DATA, 0xE2);            //IAP Data
SFR(ISP_DATA, 0xE2);            //ISP Data
SFR(IAP_ADDRH, 0xE3);           //IAP Address High
SFR(ISP_ADDRH, 0xE3);           //ISP Address High
SFR(IAP_ADDRL, 0xE4);           //IAP Address Low
SFR(ISP_ADDRL, 0xE4);           //ISP Address Low
SFR(IAP_CMD, 0xE5);             //IAP Command
SFR(ISP_CMD, 0xE5);             //ISP Command
   #define MS0 0x01 //Mode Select 0
   #define MS1 0x02 //Mode Select 1
   #define MS2 0x04 //Mode Select 2
SFR(IAP_TRIG, 0xE6);            //IAP Trigger
SFR(ISP_TRIG, 0xE6);            //ISP Trigger
SFR(IAP_CONTR, 0xE7);           //IAP Control
SFR(ISP_CONTR, 0xE7);           //ISP Control
   #define WT0      0x01 //Wait Time 0
   #define WT1      0x02 //Wait Time 1
   #define WT2      0x04 //Wait Time 2
   #define SWRST    0x20 //Software Reset Trigger
   #define SWBS     0x40 //Software Boot Select
   #define ISPEN    0x80 //ISP Enable
   #define IAPEN    0x80 //IAP Enable
SFR(XICON, 0xE8);               //Auxiliary Interrupt Control
   #define IT2 0x01 //Interrupt 2 Type
   #define IE2 0x02 //Interrupt 2 Edge
   #define EX2 0x04 //Enable External 2
   #define PX2 0x08 //Priority External 2
   #define IT3 0x10 //Interrupt 3 Type
   #define IE3 0x20 //Interrupt 3 Edge
   #define EX3 0x40 //Enable External 3
   #define PX3 0x80 //Priority External 3
SFR(B, 0xF0);                   //B
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7

//Interrupt numbers: Address = ( Number * 8 ) + 3
//Vectors are named after their corresponding interrupt
//enable register bit, so that we don't have to make up
//names and can be consisten across different 8051 MCUs
   #define X0_VECTOR  0  // 0x0003 External Interrupt 0
   #define T0_VECTOR  1  // 0x000B Timer 0
   #define X1_VECTOR  2  // 0x0013 External Interrupt 1
   #define T1_VECTOR  3  // 0x001B Timer 1
   #define S_VECTOR   4  // 0x0023 Serial Port 0
   #define T2_VECTOR  5  // 0x002B Timer 2
   #define X2_VECTOR  6  // 0x0033 External Interrupt 2
   #define X3_VECTOR  7  // 0x003B External Interrupt 3

#endif