// PIO compatible header file STC8G.h 20210829.
// For use with all STC8Gxx series.

#ifndef STC8G_H
#define STC8G_H
#include <compiler.h>

// SFR Definition               Description

SFR(P0, 0x80);                  //Port 0
// SBIT(ACH0, 0x80, 0); //ADC Channel 8
// SBIT(ACH1, 0x80, 1); //ADC Channel 9
// SBIT(ACH2, 0x80, 2); //ADC Channel 10
// SBIT(ACH3, 0x80, 3); //ADC Channel 11
// SBIT(ACH4, 0x80, 4); //ADC Channel 12
// SBIT(ACH5, 0x80, 5); //ADC Channel 13
// SBIT(ACH6, 0x80, 6); //ADC Channel 14
// SBIT(ADC0, 0x80, 0); //AtoD Channel 8
// SBIT(ADC1, 0x80, 1); //AtoD Channel 9
// SBIT(ADC2, 0x80, 2); //AtoD Channel 10
// SBIT(ADC3, 0x80, 3); //AtoD Channel 11
// SBIT(ADC4, 0x80, 4); //AtoD Channel 12
// SBIT(ADC5, 0x80, 5); //AtoD Channel 13
// SBIT(ADC6, 0x80, 6); //AtoD Channel 14
// SBIT(AIN0, 0x80, 0); //Analog Input 8
// SBIT(AIN1, 0x80, 1); //Analog Input 9
// SBIT(AIN2, 0x80, 2); //Analog Input 10
// SBIT(AIN3, 0x80, 3); //Analog Input 11
// SBIT(AIN4, 0x80, 4); //Analog Input 12
// SBIT(AIN5, 0x80, 5); //Analog Input 13
// SBIT(AIN6, 0x80, 6); //Analog Input 14
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
// See device specific data sheet for additional pin names.

SFR(SP, 0x81);                  //Stack Pointer

SFR(DPTR, 0x82);               //Date Pointer Word
SFR(DPL, 0x82);                 //Data Pointer Low Byte

SFR(DPH, 0x83);                 //Data Pointer High Byte

SFR(S4CON, 0x84);               //Serial Port 4 Control Register
   #define S4RI  0x01 //Serial Port 4 Receive Interrupt Flag
   #define S4TI  0x02 //Serial Port 4 Transmit Interrupt Flag
   #define S4RB8 0x04 //Serial Port 4 Receive Bit 8 Data
   #define S4TB8 0x08 //Serial Port 4 Transmit Bit 8 Data
   #define S4REN 0x10 //Serial Port 4 Receive Enable
   #define S4SM2 0x20 //Serial Port 4 Select Mode Bit 2
   #define S4ST4 0x40 //Serial Port 4 Select Timer 4
   #define S4SM0 0x80 //Serial Port 4 Select Mode Bit 0

SFR(S4BUF, 0x85);               //Serial Port 4 Data Register

SFR(PCON, 0x87);                //Power Control Register
   #define IDL   0x01 //Idle Mode Control
   #define PD    0x02 //Power Down Mode Control
   #define GF0   0x04 //User Defined Gereral Purpose Flag 0
   #define GF1   0x08 //User Defined General Purpose Flag 1
   #define POF   0x10 //Power On Flag
   #define LVDF  0x20 //Low Voltage Detect Flag
   #define SMOD0 0x40 //Frame Error Detection Control
   #define SMOD  0x80 //Double Baudrate of Serial Port 1

SFR(TCON, 0x88);                //Timer Control
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag

SFR(TMOD, 0x89);                //Timer Mode
   #define T0_M0   0x01 //Timer 0 Mode 0
   #define T0_M1   0x02 //Timer 0 Mode 1
   #define T0_M    0x03 //Timer 0 Mode
   #define T0_CT   0x04 //Timer 0 Counter Timer
   #define T0_GATE 0x08 //Timer 0 Gate
   #define T1_M0   0x10 //Timer 1 Mode 0
   #define T1_M1   0x20 //Timer 1 Mode 1
   #define T1_M    0x30 //Timer 1 Mode
   #define T1_CT   0x40 //Timer 1 Counter Timer
   #define T1_GATE 0x80 //Timer 1 Gate
   #define M00   0x01 //Mode 0 Timer 0
   #define M10   0x02 //Mode 1 Timer 0
   #define M0    0x03 //Timer 0 Mode
   #define CT0   0x04 //Counter Timer 0
   #define GATE0 0x08 //Gate 0
   #define M01   0x10 //Mode 1 Timer 1
   #define M11   0x20 //Mode 1 Timer 1
   #define M1    0x30 //Timer 1 Mode
   #define CT1   0x40 //Counter Timer 1
   #define GATE1 0x80 //Gate 1

SFR(TL0, 0x8A);                 //T0 Low Byte

SFR(TL1, 0x8B);                 //T1 Low Byte

SFR(TH0, 0x8C);                 //T0 High Byte

SFR(TH1, 0x8D);                 //T1 High Byte

SFR(AUXR, 0x8E);                //Auxiliary Register
   #define S1ST2     0x01 //Serial Port 1 Baud Rate Generator Select
   #define EXTRAM    0x02 //Extended RAM Access Control
   #define T2x12     0x04 //Timer 2 Clock x12 Prescaler Bypass
   #define T2_CT     0x08 //Timer 2 Counter or Timer Mode Select
   #define T2R       0x10 //Timer 2 Run Control
   #define UART_M0x6 0x20 //UART 1 Mode 0 Baudrate Prescaler Select
   #define T1x12     0x40 //Timer 1 Clock x12 Prescaler Bypass
   #define T0x12     0x80 //Timer 0 Clock x12 Prescaler Bypass

SFR(INTCLKO, 0x8F);             //Interrupt and Clock Output Control Register
   #define T0CLKO 0x01 //Timer 0 Clock Output Control
   #define T1CLKO 0x02 //Timer 1 Clock Output Control
   #define T2CLKO 0x04 //Timer 2 Clock Output Control
   #define EX2    0x10 //External Interrupt 3 Enable
   #define EX3    0x20 //External Interrupt 2 Enable
   #define EX4    0x40 //External Interrupt 4 Enable

SFR(P1, 0x90);                  //Port 1
   SBIT(ACH0, 0x90, 0); //ADC Channel 0
   SBIT(ACH1, 0x90, 1); //ADC Channel 1
   SBIT(ACH2, 0x90, 2); //ADC Channel 2
   SBIT(ACH3, 0x90, 3); //ADC Channel 3
   SBIT(ACH4, 0x90, 4); //ADC Channel 4
   SBIT(ACH5, 0x90, 5); //ADC Channel 5
   SBIT(ACH6, 0x90, 6); //ADC Channel 6
   SBIT(ACH7, 0x90, 7); //ADC Channel 7
   SBIT(ADC0, 0x90, 0); //AtoD Channel 0
   SBIT(ADC1, 0x90, 1); //AtoD Channel 1
   SBIT(ADC2, 0x90, 2); //AtoD Channel 2
   SBIT(ADC3, 0x90, 3); //AtoD Channel 3
   SBIT(ADC4, 0x90, 4); //AtoD Channel 4
   SBIT(ADC5, 0x90, 5); //AtoD Channel 5
   SBIT(ADC6, 0x90, 6); //AtoD Channel 6
   SBIT(ADC7, 0x90, 7); //AtoD Channel 7
   SBIT(AIN0, 0x90, 0); //Analog Input 0
   SBIT(AIN1, 0x90, 1); //Analog Input 1
   SBIT(AIN2, 0x90, 2); //Analog Input 2
   SBIT(AIN3, 0x90, 3); //Analog Input 3
   SBIT(AIN4, 0x90, 4); //Analog Input 4
   SBIT(AIN5, 0x90, 5); //Analog Input 5
   SBIT(AIN6, 0x90, 6); //Analog Input 6
   SBIT(AIN7, 0x90, 7); //Analog Input 7
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
// See device specific data sheet for additional pin names.

SFR(P1M1, 0x91);                //Port 1 Mode Register 1
   #define P10M1 0x01 //Port 1 bit 0 Mode 1
   #define P11M1 0x02 //Port 1 bit 1 Mode 1
   #define P12M1 0x04 //Port 1 bit 2 Mode 1
   #define P13M1 0x08 //Port 1 bit 3 Mode 1
   #define P14M1 0x10 //Port 1 bit 4 Mode 1
   #define P15M1 0x20 //Port 1 bit 5 Mode 1
   #define P16M1 0x40 //Port 1 bit 6 Mode 1
   #define P17M1 0x80 //Port 1 bit 7 Mode 1

SFR(P1M0, 0x92);                //Port 1 Mode Register 0
   #define P10M0 0x01 //Port 1 bit 0 Mode 0
   #define P11M0 0x02 //Port 1 bit 1 Mode 0
   #define P12M0 0x04 //Port 1 bit 2 Mode 0
   #define P13M0 0x08 //Port 1 bit 3 Mode 0
   #define P14M0 0x10 //Port 1 bit 4 Mode 0
   #define P15M0 0x20 //Port 1 bit 5 Mode 0
   #define P16M0 0x40 //Port 1 bit 6 Mode 0
   #define P17M0 0x80 //Port 1 bit 7 Mode 0

SFR(P0M1, 0x93);                //Port 0 Mode Register 1
   #define P00M1 0x01 //Port 0 bit 0 Mode 1
   #define P01M1 0x02 //Port 0 bit 1 Mode 1
   #define P02M1 0x04 //Port 0 bit 2 Mode 1
   #define P03M1 0x08 //Port 0 bit 3 Mode 1
   #define P04M1 0x10 //Port 0 bit 4 Mode 1
   #define P05M1 0x20 //Port 0 bit 5 Mode 1
   #define P06M1 0x40 //Port 0 bit 6 Mode 1
   #define P07M1 0x80 //Port 0 bit 7 Mode 1

SFR(P0M0, 0x94);                //Port 0 Mode Register 0
   #define P00M0 0x01 //Port 0 bit 0 Mode 0
   #define P01M0 0x02 //Port 0 bit 1 Mode 0
   #define P02M0 0x04 //Port 0 bit 2 Mode 0
   #define P03M0 0x08 //Port 0 bit 3 Mode 0
   #define P04M0 0x10 //Port 0 bit 4 Mode 0
   #define P05M0 0x20 //Port 0 bit 5 Mode 0
   #define P06M0 0x40 //Port 0 bit 6 Mode 0
   #define P07M0 0x80 //Port 0 bit 7 Mode 0

SFR(P2M1, 0x95);                //Port 2 Mode Register 1
   #define P20M1 0x01 //Port 2 bit 0 Mode 1
   #define P21M1 0x02 //Port 2 bit 1 Mode 1
   #define P22M1 0x04 //Port 2 bit 2 Mode 1
   #define P23M1 0x08 //Port 2 bit 3 Mode 1
   #define P24M1 0x10 //Port 2 bit 4 Mode 1
   #define P25M1 0x20 //Port 2 bit 5 Mode 1
   #define P26M1 0x40 //Port 2 bit 6 Mode 1
   #define P27M1 0x80 //Port 2 bit 7 Mode 1

SFR(P2M0, 0x96);                //Port 2 Mode Register 0
   #define P20M0 0x01 //Port 2 bit 0 Mode 0
   #define P21M0 0x02 //Port 2 bit 1 Mode 0
   #define P22M0 0x04 //Port 2 bit 2 Mode 0
   #define P23M0 0x08 //Port 2 bit 3 Mode 0
   #define P24M0 0x10 //Port 2 bit 4 Mode 0
   #define P25M0 0x20 //Port 2 bit 5 Mode 0
   #define P26M0 0x40 //Port 2 bit 6 Mode 0
   #define P27M0 0x80 //Port 2 bit 7 Mode 0

SFR(SCON, 0x98);                //Serial Control
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error

SFR(SBUF, 0x99);                //Serial Port 1 Data Register

SFR(S2CON, 0x9A);               //Serial Port 2 Control Register
   #define S2RI  0x01 //Serial Port 2 Receive Interrupt Flag
   #define S2TI  0x02 //Serial Port 2 Transmit Interrupt Flag
   #define S2RB8 0x04 //Serial Port 2 Receive Bit 8 Data
   #define S2TB8 0x08 //Serial Port 2 Transmit Bit 8 Data
   #define S2REN 0x10 //Serial Port 2 Receive Enable
   #define S2SM2 0x20 //Serial Port 2 Select Mode Bit 2
   #define S2SM0 0x80 //Serial Port 2 Select Mode Bit 0

SFR(S2BUF, 0x9B);               //Serial Port 2 Data Register

SFR(LIRTRIM, 0x9E);             //Internal RC Clock Frequency Trimming Register

SFR(IRTRIM, 0x9F);              //Internal RC Clock Frequency Adjustment Register

SFR(P2, 0xA0);                  //Port 2
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P27, 0xA0, 7); //Port 2 Bit 7
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_7, 0xA0, 7); //Port 2 Bit 7
// See device specific data sheet for additional pin names.

SFR(BUS_SPEED, 0xA1);           //Bus Speed Control Register
   #define BUSSPEED 0x07 //Bus Read-Write Speed Control
   #define RW_S     0xC0 //Read-Write Control Pin Select

SFR(P_SW1, 0xA2);               //Peripheral Port Switching Register 1
   #define SPI_S 0xC0 //Serial Peripheral Interface Pin Select
   #define CCP_S 0x30 //PCA Pin Select
   #define S1_S  0xC0 //Serial Port 1 Pin Select

SFR(IE, 0xA8);                  //Interrupt Enable
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EADC, 0xA8, 5); //Enable ADC
   SBIT(ELVD, 0xA8, 6); //Enable Low Voltage Detect
   SBIT(EA,   0xA8, 7); //Enable All

SFR(SADDR, 0xA9);               //Slave Address Register

SFR(WKTCL, 0xAA);               //Power Down Wakeup Timer Low Byte

SFR(WKTCH, 0xAB);               //Power Down Wakeup Timer High Byte
   #define WKTEN 0x80 //Power Down Wakeup Timer Enable

SFR(S3CON, 0xAC);               //Serial Port 3 Control Register
   #define S3RI  0x01 //Serial Port 3 Receive Interrupt Flag
   #define S3TI  0x02 //Serial Port 3 Transmit Interrupt Flag
   #define S3RB8 0x04 //Serial Port 3 Receive Bit 8 Data
   #define S3TB8 0x08 //Serial Port 3 Transmit Bit 8 Data
   #define S3REN 0x10 //Serial Port 3 Receive Enable
   #define S3SM2 0x20 //Serial Port 3 Select Mode Bit 2
   #define S3ST3 0x40 //Serial Port 3 Select Timer 3
   #define S3SM0 0x80 //Serial Port 3 Select Mode Bit 0

SFR(S3BUF, 0xAD);               //Serial Port 3 Data Register

SFR(TA, 0xAE);                  //Data Pointer Control Register

SFR(IE2, 0xAF);                 //Interrupt Control Register 2
   #define ES2  0x01 //Enable Serial Port 2 Interrupt
   #define ESPI 0x02 //Enable Serial Peripheral Interface Interrupt
   #define ET2  0x04 //Enable Timer 2 Interrupt
   #define ES3  0x08 //Enable Serial Port 3 Interrupt
   #define ES4  0x10 //Enable Serial Port 4 Interrupt
   #define ET3  0x20 //Enable Timer 3 Interrupt
   #define ET4  0x40 //Enable Timer 4 Interrupt
   #define ECAN 0x80 //Enable CAN Interrupt

SFR(P3, 0xB0);                  //Port 3
// SBIT(ACH0, 0xB0, 0); //ADC Channel 8
// SBIT(ACH1, 0xB0, 1); //ADC Channel 9
// SBIT(ACH2, 0xB0, 2); //ADC Channel 10
// SBIT(ACH3, 0xB0, 3); //ADC Channel 11
// SBIT(ACH4, 0xB0, 4); //ADC Channel 12
// SBIT(ACH5, 0xB0, 5); //ADC Channel 13
// SBIT(ACH6, 0xB0, 6); //ADC Channel 14
// SBIT(ADC0, 0xB0, 0); //AtoD Channel 8
// SBIT(ADC1, 0xB0, 1); //AtoD Channel 9
// SBIT(ADC2, 0xB0, 2); //AtoD Channel 10
// SBIT(ADC3, 0xB0, 3); //AtoD Channel 11
// SBIT(ADC4, 0xB0, 4); //AtoD Channel 12
// SBIT(ADC5, 0xB0, 5); //AtoD Channel 13
// SBIT(ADC6, 0xB0, 6); //AtoD Channel 14
// SBIT(AIN0, 0xB0, 0); //Analog Input 8
// SBIT(AIN1, 0xB0, 1); //Analog Input 9
// SBIT(AIN2, 0xB0, 2); //Analog Input 10
// SBIT(AIN3, 0xB0, 3); //Analog Input 11
// SBIT(AIN4, 0xB0, 4); //Analog Input 12
// SBIT(AIN5, 0xB0, 5); //Analog Input 13
// SBIT(AIN6, 0xB0, 6); //Analog Input 14
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
// See device specific data sheet for additional pin names.

SFR(P3M1, 0xB1);                //Port 3 Mode Register 1
   #define P30M1 0x01 //Port 3 bit 0 Mode 1
   #define P31M1 0x02 //Port 3 bit 1 Mode 1
   #define P32M1 0x04 //Port 3 bit 2 Mode 1
   #define P33M1 0x08 //Port 3 bit 3 Mode 1
   #define P34M1 0x10 //Port 3 bit 4 Mode 1
   #define P35M1 0x20 //Port 3 bit 5 Mode 1
   #define P36M1 0x40 //Port 3 bit 6 Mode 1
   #define P37M1 0x80 //Port 3 bit 7 Mode 1

SFR(P3M0, 0xB2);                //Port 3 Mode Register 0
   #define P30M0 0x01 //Port 3 bit 0 Mode 0
   #define P31M0 0x02 //Port 3 bit 1 Mode 0
   #define P32M0 0x04 //Port 3 bit 2 Mode 0
   #define P33M0 0x08 //Port 3 bit 3 Mode 0
   #define P34M0 0x10 //Port 3 bit 4 Mode 0
   #define P35M0 0x20 //Port 3 bit 5 Mode 0
   #define P36M0 0x40 //Port 3 bit 6 Mode 0
   #define P37M0 0x80 //Port 3 bit 7 Mode 0

SFR(P4M1, 0xB3);                //Port 4 Mode Register 1
   #define P40M1 0x01 //Port 4 bit 0 Mode 1
   #define P41M1 0x02 //Port 4 bit 1 Mode 1
   #define P42M1 0x04 //Port 4 bit 2 Mode 1
   #define P43M1 0x08 //Port 4 bit 3 Mode 1
   #define P44M1 0x10 //Port 4 bit 4 Mode 1
   #define P45M1 0x20 //Port 4 bit 5 Mode 1
   #define P46M1 0x40 //Port 4 bit 6 Mode 1
   #define P47M1 0x80 //Port 4 bit 7 Mode 1

SFR(P4M0, 0xB4);                //Port 4 Mode Register 0
   #define P40M0 0x01 //Port 4 bit 0 Mode 0
   #define P41M0 0x02 //Port 4 bit 1 Mode 0
   #define P42M0 0x04 //Port 4 bit 2 Mode 0
   #define P43M0 0x08 //Port 4 bit 3 Mode 0
   #define P44M0 0x10 //Port 4 bit 4 Mode 0
   #define P45M0 0x20 //Port 4 bit 5 Mode 0
   #define P46M0 0x40 //Port 4 bit 6 Mode 0
   #define P47M0 0x80 //Port 4 bit 7 Mode 0

SFR(IP2, 0xB5);                 //Interrupt Priority Register 2
   #define PS2    0x01 //Serial Port 2 Interrupt Priority
   #define PSPI   0x02 //Serial Peripheral Interface Interrupt Priority
   #define PPWM   0x04 //PWM Interrupt Priority
   #define PPWMFD 0x08 //PWM Fault Detect Interrupt Priority
   #define PX4    0x10 //External Interrupt 4 Priority
   #define PCMP   0x20 //Comparator Interrupt Priority
   #define PI2C   0x40 //I2C Interrupt Priority
   #define PCAN   0x80 //CAN Interrupt Priority

SFR(IP2H, 0xB6);                //High Interrupt Priority Register 2
   #define PS2H    0x01 //Serial Port 2 Interrupt Priority High
   #define PSPIH   0x02 //Serial Peripheral Interface Interrupt Priority High
   #define PPWMH   0x04 //PWM Interrupt Priority High
   #define PPWMFDH 0x08 //PWM Fault Detect Interrupt Priority High
   #define PX4H    0x10 //External Interrupt 4 Priority High
   #define PCMPH   0x20 //Comparator Interrupt Priority High
   #define PI2CH   0x40 //I2C Interrupt Priority High
   #define PCANH   0x80 //CAN Interrupt Priority High

SFR(IPH, 0xB7);                 //High Interrupt Priority Register
   #define PX0H  0x01 //External Interrupt 0 Priority High
   #define PT0H  0x02 //Timer 0 Interrupt Priority High
   #define PX1H  0x04 //External Interrupt 1 Priority High
   #define PT1H  0x08 //Timer 1 Interrupt Priority High
   #define PSH   0x10 //Serial Port 1 Interrupt Priority High
   #define PADCH 0x20 //ADC Interrupt Priority High
   #define PLVDH 0x40 //Low Voltage Detect Interrupt Priority High
   #define PPCAH 0x80 //CCP-PCA Interrupt Priority High

SFR(IP, 0xB8);                  //Interrupt Priority
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PADC, 0xB8, 5); //Priority ADC
   SBIT(PLVD, 0xB8, 6); //Priority Low Voltage Detect
   SBIT(PPCA, 0xB8, 7); //Priority CCP-PCA

SFR(SADEN, 0xB9);               //Slave Address Mask Register

SFR(P_SW2, 0xBA);               //Peripheral Port Switching Register 2
   #define S2_S   0x10 //Serial Port 2 Pin Select
   #define S3_S   0x20 //Serial Port 3 Pin Select
   #define S4_S   0x40 //Serial Port 4 Pin Select
   #define CMPO_S 0x80 //Comparator Output Pin Select
   #define I2C_S  0x30 //I2C Pin Select
   #define CAN_S  0x40 //CAN Pin Select
   #define EAXFR  0x80 //Extended RAM Area Transfer Enable

SFR(ADC_CONTR, 0xBC);           //Analog to Digital Converter Control Register
   #define ADC_CHS   0x0F //ADC Analog Channel Select
   #define ADC_EPWMT 0x10 //ADC Enable PWM Trigger
   #define ADC_FLAG  0x20 //ADC Conversion Complete Flag
   #define ADC_START 0x40 //ADC Start Command
   #define ADC_POWER 0x80 //ADC Power Control

SFR(ADC_RES, 0xBD);             //Analog to Digital Converter Result High 8 Bits

SFR(ADC_RESL, 0xBE);            //Analog to Digital Converter Result Low 2 Bits

SFR(P4, 0xC0);                  //Port 4
   SBIT(P40, 0xC0, 0); //Port 4 Bit 0
   SBIT(P41, 0xC0, 1); //Port 4 Bit 1
   SBIT(P42, 0xC0, 2); //Port 4 Bit 2
   SBIT(P43, 0xC0, 3); //Port 4 Bit 3
   SBIT(P44, 0xC0, 4); //Port 4 Bit 4
   SBIT(P45, 0xC0, 5); //Port 4 Bit 5
   SBIT(P46, 0xC0, 6); //Port 4 Bit 6
   SBIT(P47, 0xC0, 7); //Port 4 Bit 7
   SBIT(P4_0, 0xC0, 0); //Port 4 Bit 0
   SBIT(P4_1, 0xC0, 1); //Port 4 Bit 1
   SBIT(P4_2, 0xC0, 2); //Port 4 Bit 2
   SBIT(P4_3, 0xC0, 3); //Port 4 Bit 3
   SBIT(P4_4, 0xC0, 4); //Port 4 Bit 4
   SBIT(P4_5, 0xC0, 5); //Port 4 Bit 5
   SBIT(P4_6, 0xC0, 6); //Port 4 Bit 6
   SBIT(P4_7, 0xC0, 7); //Port 4 Bit 7
// See device specific data sheet for additional pin names.

SFR(WDT_CONTR, 0xC1);           //Watchdog Control Register
   #define WDTPS0   0x01 //Watchdog Timer Prescaler 0
   #define WDTPS1   0x02 //Watchdog Timer Prescaler 1
   #define WDTPS2   0x04 //Watchdog Timer Prescaler 2
   #define WDT_PS   0x07 //Watchdog Timer Prescaler
   #define IDL_WDT  0x08 //Watchdog Timer Idle Mode Behavior
   #define CLR_WDT  0x10 //Clear Watchdog Timer
   #define EN_WDT   0x20 //Enable Watchdog Timer
   #define WDT_FLAG 0x80 //Watchdog Timer Overflow Flag

SFR(IAP_DATA, 0xC2);            //In Application Programming Data
SFR(ISP_DATA, 0xC2);            //In System Programming Data

SFR(IAP_ADDRH, 0xC3);           //In Application Programming Address High
SFR(ISP_ADDRH, 0xC3);           //In System Programming Address High

SFR(IAP_ADDRL, 0xC4);           //In Application Programming Address Low
SFR(ISP_ADDRL, 0xC4);           //In System Programming Address Low

SFR(IAP_CMD, 0xC5);             //In Application Programming Command
SFR(ISP_CMD, 0xC5);             //In System Programming Command
   #define MS0    0x01 //Mode Select 0
   #define MS1    0x02 //Mode Select 1
   #define IAPCMD 0x03 //In Application Programming Command
// Valid commands follow
#define IAP_IDL   0x00
#define IAP_READ  0x01
#define IAP_WRITE 0x02
#define IAP_ERASE 0x03
// End of valid commands

SFR(IAP_TRIG, 0xC6);            //In Application Programming Trigger
SFR(ISP_TRIG, 0xC6);            //In System Programming Trigger

SFR(IAP_CONTR, 0xC7);           //In Application Programming Control
SFR(ISP_CONTR, 0xC7);           //In System Programming Control
   #define WT0      0x01 //Wait 0
   #define WT1      0x02 //Wait 1
   #define WT2      0x04 //Wait 2
   #define IAP_WT   0x07 //In Application Programming Wait
   #define CMD_FAIL 0x10 //Command Fail
   #define SWRST    0x20 //Software Reset Trigger
   #define SWBS     0x40 //Software Boot Selection
   #define IAPEN    0x80 //In Application Programming Enable

SFR(P5, 0xC8);                  //Port 5
   SBIT(P50, 0xC8, 0); //Port 5 Bit 0
   SBIT(P51, 0xC8, 1); //Port 5 Bit 1
   SBIT(P52, 0xC8, 2); //Port 5 Bit 2
   SBIT(P53, 0xC8, 3); //Port 5 Bit 3
   SBIT(P54, 0xC8, 4); //Port 5 Bit 4
   SBIT(P55, 0xC8, 5); //Port 5 Bit 5
   SBIT(P5_0, 0xC8, 0); //Port 5 Bit 0
   SBIT(P5_1, 0xC8, 1); //Port 5 Bit 1
   SBIT(P5_2, 0xC8, 2); //Port 5 Bit 2
   SBIT(P5_3, 0xC8, 3); //Port 5 Bit 3
   SBIT(P5_4, 0xC8, 4); //Port 5 Bit 4
   SBIT(P5_5, 0xC8, 5); //Port 5 Bit 5
// See device specific data sheet for additional pin names.

SFR(P5M1, 0xC9);                //Port 5 Mode Register 1
   #define P50M1 0x01 //Port 5 bit 0 Mode 1
   #define P51M1 0x02 //Port 5 bit 1 Mode 1
   #define P52M1 0x04 //Port 5 bit 2 Mode 1
   #define P53M1 0x08 //Port 5 bit 3 Mode 1
   #define P54M1 0x10 //Port 5 bit 4 Mode 1
   #define P55M1 0x20 //Port 5 bit 5 Mode 1

SFR(P5M0, 0xCA);                //Port 5 Mode Register 0
   #define P50M0 0x01 //Port 5 bit 0 Mode 0
   #define P51M0 0x02 //Port 5 bit 1 Mode 0
   #define P52M0 0x04 //Port 5 bit 2 Mode 0
   #define P53M0 0x08 //Port 5 bit 3 Mode 0
   #define P54M0 0x10 //Port 5 bit 4 Mode 0
   #define P55M0 0x20 //Port 5 bit 5 Mode 0

SFR(P6M1, 0xCB);                //Port 6 Mode Register 1
   #define P60M1 0x01 //Port 6 bit 0 Mode 1
   #define P61M1 0x02 //Port 6 bit 1 Mode 1
   #define P62M1 0x04 //Port 6 bit 2 Mode 1
   #define P63M1 0x08 //Port 6 bit 3 Mode 1
   #define P64M1 0x10 //Port 6 bit 4 Mode 1
   #define P65M1 0x20 //Port 6 bit 5 Mode 1
   #define P66M1 0x40 //Port 6 bit 6 Mode 1
   #define P67M1 0x80 //Port 6 bit 7 Mode 1

SFR(P6M0, 0xCC);                //Port 6 Mode Register 0
   #define P60M0 0x01 //Port 6 bit 0 Mode 0
   #define P61M0 0x02 //Port 6 bit 1 Mode 0
   #define P62M0 0x04 //Port 6 bit 2 Mode 0
   #define P63M0 0x08 //Port 6 bit 3 Mode 0
   #define P64M0 0x10 //Port 6 bit 4 Mode 0
   #define P65M0 0x20 //Port 6 bit 5 Mode 0
   #define P66M0 0x40 //Port 6 bit 6 Mode 0
   #define P67M0 0x80 //Port 6 bit 7 Mode 0

SFR(SPSTAT, 0xCD);              //Serial Peripheral Status Register
   #define WCOL 0x40 //Write Collision
   #define SPIF 0x80 //Serial Peripheral Interface Flag

SFR(SPCTL, 0xCE);               //Serial Peripheral Control Register
   #define SPR0 0x00 //Serial Peripheral Rate 0
   #define SPR1 0x01 //Serial Peripheral Rate 1
   #define SPR  0x03 //Serial Peripheral Rate
   #define CPHA 0x04 //Clock Phase
   #define CPOL 0x08 //Clock Polarity
   #define MSTR 0x10 //Master
   #define DORD 0x20 //Data Order
   #define SPEN 0x40 //Serial Peripheral Enable
   #define SSIG 0x80 //Slave Select Signal

SFR(SPDAT, 0xCF);               //Serial Peripheral Data

SFR(PSW, 0xD0);                 //Program status word
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry

SFR(T4T3M, 0xD1);               //T4 and T3 Mode Register
   #define T3CLKO 0x01 //Timer 3 Clock Output Control
   #define T3x12  0x02 //Timer 3 Clock x12 Prescaler Bypass
   #define T3_CT  0x04 //Timer 3 Counter or Timer Mode Select
   #define T3R    0x08 //Timer 3 Run Control
   #define T4CLKO 0x10 //Timer 4 Clock Output Control
   #define T4x12  0x20 //Timer 4 Clock x12 Prescaler Bypass
   #define T4_CT  0x40 //Timer 4 Counter or Timer Mode Select
   #define T4R    0x80 //Timer 4 Run Control

SFR(T4H, 0xD2);                 //T4 High Byte
SFR(TH4, 0xD2);

SFR(T4L, 0xD3);                 //T4 Low Byte
SFR(TL4, 0xD3);

SFR(T3H, 0xD4);                 //T3 High Byte
SFR(TH3, 0xD4);

SFR(T3L, 0xD5);                 //T3 Low Byte
SFR(TL3, 0xD5);

SFR(T2H, 0xD6);                 //T2 High Byte
SFR(TH2, 0xD6);

SFR(T2L, 0xD7);                 //T2 Low Byte
SFR(TL2, 0xD7);

SFR(CCON,   0xD8);              //PCA Control Register
   SBIT(CCF0, 0xD8, 0); //PCA Counter 0 Interrupt Flag
   SBIT(CCF1, 0xD8, 1); //PCA Counter 1 Interrupt Flag
   SBIT(CCF2, 0xD8, 2); //PCA Counter 2 Interrupt Flag
   SBIT(CCF3, 0xD8, 3); //PCA Counter 3 Interrupt Flag
   SBIT(CR,   0xD8, 6); //PCA Counter Enable
   SBIT(CF,   0xD8, 7); //PCA Counter Overflow Flage

SFR(CMOD, 0xD9);                //PCA Working Mode Register
   #define ECF  0x01 //PCA Counter Overflow Interrupt Enable
   #define CPS0 0x02 //PCA Counter Pulse Source Select 0
   #define CPS1 0x04 //PCA Counter Pulse Source Select 1
   #define CPS2 0x08 //PCA Counter Pulse Source Select 2
   #define CPS  0x0E //PCA Counter Pulse Source Select
   #define CIDL 0x80 //PCA Counter Idle Mode Control

SFR(CCAPM0, 0xDA);              //Compare Capture PWM 0 Mode
   #define ECCF0  0x01 //Enable PCA Capture Flag 0
   #define PWM0   0x02 //Pulse Width Modulator 0
   #define TOG0   0x04 //Toggle 0
   #define MAT0   0x08 //Match 0
   #define CCAPN0 0x10 //PCA Capture Negative-going 0
   #define CCAPP0 0x20 //PCA Capture Positive-going 0
   #define ECOM0  0x40 //Enable Comparator 0

SFR(CCAPM1, 0xDB);              //Compare Capture PWM 1 Mode
   #define ECCF1  0x01 //Enable PCA Capture Flag 1
   #define PWM1   0x02 //Pulse Width Modulator 1
   #define TOG1   0x04 //Toggle 1
   #define MAT1   0x08 //Match 1
   #define CCAPN1 0x10 //PCA Capture Negative-going 1
   #define CCAPP1 0x20 //PCA Capture Positive-going 1
   #define ECOM1  0x40 //Enable Comparator 1

SFR(CCAPM2, 0xDC);              //Compare Capture PWM 2 Mode
   #define ECCF2  0x01 //Enable PCA Capture Flag 2
   #define PWM2   0x02 //Pulse Width Modulator 2
   #define TOG2   0x04 //Toggle 2
   #define MAT2   0x08 //Match 2
   #define CCAPN2 0x10 //PCA Capture Negative-going 2
   #define CCAPP2 0x20 //PCA Capture Positive-going 2
   #define ECOM2  0x40 //Enable Comparator 2

SFR(ADCCFG, 0xDE);              //ADC Configuration Register
   #define ADCSPEED  0x0F //Clock Speed Control
   #define RESFMT    0x20 //Result Format Control

SFR(IP3, 0xDF);                 //Interrupt Priority Register 3
   #define PS3  0x01 //Serial Port 3 Interrupt Priority
   #define PS4  0x02 //Serial Port 4 Interrupt Priority
   #define PRTC 0x04 //RTC Interrupt Priority Control

SFR(ACC, 0xE0);                 //Accumulator
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7

SFR(P7M1, 0xE1);                //Port 7 Mode Register 1
   #define P70M1 0x01 //Port 7 bit 0 Mode 1
   #define P71M1 0x02 //Port 7 bit 1 Mode 1
   #define P72M1 0x04 //Port 7 bit 2 Mode 1
   #define P73M1 0x08 //Port 7 bit 3 Mode 1
   #define P74M1 0x10 //Port 7 bit 4 Mode 1
   #define P75M1 0x20 //Port 7 bit 5 Mode 1
   #define P76M1 0x40 //Port 7 bit 6 Mode 1
   #define P77M1 0x80 //Port 7 bit 7 Mode 1

SFR(P7M0, 0xE2);                //Port 7 Mode Register 0
   #define P70M0 0x01 //Port 7 bit 0 Mode 0
   #define P71M0 0x02 //Port 7 bit 1 Mode 0
   #define P72M0 0x04 //Port 7 bit 2 Mode 0
   #define P73M0 0x08 //Port 7 bit 3 Mode 0
   #define P74M0 0x10 //Port 7 bit 4 Mode 0
   #define P75M0 0x20 //Port 7 bit 5 Mode 0
   #define P76M0 0x40 //Port 7 bit 6 Mode 0
   #define P77M0 0x80 //Port 7 bit 7 Mode 0

SFR(DPS, 0xE3);                 //DPTR Pointer Selector
   #define SEL 0x01 //Data Pointer Select
   #define AU0 0x08 //Auto Increment-Decrement Data Pointer 0
   #define AU1 0x10 //Auto Increment-Decrement Data Pointer 1
   #define TSL 0x20 //Auto Toggle Data Pointer Select
   #define ID0 0x40 //Increment or Decrement Data Pointer 0
   #define ID1 0x80 //Increment or Decrement Data Pointer 1

SFR(DPL1, 0xE4);                //Second Data Pointer Low Byte
SFR(DPTR1, 0xE4);               //Second Data Pointer Word

SFR(DPH1, 0xE5);                //Second Data Pointer High Byte

SFR(CMPCR1, 0xE6);              //Comparator Control Register 1
   #define CMPRES 0x01 //Comparator Result
   #define CMPOE  0x02 //Comparator Output Enable
   #define NIS    0x04 //Negative Input Source Selection
   #define PIS    0x08 //Positive Input Source Selection
   #define NIE    0x10 //Falling Edge Interrupt Enable
   #define PIE    0x20 //Rising Edge Interrupt Enable
   #define CMPIF  0x40 //Comparator Interrupt Flag
   #define CMPEN  0x80 //Comparator Enable

SFR(CMPCR2, 0xE7);              //Comparator Control Register 2
   #define LCDTY   0x3F //Digital Filter Control
   #define DISFLT  0x40 //Analog Filter Control
   #define INVCMPO 0x80 //Comparator Output Control

SFR(P6, 0xE8);                  //Port 6
   SBIT(P60, 0xE8, 0); //Port 6 Bit 0
   SBIT(P61, 0xE8, 1); //Port 6 Bit 1
   SBIT(P62, 0xE8, 2); //Port 6 Bit 2
   SBIT(P63, 0xE8, 3); //Port 6 Bit 3
   SBIT(P64, 0xE8, 4); //Port 6 Bit 4
   SBIT(P65, 0xE8, 5); //Port 6 Bit 5
   SBIT(P66, 0xE8, 6); //Port 6 Bit 6
   SBIT(P67, 0xE8, 7); //Port 6 Bit 7
   SBIT(P6_0, 0xE8, 0); //Port 6 Bit 0
   SBIT(P6_1, 0xE8, 1); //Port 6 Bit 1
   SBIT(P6_2, 0xE8, 2); //Port 6 Bit 2
   SBIT(P6_3, 0xE8, 3); //Port 6 Bit 3
   SBIT(P6_4, 0xE8, 4); //Port 6 Bit 4
   SBIT(P6_5, 0xE8, 5); //Port 6 Bit 5
   SBIT(P6_6, 0xE8, 6); //Port 6 Bit 6
   SBIT(P6_7, 0xE8, 7); //Port 6 Bit 7
// See device specific data sheet for additional pin names.

SFR(CL, 0xE9);                  //PCA Counter Low Byte

SFR(CCAP0L, 0xEA);              //PCA Module 0 Capture-Compare Register Low Byte

SFR(CCAP1L, 0xEB);              //PCA Module 1 Capture-Compare Register Low Byte

SFR(CCAP2L, 0xEC);              //PCA Module 2 Capture-Compare Register Low Byte

SFR(IP3H, 0xEE);                //High Interrupt Priority Register 3
   #define PS3H  0x01 //Serial Port 3 Interrupt Priority
   #define PS4H  0x02 //Serial Port 4 Interrupt Priority
   #define PRTCH 0x04 //RTC Interrupt Priority Control

SFR(AUXINTIF, 0xEF);            //Auxiliary Interrupt Flag Register
   #define T2IF   0x01 //Timer 2 Overflow Interrupt
   #define T3IF   0x02 //Timer 1 Overflow Interrupt
   #define T4IF   0x04 //Timer 0 Overflow Interrupt
   #define INT2IF 0x10 //External Interrupt 2 Request Flag
   #define INT3IF 0x20 //External Interrupt 3 Request Flag
   #define INT4IF 0x40 //External Interrupt 4 Request Flag

SFR(B, 0xF0);                   //B
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7

SFR(PWMSET, 0xF1);              //Enhanced PWM Clobal Configuration Register
   #define ENPWM0   0x01 //Enable PWM 0
   #define ENPWM1   0x02 //Enable PWM 1
   #define ENPWM2   0x04 //Enable PWM 2
   #define ENPWM3   0x08 //Enable PWM 3
   #define ENPWM4   0x10 //Enable PWM 4
   #define ENPWM5   0x20 //Enable PWM 5
   #define PWMRST   0x40 //PWM Reset
   #define ENGLBSET 0x80 //Enable Global Setup

SFR(PCA_PWM0, 0xF2);            //PCA Module 0 PWM Register
   #define EPC0L   0x01 //MSB of comparison vaule in PWM mode 
   #define EPC0H   0x02 //MSB of reload vaule in PWM mode
   #define XCCAP0L 0x0C //9th & 10th bit of comparison value in PWM mode
   #define XCCAP0H 0x30 //9th & 10th bit of reload value in PWM mode
   #define EBS0_0  0x40 //Number of PCAn PWM Bits Control 0
   #define EBS0_1  0x80 //Number of PCAn PWM Bits Control 1
   #define EBS0    0xC0 //Number of PCAn PWM Bits Control

SFR(PCA_PWM1, 0xF3);            //PCA Module 1 PWM Register
   #define EPC1L   0x01 //MSB of comparison vaule in PWM mode 
   #define EPC1H   0x02 //MSB of reload vaule in PWM mode
   #define XCCAP1L 0x0C //9th & 10th bit of comparison value in PWM mode
   #define XCCAP1H 0x30 //9th & 10th bit of reload value in PWM mode
   #define EBS1_0  0x40 //Number of PCAn PWM Bits Control 0
   #define EBS1_1  0x80 //Number of PCAn PWM Bits Control 1
   #define EBS1    0xC0 //Number of PCAn PWM Bits Control

SFR(PCA_PWM2, 0xF4);            //PCA Module 2 PWM Register
   #define EPC2L   0x01 //MSB of comparison vaule in PWM mode
   #define EPC2H   0x02 //MSB of reload vaule in PWM mode
   #define XCCAP2L 0x0C //9th & 10th bit of comparison value in PWM mode
   #define XCCAP2H 0x30 //9th & 10th bit of reload value in PWM mode
   #define EBS2_0  0x40 //Number of PCAn PWM Bits Control 0
   #define EBS2_1  0x80 //Number of PCAn PWM Bits Control 1
   #define EBS2    0xC0 //Number of PCAn PWM Bits Control

SFR(IAP_TPS, 0xF5);             //IAP Wait Time Control Register
   #define IAPTPS 0x3F //Set Wait Time Per Operating Frequency

SFR(PWMCFG01, 0xF6);            //Enhanced PWM Channel 0 and 1 Configuration Register
   #define PWM0CEN  0x01 //PWM 0 Counter Enable
   #define ENPWM0TA 0x02 //Enable PWM0 Trigger ADC
   #define EPWM0CBI 0x04 //Enable PWM 0 Counter Overflow Interrupt
   #define PWM0CBIF 0x08 //PWM 0 Counter Overflow Interrupt Flag
   #define PWM1CEN  0x10 //PWM 1 Counter Enable
   #define FLTPS0   0x20 //Fault Pin Select 0
   #define EPWM1CBI 0x40 //Enable PWM 1 Counter Overflow Interrupt
   #define PWM1CBIF 0x80 //PWM 1 Counter Overflow Interrupt Flag

SFR(PWMCFG23, 0xF7);            //Enhanced PWM Channel 2 and 3 Configuration Register
   #define PWM2CEN  0x01 //PWM 2 Counter Enable
   #define ENPWM2TA 0x02 //Enable PWM2 Trigger ADC
   #define EPWM2CBI 0x04 //Enable PWM 2 Counter Overflow Interrupt
   #define PWM2CBIF 0x08 //PWM 2 Counter Overflow Interrupt Flag
   #define PWM3CEN  0x10 //PWM 3 Counter Enable
   #define FLTPS1   0x20 //Fault Pin Select 1
   #define EPWM3CBI 0x40 //Enable PWM 3 Counter Overflow Interrupt
   #define PWM3CBIF 0x80 //PWM 3 Counter Overflow Interrupt Flag

SFR(P7, 0xF8);                  //Port 7
   SBIT(P70, 0xF8, 0); //Port 7 Bit 0
   SBIT(P71, 0xF8, 1); //Port 7 Bit 1
   SBIT(P72, 0xF8, 2); //Port 7 Bit 2
   SBIT(P73, 0xF8, 3); //Port 7 Bit 3
   SBIT(P74, 0xF8, 4); //Port 7 Bit 4
   SBIT(P75, 0xF8, 5); //Port 7 Bit 5
   SBIT(P76, 0xF8, 6); //Port 7 Bit 6
   SBIT(P77, 0xF8, 7); //Port 7 Bit 7
   SBIT(P7_0, 0xF8, 0); //Port 7 Bit 0
   SBIT(P7_1, 0xF8, 1); //Port 7 Bit 1
   SBIT(P7_2, 0xF8, 2); //Port 7 Bit 2
   SBIT(P7_3, 0xF8, 3); //Port 7 Bit 3
   SBIT(P7_4, 0xF8, 4); //Port 7 Bit 4
   SBIT(P7_5, 0xF8, 5); //Port 7 Bit 5
   SBIT(P7_6, 0xF8, 6); //Port 7 Bit 6
   SBIT(P7_7, 0xF8, 7); //Port 7 Bit 7
// See device specific data sheet for additional pin names.

SFR(CH, 0xF9);                  //PCA Counter High Byte

SFR(CCAP0H, 0xFA);              //PCA Module 0 Capture-Compare Register High Byte

SFR(CCAP1H, 0xFB);              //PCA Module 1 Capture-Compare Register High Byte

SFR(CCAP2H, 0xFC);              //PCA Module 2 Capture-Compare Register High Byte

SFR(PWMCFG45, 0xFE);            //Enhanced PWM Channel 4 and 5 Configuration Register
   #define PWM4CEN  0x01 //PWM 4 Counter Enable
   #define ENPWM4TA 0x02 //Enable PWM4 Trigger ADC
   #define EPWM4CBI 0x04 //Enable PWM 4 Counter Overflow Interrupt
   #define PWM4CBIF 0x08 //PWM 4 Counter Overflow Interrupt Flag
   #define PWM5CEN  0x10 //PWM 5 Counter Enable
   #define FLTPS2   0x20 //Fault Pin Select 2
   #define EPWM5CBI 0x40 //Enable PWM 5 Counter Overflow Interrupt
   #define PWM5CBIF 0x80 //PWM 5 Counter Overflow Interrupt Flag

SFR(RSTCFG, 0xFF);              //Reset Configuration Register
   #define LVDS   0x03 //Low Voltage Detection Threshold
   #define P54RST 0x10 //Port 5 Pin 4 Reset Pin Enable
   #define ENLVR  0x40 //Enable Low Voltage Reset

// The following special function registers are in the extended RAM area.
// You need to set bit7 of P_SW2 EAXFR to 1 to read and write them normally.
#define COMEN (*(unsigned char volatile xdata *)0xfb00) //LED Common Enable
   #define C0EN 0x01 //
   #define C1EN 0x02 //
   #define C2EN 0x04 //
   #define C3EN 0x08 //
   #define C4EN 0x10 //
   #define C5EN 0x20 //
   #define C6EN 0x40 //
   #define C7EN 0x80 //
#define SEGENL (*(unsigned char volatile xdata *)0xfb01) //Segment Enable Low Byte
   #define S0EN 0x01 //
   #define S1EN 0x02 //
   #define S2EN 0x04 //
   #define S3EN 0x08 //
   #define S4EN 0x10 //
   #define S5EN 0x20 //
   #define S6EN 0x40 //
   #define S7EN 0x80 //
#define SEGENH (*(unsigned char volatile xdata *)0xfb02) //Segment Enable High Byte
   #define S8EN  0x01 //
   #define S9EN  0x02 //
   #define S10EN 0x04 //
   #define S11EN 0x08 //
   #define S12EN 0x10 //
   #define S13EN 0x20 //
   #define S14EN 0x40 //
   #define S15EN 0x80 //
#define LEDCTRL (*(unsigned char volatile xdata *)0xfb03) //LED Control
   #define LEDDUTY 0x07 //LED Duty Cycle Adjustment
   #define LEDMODE 0x30 //LED Driver Mode
   #define LEDON   0x80 //LED Driver Enable
#define LEDCKS (*(unsigned char volatile xdata *)0xfb04) //LED Clock Division
#define COM0_DA_L (*(unsigned char volatile xdata *)0xfb10) //Common Anode阳 Display Data 0
#define COM1_DA_L (*(unsigned char volatile xdata *)0xfb11) //Common Anode阳 Display Data 1
#define COM2_DA_L (*(unsigned char volatile xdata *)0xfb12) //Common Anode阳 Display Data 2
#define COM3_DA_L (*(unsigned char volatile xdata *)0xfb13) //Common Anode阳 Display Data 3
#define COM4_DA_L (*(unsigned char volatile xdata *)0xfb14) //Common Anode阳 Display Data 4
#define COM5_DA_L (*(unsigned char volatile xdata *)0xfb15) //Common Anode阳 Display Data 5
#define COM6_DA_L (*(unsigned char volatile xdata *)0xfb16) //Common Anode阳 Display Data 6
#define COM7_DA_L (*(unsigned char volatile xdata *)0xfb17) //Common Anode阳 Display Data 7
#define COM0_DA_H (*(unsigned char volatile xdata *)0xfb18) //Common Anode阳 Display Data 8
#define COM1_DA_H (*(unsigned char volatile xdata *)0xfb19) //Common Anode阳 Display Data 9
#define COM2_DA_H (*(unsigned char volatile xdata *)0xfb1a) //Common Anode阳 Display Data 10
#define COM3_DA_H (*(unsigned char volatile xdata *)0xfb1b) //Common Anode阳 Display Data 11
#define COM4_DA_H (*(unsigned char volatile xdata *)0xfb1c) //Common Anode阳 Display Data 12
#define COM5_DA_H (*(unsigned char volatile xdata *)0xfb1d) //Common Anode阳 Display Data 13
#define COM6_DA_H (*(unsigned char volatile xdata *)0xfb1e) //Common Anode阳 Display Data 14
#define COM7_DA_H (*(unsigned char volatile xdata *)0xfb1f) //Common Anode阳 Display Data 15
#define COM0_DC_L (*(unsigned char volatile xdata *)0xfb20) //Common Cathode阴 Display Data 0
#define COM1_DC_L (*(unsigned char volatile xdata *)0xfb21) //Common Cathode阴 Display Data 1
#define COM2_DC_L (*(unsigned char volatile xdata *)0xfb22) //Common Cathode阴 Display Data 2
#define COM3_DC_L (*(unsigned char volatile xdata *)0xfb23) //Common Cathode阴 Display Data 3
#define COM4_DC_L (*(unsigned char volatile xdata *)0xfb24) //Common Cathode阴 Display Data 4
#define COM5_DC_L (*(unsigned char volatile xdata *)0xfb25) //Common Cathode阴 Display Data 5
#define COM6_DC_L (*(unsigned char volatile xdata *)0xfb26) //Common Cathode阴 Display Data 6
#define COM7_DC_L (*(unsigned char volatile xdata *)0xfb27) //Common Cathode阴 Display Data 7
#define COM0_DC_H (*(unsigned char volatile xdata *)0xfb28) //Common Cathode阴 Display Data 8
#define COM1_DC_H (*(unsigned char volatile xdata *)0xfb29) //Common Cathode阴 Display Data 9
#define COM2_DC_H (*(unsigned char volatile xdata *)0xfb2a) //Common Cathode阴 Display Data 10
#define COM3_DC_H (*(unsigned char volatile xdata *)0xfb2b) //Common Cathode阴 Display Data 11
#define COM4_DC_H (*(unsigned char volatile xdata *)0xfb2c) //Common Cathode阴 Display Data 12
#define COM5_DC_H (*(unsigned char volatile xdata *)0xfb2d) //Common Cathode阴 Display Data 13
#define COM6_DC_H (*(unsigned char volatile xdata *)0xfb2e) //Common Cathode阴 Display Data 14
#define COM7_DC_H (*(unsigned char volatile xdata *)0xfb2f) //Common Cathode阴 Display Data 15
#define TSCHEN1 (*(unsigned char volatile xdata *)0xfb40) //Touch Sensor Enable Register 1
   #define TKEN0 0x01 //
   #define TKEN1 0x02 //
   #define TKEN2 0x04 //
   #define TKEN3 0x08 //
   #define TKEN4 0x10 //
   #define TKEN5 0x20 //
   #define TKEN6 0x40 //
   #define TKEN7 0x80 //
#define TSCHEN2 (*(unsigned char volatile xdata *)0xfb41) //Touch Sensor Enable Register 2
   #define TKEN8  0x01 //
   #define TKEN9  0x02 //
   #define TKEN10 0x04 //
   #define TKEN11 0x08 //
   #define TKEN12 0x10 //
   #define TKEN13 0x20 //
   #define TKEN14 0x40 //
   #define TKEN15 0x80 //
#define TSCFG1 (*(unsigned char volatile xdata *)0xfb42) //Touch Sensor Config Register 1
   #define DT  0x07 //Discharge Time
   #define SCR 0x70 //Switched Capacitor Rate
#define TSCFG2 (*(unsigned char volatile xdata *)0xfb43) //Touch Sensor Config Register 2
   #define TSVR 0x03 //Touch Sensor Voltage Reference
#define TSWUTC (*(unsigned char volatile xdata *)0xfb44) //Touch Sensor Wakeup Control
#define TSCTRL (*(unsigned char volatile xdata *)0xfb45) //Touch Sensor Control
   #define TSSAMP 0x03 //Touch Sensor Multiple Scan Averaging
   #define TSWUEN 0x04 //Touch Sensor Wakeup Enable
   #define TSDCEN 0x08 //Touch Sensor Digital Comparator Enable
   #define TSWUCS 0x10 //Touch Sensor Wakeup Clock Select
   #define TSWAIT 0x20 //Touch Sensor WAIT Control
   #define SINGLE 0x40 //Single Scan Mode Control
   #define TSGO   0x80 //Touch Sensor Enable
#define TSSTA1 (*(unsigned char volatile xdata *)0xfb46) //Touch Sensor Status Register 1
   #define TSWKCHN 0x0F //Touch Sensor Scan Status Flags
   #define LEDWK   0x80 //LED Working Status
#define TSSTA2 (*(unsigned char volatile xdata *)0xfb47) //Touch Sensor Status Register 2
   #define TSDNCHN 0x0F //Touch Sensor Channel Completion Status
   #define TSDOV   0x40 //Touch Sensor Data Overflow Flag
   #define TSIF    0x80 //Touch Sensor Interrup Flag
#define TSRT (*(unsigned char volatile xdata *)0xfb48) //Touch Sensor Time Control
#define TSDAT (*(unsigned int  volatile xdata *)0xfb49) //Touch Sensor Data Word
#define TSDATH (*(unsigned char volatile xdata *)0xfb49) //Touch Sensor Data High Byte
#define TSDATL (*(unsigned char volatile xdata *)0xfb4a) //Touch Sensor Data Low Byte
#define TSTH00 (*(unsigned int  volatile xdata *)0xfb50) //Touch Sensor 0 Threshold Word
#define TSTH00H (*(unsigned char volatile xdata *)0xfb50) //Touch Sensor 0 Threshold High Byte
#define TSTH00L (*(unsigned char volatile xdata *)0xfb51) //Touch Sensor 0 Threshold Low Byte
#define TSTH01 (*(unsigned int  volatile xdata *)0xfb52) //Touch Sensor 1 Threshold Word
#define TSTH01H (*(unsigned char volatile xdata *)0xfb52) //Touch Sensor 1 Threshold High Byte
#define TSTH01L (*(unsigned char volatile xdata *)0xfb53) //Touch Sensor 1 Threshold Low Byte
#define TSTH02 (*(unsigned int  volatile xdata *)0xfb54) //Touch Sensor 2 Threshold Word
#define TSTH02H (*(unsigned char volatile xdata *)0xfb54) //Touch Sensor 2 Threshold High Byte
#define TSTH02L (*(unsigned char volatile xdata *)0xfb55) //Touch Sensor 2 Threshold Low Byte
#define TSTH03 (*(unsigned int  volatile xdata *)0xfb56) //Touch Sensor 3 Threshold Word
#define TSTH03H (*(unsigned char volatile xdata *)0xfb56) //Touch Sensor 3 Threshold High Byte
#define TSTH03L (*(unsigned char volatile xdata *)0xfb57) //Touch Sensor 3 Threshold Low Byte
#define TSTH04 (*(unsigned int  volatile xdata *)0xfb58) //Touch Sensor 4 Threshold Word
#define TSTH04H (*(unsigned char volatile xdata *)0xfb58) //Touch Sensor 4 Threshold High Byte
#define TSTH04L (*(unsigned char volatile xdata *)0xfb59) //Touch Sensor 4 Threshold Low Byte
#define TSTH05 (*(unsigned int  volatile xdata *)0xfb5a) //Touch Sensor 5 Threshold Word
#define TSTH05H (*(unsigned char volatile xdata *)0xfb5a) //Touch Sensor 5 Threshold High Byte
#define TSTH05L (*(unsigned char volatile xdata *)0xfb5b) //Touch Sensor 5 Threshold Low Byte
#define TSTH06 (*(unsigned int  volatile xdata *)0xfb5c) //Touch Sensor 6 Threshold Word
#define TSTH06H (*(unsigned char volatile xdata *)0xfb5c) //Touch Sensor 6 Threshold High Byte
#define TSTH06L (*(unsigned char volatile xdata *)0xfb5d) //Touch Sensor 6 Threshold Low Byte
#define TSTH07 (*(unsigned int  volatile xdata *)0xfb5e) //Touch Sensor 7 Threshold Word
#define TSTH07H (*(unsigned char volatile xdata *)0xfb5e) //Touch Sensor 7 Threshold High Byte
#define TSTH07L (*(unsigned char volatile xdata *)0xfb5f) //Touch Sensor 7 Threshold Low Byte
#define TSTH08 (*(unsigned int  volatile xdata *)0xfb60) //Touch Sensor 8 Threshold Word
#define TSTH08H (*(unsigned char volatile xdata *)0xfb60) //Touch Sensor 8 Threshold High Byte
#define TSTH08L (*(unsigned char volatile xdata *)0xfb61) //Touch Sensor 8 Threshold Low Byte
#define TSTH09 (*(unsigned int  volatile xdata *)0xfb62) //Touch Sensor 9 Threshold Word
#define TSTH09H (*(unsigned char volatile xdata *)0xfb62) //Touch Sensor 9 Threshold High Byte
#define TSTH09L (*(unsigned char volatile xdata *)0xfb63) //Touch Sensor 9 Threshold Low Byte
#define TSTH10 (*(unsigned int  volatile xdata *)0xfb64) //Touch Sensor 10 Threshold Word
#define TSTH10H (*(unsigned char volatile xdata *)0xfb64) //Touch Sensor 10 Threshold High Byte
#define TSTH10L (*(unsigned char volatile xdata *)0xfb65) //Touch Sensor 10 Threshold Low Byte
#define TSTH11 (*(unsigned int  volatile xdata *)0xfb66) //Touch Sensor 11 Threshold Word
#define TSTH11H (*(unsigned char volatile xdata *)0xfb66) //Touch Sensor 11 Threshold High Byte
#define TSTH11L (*(unsigned char volatile xdata *)0xfb67) //Touch Sensor 11 Threshold Low Byte
#define TSTH12 (*(unsigned int  volatile xdata *)0xfb68) //Touch Sensor 12 Threshold Word
#define TSTH12H (*(unsigned char volatile xdata *)0xfb68) //Touch Sensor 12 Threshold High Byte
#define TSTH12L (*(unsigned char volatile xdata *)0xfb69) //Touch Sensor 12 Threshold Low Byte
#define TSTH13 (*(unsigned int  volatile xdata *)0xfb6a) //Touch Sensor 13 Threshold Word
#define TSTH13H (*(unsigned char volatile xdata *)0xfb6a) //Touch Sensor 13 Threshold High Byte
#define TSTH13L (*(unsigned char volatile xdata *)0xfb6b) //Touch Sensor 13 Threshold Low Byte
#define TSTH14 (*(unsigned int  volatile xdata *)0xfb6c) //Touch Sensor 14 Threshold Word
#define TSTH14H (*(unsigned char volatile xdata *)0xfb6c) //Touch Sensor 14 Threshold High Byte
#define TSTH14L (*(unsigned char volatile xdata *)0xfb6d) //Touch Sensor 14 Threshold Low Byte
#define TSTH15 (*(unsigned int  volatile xdata *)0xfb6e) //Touch Sensor 15 Threshold Word
#define TSTH15H (*(unsigned char volatile xdata *)0xfb6e) //Touch Sensor 15 Threshold High Byte
#define TSTH15L (*(unsigned char volatile xdata *)0xfb6f) //Touch Sensor 15 Threshold Low Byte
#define PWM3C (*(unsigned int  volatile xdata *)0xfc00) //PWM 3 Counter Word
#define PWM3CH (*(unsigned char volatile xdata *)0xfc00) //PWM 3 Counter High Byte
#define PWM3CL (*(unsigned char volatile xdata *)0xfc01) //PWM 3 Counter Low Byte
#define PWM3CKS (*(unsigned char volatile xdata *)0xfc02) //PWM 3 Clock Selection
   #define PWM_PS 0x0F //PWM System Clock Prescaler
   #define SELT2  0x10 //PWM Clock Source Selection
#define PWM3IF (*(unsigned char volatile xdata *)0xfc05) //PWM 3 Interrupt Flags
   #define C0IF 0x01 //Channel 0 Interrupt Flag
   #define C1IF 0x02 //Channel 1 Interrupt Flag
   #define C2IF 0x04 //Channel 2 Interrupt Flag
   #define C3IF 0x08 //Channel 3 Interrupt Flag
   #define C4IF 0x10 //Channel 4 Interrupt Flag
   #define C5IF 0x20 //Channel 5 Interrupt Flag
   #define C6IF 0x40 //Channel 6 Interrupt Flag
   #define C7IF 0x80 //Channel 7 Interrupt Flag
#define PWM3FDCR (*(unsigned char volatile xdata *)0xfc06) //PWM 3 Fault Detect Control Register
   #define FDIF    0x01 //Fault Detect Interrupt Flag
   #define FDIO    0x02 //IO Port Fault Detect
   #define FDCMP   0x04 //Comparator Fault Detect
   #define EFDI    0x08 //Enable Fault Detect Interrupt
   #define FLTFLIO 0x10 //Fault Detect IO Port Action
   #define ENFD    0x20 //Enable Fault Detect
   #define INVIO   0x40 //Invert IO Port Fault Detect Level
   #define INVCMP  0x80 //Invert Comparator Fault Detect Level
#define PWM30T1 (*(unsigned int  volatile xdata *)0xfc10) //PWM 3 Chanel 0 Timer 1 Word
#define PWM30T1H (*(unsigned char volatile xdata *)0xfc10) //PWM 3 Chanel 0 Timer 1 High Byte
#define PWM30T1L (*(unsigned char volatile xdata *)0xfc11) //PWM 3 Chanel 0 Timer 1 Low Byte
#define PWM30T2 (*(unsigned int  volatile xdata *)0xfc12) //PWM 3 Chanel 0 Timer 2 Word
#define PWM30T2H (*(unsigned char volatile xdata *)0xfc12) //PWM 3 Chanel 0 Timer 2 High Byte
#define PWM30T2L (*(unsigned char volatile xdata *)0xfc13) //PWM 3 Chanel 0 Timer 2 Low Byte
#define PWM30CR (*(unsigned char volatile xdata *)0xfc14) //PWM 3 Chanel 0 Control Register
   #define PWM30_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM30_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM30_ENI   0x04 //Enable Interrupt
   #define PWM30_INI   0x40 //Initial Output Level
   #define PWM30_ENO   0x80 //PWM Output Enable Bit
#define PWM30HLD (*(unsigned char volatile xdata *)0xfc15) //PWM 3 Chanel 0 Level Hold Control
   #define PWM30_HLDL 0x01 //Hold Low Override
   #define PWM30_HLDH 0x02 //Hold High Override
#define PWM31T1 (*(unsigned int  volatile xdata *)0xfc18) //PWM 3 Chanel 1 Timer 1 Word
#define PWM31T1H (*(unsigned char volatile xdata *)0xfc18) //PWM 3 Chanel 1 Timer 1 High Byte
#define PWM31T1L (*(unsigned char volatile xdata *)0xfc19) //PWM 3 Chanel 1 Timer 1 Low Byte
#define PWM31T2 (*(unsigned int  volatile xdata *)0xfc1a) //PWM 3 Chanel 1 Timer 2 Word
#define PWM31T2H (*(unsigned char volatile xdata *)0xfc1a) //PWM 3 Chanel 1 Timer 2 High Byte
#define PWM31T2L (*(unsigned char volatile xdata *)0xfc1b) //PWM 3 Chanel 1 Timer 2 Low Byte
#define PWM31CR (*(unsigned char volatile xdata *)0xfc1c) //PWM 3 Chanel 1 Control Register
   #define PWM31_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM31_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM31_ENI   0x04 //Enable Interrupt
   #define PWM31_INI   0x40 //Initial Output Level
   #define PWM31_ENO   0x80 //PWM Output Enable Bit
#define PWM31HLD (*(unsigned char volatile xdata *)0xfc1d) //PWM 3 Chanel 1 Level Hold Control
   #define PWM31_HLDL 0x01 //Hold Low Override
   #define PWM31_HLDH 0x02 //Hold High Override
#define PWM32T1 (*(unsigned int  volatile xdata *)0xfc20) //PWM 3 Chanel 2 Timer 1 Word
#define PWM32T1H (*(unsigned char volatile xdata *)0xfc20) //PWM 3 Chanel 2 Timer 1 High Byte
#define PWM32T1L (*(unsigned char volatile xdata *)0xfc21) //PWM 3 Chanel 2 Timer 1 Low Byte
#define PWM32T2 (*(unsigned int  volatile xdata *)0xfc22) //PWM 3 Chanel 2 Timer 2 Word
#define PWM32T2H (*(unsigned char volatile xdata *)0xfc22) //PWM 3 Chanel 2 Timer 2 High Byte
#define PWM32T2L (*(unsigned char volatile xdata *)0xfc23) //PWM 3 Chanel 2 Timer 2 Low Byte
#define PWM32CR (*(unsigned char volatile xdata *)0xfc24) //PWM 3 Chanel 2 Control Register
   #define PWM32_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM32_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM32_ENI   0x04 //Enable Interrupt
   #define PWM32_INI   0x40 //Initial Output Level
   #define PWM32_ENO   0x80 //PWM Output Enable Bit
#define PWM32HLD (*(unsigned char volatile xdata *)0xfc25) //PWM 3 Chanel 2 Level Hold Control
   #define PWM32_HLDL 0x01 //Hold Low Override
   #define PWM32_HLDH 0x02 //Hold High Override
#define PWM33T1 (*(unsigned int  volatile xdata *)0xfc28) //PWM 3 Chanel 3 Timer 1 Word
#define PWM33T1H (*(unsigned char volatile xdata *)0xfc28) //PWM 3 Chanel 3 Timer 1 High Byte
#define PWM33T1L (*(unsigned char volatile xdata *)0xfc29) //PWM 3 Chanel 3 Timer 1 Low Byte
#define PWM33T2 (*(unsigned int  volatile xdata *)0xfc2a) //PWM 3 Chanel 3 Timer 2 Word
#define PWM33T2H (*(unsigned char volatile xdata *)0xfc2a) //PWM 3 Chanel 3 Timer 2 High Byte
#define PWM33T2L (*(unsigned char volatile xdata *)0xfc2b) //PWM 3 Chanel 3 Timer 2 Low Byte
#define PWM33CR (*(unsigned char volatile xdata *)0xfc2c) //PWM 3 Chanel 3 Control Register
   #define PWM33_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM33_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM33_ENI   0x04 //Enable Interrupt
   #define PWM33_INI   0x40 //Initial Output Level
   #define PWM33_ENO   0x80 //Output Enable
#define PWM33HLD (*(unsigned char volatile xdata *)0xfc2d) //PWM 3 Chanel 3 Level Hold Control
   #define PWM33_HLDL 0x01 //Hold Low Override
   #define PWM33_HLDH 0x02 //Hold High Override
#define PWM34T1 (*(unsigned int  volatile xdata *)0xfc30) //PWM 3 Chanel 4 Timer 1 Word
#define PWM34T1H (*(unsigned char volatile xdata *)0xfc30) //PWM 3 Chanel 4 Timer 1 High Byte
#define PWM34T1L (*(unsigned char volatile xdata *)0xfc31) //PWM 3 Chanel 4 Timer 1 Low Byte
#define PWM34T2 (*(unsigned int  volatile xdata *)0xfc32) //PWM 3 Chanel 4 Timer 2 Word
#define PWM34T2H (*(unsigned char volatile xdata *)0xfc32) //PWM 3 Chanel 4 Timer 2 High Byte
#define PWM34T2L (*(unsigned char volatile xdata *)0xfc33) //PWM 3 Chanel 4 Timer 2 Low Byte
#define PWM34CR (*(unsigned char volatile xdata *)0xfc34) //PWM 3 Chanel 4 Control Register
   #define PWM34_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM34_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM34_ENI   0x04 //Enable Interrupt
   #define PWM34_INI   0x40 //Initial Output Level
   #define PWM34_ENO   0x80 //Output Enable
#define PWM34HLD (*(unsigned char volatile xdata *)0xfc35) //PWM 3 Chanel 4 Level Hold Control
   #define PWM34_HLDL 0x01 //Hold Low Override
   #define PWM34_HLDH 0x02 //Hold High Override
#define PWM35T1 (*(unsigned int  volatile xdata *)0xfc38) //PWM 3 Chanel 5 Timer 1 Word
#define PWM35T1H (*(unsigned char volatile xdata *)0xfc38) //PWM 3 Chanel 5 Timer 1 High Byte
#define PWM35T1L (*(unsigned char volatile xdata *)0xfc39) //PWM 3 Chanel 5 Timer 1 Low Byte
#define PWM35T2 (*(unsigned int  volatile xdata *)0xfc3a) //PWM 3 Chanel 5 Timer 2 Word
#define PWM35T2H (*(unsigned char volatile xdata *)0xfc3a) //PWM 3 Chanel 5 Timer 2 High Byte
#define PWM35T2L (*(unsigned char volatile xdata *)0xfc3b) //PWM 3 Chanel 5 Timer 2 Low Byte
#define PWM35CR (*(unsigned char volatile xdata *)0xfc3c) //PWM 3 Chanel 5 Control Register
   #define PWM35_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM35_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM35_ENI   0x04 //Enable Interrupt
   #define PWM35_INI   0x40 //Initial Output Level
   #define PWM35_ENO   0x80 //Output Enable
#define PWM35HLD (*(unsigned char volatile xdata *)0xfc3d) //PWM 3 Chanel 5 Level Hold Control
   #define PWM35_HLDL 0x01 //Hold Low Override
   #define PWM35_HLDH 0x02 //Hold High Override
#define PWM36T1 (*(unsigned int  volatile xdata *)0xfc40) //PWM 3 Chanel 6 Timer 1 Word
#define PWM36T1H (*(unsigned char volatile xdata *)0xfc40) //PWM 3 Chanel 6 Timer 1 High Byte
#define PWM36T1L (*(unsigned char volatile xdata *)0xfc41) //PWM 3 Chanel 6 Timer 1 Low Byte
#define PWM36T2 (*(unsigned int  volatile xdata *)0xfc42) //PWM 3 Chanel 6 Timer 2 Word
#define PWM36T2H (*(unsigned char volatile xdata *)0xfc42) //PWM 3 Chanel 6 Timer 2 High Byte
#define PWM36T2L (*(unsigned char volatile xdata *)0xfc43) //PWM 3 Chanel 7 Timer 2 Low Byte
#define PWM36CR (*(unsigned char volatile xdata *)0xfc44) //PWM 3 Chanel 6 Control Register
   #define PWM36_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM36_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM36_ENI   0x04 //Enable Interrupt
   #define PWM36_INI   0x40 //Initial Output Level
   #define PWM36_ENO   0x80 //Output Enable
#define PWM36HLD (*(unsigned char volatile xdata *)0xfc45) //PWM 3 Chanel 6 Level Hold Control
   #define PWM36_HLDL 0x01 //Hold Low Override
   #define PWM36_HLDH 0x02 //Hold High Override
#define PWM37T1 (*(unsigned int  volatile xdata *)0xfc48) //PWM 3 Chanel 7 Timer 1 Word
#define PWM37T1H (*(unsigned char volatile xdata *)0xfc48) //PWM 3 Chanel 7 Timer 1 High Byte
#define PWM37T1L (*(unsigned char volatile xdata *)0xfc49) //PWM 3 Chanel 7 Timer 1 Low Byte
#define PWM37T2 (*(unsigned int  volatile xdata *)0xfc4a) //PWM 3 Chanel 7 Timer 2 Word
#define PWM37T2H (*(unsigned char volatile xdata *)0xfc4a) //PWM 3 Chanel 7 Timer 2 High Byte
#define PWM37T2L (*(unsigned char volatile xdata *)0xfc4b) //PWM 3 Chanel 7 Timer 2 Low Byte
#define PWM37CR (*(unsigned char volatile xdata *)0xfc4c) //PWM 3 Chanel 7 Control Register
   #define PWM37_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM37_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM37_ENI   0x04 //Enable Interrupt
   #define PWM37_INI   0x40 //Initial Output Level
   #define PWM37_ENO   0x80 //Output Enable
#define PWM37HLD (*(unsigned char volatile xdata *)0xfc4d) //PWM 3 Chanel 7 Level Hold Control
   #define PWM37_HLDL 0x01 //Hold Low Override
   #define PWM37_HLDH 0x02 //Hold High Override
#define PWM4C (*(unsigned int  volatile xdata *)0xfc50) //PWM 4 Counter Word
#define PWM4CH (*(unsigned char volatile xdata *)0xfc50) //PWM 4 Counter High Byte
#define PWM4CL (*(unsigned char volatile xdata *)0xfc51) //PWM 4 Counter Low Byte
#define PWM4CKS (*(unsigned char volatile xdata *)0xfc52) //PWM 4 Clock Selection
   #define PWM_PS 0x0F //PWM System Clock Prescaler
   #define SELT2  0x10 //PWM Clock Source Selection
#define PWM4TADC (*(unsigned int  volatile xdata *)0xfc53) //PWM 4 Trigger ADC Count Word
#define PWM4TADCH (*(unsigned char volatile xdata *)0xfc53) //PWM 4 Trigger ADC Count High Byte
#define PWM4TADCL (*(unsigned char volatile xdata *)0xfc54) //PWM 4 Trigger ADC Count Low Byte
#define PWM4IF (*(unsigned char volatile xdata *)0xfc55) //PWM 4 Interrupt Flags
   #define C0IF 0x01 //Channel 0 Interrupt Flag
   #define C1IF 0x02 //Channel 1 Interrupt Flag
   #define C2IF 0x04 //Channel 2 Interrupt Flag
   #define C3IF 0x08 //Channel 3 Interrupt Flag
   #define C4IF 0x10 //Channel 4 Interrupt Flag
   #define C5IF 0x20 //Channel 5 Interrupt Flag
   #define C6IF 0x40 //Channel 6 Interrupt Flag
   #define C7IF 0x80 //Channel 7 Interrupt Flag
#define PWM4FDCR (*(unsigned char volatile xdata *)0xfc56) //PWM 4 Fault Detect Control Register
   #define FDIF    0x01 //Fault Detect Interrupt Flag
   #define FDIO    0x02 //IO Port Fault Detect
   #define FDCMP   0x04 //Comparator Fault Detect
   #define EFDI    0x08 //Enable Fault Detect Interrupt
   #define FLTFLIO 0x10 //Fault Detect IO Port Action
   #define ENFD    0x20 //Enable Fault Detect
   #define INVIO   0x40 //Invert IO Port Fault Detect Level
   #define INVCMP  0x80 //Invert Comparator Fault Detect Level
#define PWM40T1 (*(unsigned int  volatile xdata *)0xfc60) //PWM 4 Chanel 0 Timer 1 Word
#define PWM40T1H (*(unsigned char volatile xdata *)0xfc60) //PWM 4 Chanel 0 Timer 1 High Byte
#define PWM40T1L (*(unsigned char volatile xdata *)0xfc61) //PWM 4 Chanel 0 Timer 1 Low Byte
#define PWM40T2 (*(unsigned int  volatile xdata *)0xfc62) //PWM 4 Chanel 0 Timer 2 Word
#define PWM40T2H (*(unsigned char volatile xdata *)0xfc62) //PWM 4 Chanel 0 Timer 2 High Byte
#define PWM40T2L (*(unsigned char volatile xdata *)0xfc63) //PWM 4 Chanel 0 Timer 2 Low Byte
#define PWM40CR (*(unsigned char volatile xdata *)0xfc64) //PWM 4 Chanel 0 Control Register
   #define PWM40_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM40_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM40_ENI   0x04 //Enable Interrupt
   #define PWM40_INI   0x40 //Initial Output Level
   #define PWM40_ENO   0x80 //PWM Output Enable Bit
#define PWM40HLD (*(unsigned char volatile xdata *)0xfc65) //PWM 4 Chanel 0 Level Hold Control
   #define PWM40_HLDL 0x01 //Hold Low Override
   #define PWM40_HLDH 0x02 //Hold High Override
#define PWM41T1 (*(unsigned int  volatile xdata *)0xfc68) //PWM 4 Chanel 1 Timer 1 Word
#define PWM41T1H (*(unsigned char volatile xdata *)0xfc68) //PWM 4 Chanel 1 Timer 1 High Byte
#define PWM41T1L (*(unsigned char volatile xdata *)0xfc69) //PWM 4 Chanel 1 Timer 1 Low Byte
#define PWM41T2 (*(unsigned int  volatile xdata *)0xfc6a) //PWM 4 Chanel 1 Timer 2 Word
#define PWM41T2H (*(unsigned char volatile xdata *)0xfc6a) //PWM 4 Chanel 1 Timer 2 High Byte
#define PWM41T2L (*(unsigned char volatile xdata *)0xfc6b) //PWM 4 Chanel 1 Timer 2 Low Byte
#define PWM41CR (*(unsigned char volatile xdata *)0xfc6c) //PWM 4 Chanel 1 Control Register
   #define PWM41_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM41_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM41_ENI   0x04 //Enable Interrupt
   #define PWM41_INI   0x40 //Initial Output Level
   #define PWM41_ENO   0x80 //PWM Output Enable Bit
#define PWM41HLD (*(unsigned char volatile xdata *)0xfc6d) //PWM 4 Chanel 1 Level Hold Control
   #define PWM41_HLDL 0x01 //Hold Low Override
   #define PWM41_HLDH 0x02 //Hold High Override
#define PWM42T1 (*(unsigned int  volatile xdata *)0xfc70) //PWM 4 Chanel 2 Timer 1 Word
#define PWM42T1H (*(unsigned char volatile xdata *)0xfc70) //PWM 4 Chanel 2 Timer 1 High Byte
#define PWM42T1L (*(unsigned char volatile xdata *)0xfc71) //PWM 4 Chanel 2 Timer 1 Low Byte
#define PWM42T2 (*(unsigned int  volatile xdata *)0xfc72) //PWM 4 Chanel 2 Timer 2 Word
#define PWM42T2H (*(unsigned char volatile xdata *)0xfc72) //PWM 4 Chanel 2 Timer 2 High Byte
#define PWM42T2L (*(unsigned char volatile xdata *)0xfc73) //PWM 4 Chanel 2 Timer 2 Low Byte
#define PWM42CR (*(unsigned char volatile xdata *)0xfc74) //PWM 4 Chanel 2 Control Register
   #define PWM42_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM42_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM42_ENI   0x04 //Enable Interrupt
   #define PWM42_INI   0x40 //Initial Output Level
   #define PWM42_ENO   0x80 //PWM Output Enable Bit
#define PWM42HLD (*(unsigned char volatile xdata *)0xfc75) //PWM 4 Chanel 2 Level Hold Control
   #define PWM42_HLDL 0x01 //Hold Low Override
   #define PWM42_HLDH 0x02 //Hold High Override
#define PWM43T1 (*(unsigned int  volatile xdata *)0xfc78) //PWM 4 Chanel 3 Timer 1 Word
#define PWM43T1H (*(unsigned char volatile xdata *)0xfc78) //PWM 4 Chanel 3 Timer 1 High Byte
#define PWM43T1L (*(unsigned char volatile xdata *)0xfc79) //PWM 4 Chanel 3 Timer 1 Low Byte
#define PWM43T2 (*(unsigned int  volatile xdata *)0xfc7a) //PWM 4 Chanel 3 Timer 2 Word
#define PWM43T2H (*(unsigned char volatile xdata *)0xfc7a) //PWM 4 Chanel 3 Timer 2 High Byte
#define PWM43T2L (*(unsigned char volatile xdata *)0xfc7b) //PWM 4 Chanel 3 Timer 2 Low Byte
#define PWM43CR (*(unsigned char volatile xdata *)0xfc7c) //PWM 4 Chanel 3 Control Register
   #define PWM43_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM43_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM43_ENI   0x04 //Enable Interrupt
   #define PWM43_INI   0x40 //Initial Output Level
   #define PWM43_ENO   0x80 //PWM Output Enable Bit
#define PWM43HLD (*(unsigned char volatile xdata *)0xfc7d) //PWM 4 Chanel 3 Level Hold Control
   #define PWM43_HLDL 0x01 //Hold Low Override
   #define PWM43_HLDH 0x02 //Hold High Override
#define PWM44T1 (*(unsigned int  volatile xdata *)0xfc80) //PWM 4 Chanel 4 Timer 1 Word
#define PWM44T1H (*(unsigned char volatile xdata *)0xfc80) //PWM 4 Chanel 4 Timer 1 High Byte
#define PWM44T1L (*(unsigned char volatile xdata *)0xfc81) //PWM 4 Chanel 4 Timer 1 Low Byte
#define PWM44T2 (*(unsigned int  volatile xdata *)0xfc82) //PWM 4 Chanel 4 Timer 2 Word
#define PWM44T2H (*(unsigned char volatile xdata *)0xfc82) //PWM 4 Chanel 4 Timer 2 High Byte
#define PWM44T2L (*(unsigned char volatile xdata *)0xfc83) //PWM 4 Chanel 4 Timer 2 Low Byte
#define PWM44CR (*(unsigned char volatile xdata *)0xfc84) //PWM 4 Chanel 4 Control Register
   #define PWM44_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM44_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM44_ENI   0x04 //Enable Interrupt
   #define PWM44_INI   0x40 //Initial Output Level
   #define PWM44_ENO   0x80 //PWM Output Enable Bit
#define PWM44HLD (*(unsigned char volatile xdata *)0xfc85) //PWM 4 Chanel 4 Level Hold Control
   #define PWM44_HLDL 0x01 //Hold Low Override
   #define PWM44_HLDH 0x02 //Hold High Override
#define PWM45T1 (*(unsigned int  volatile xdata *)0xfc88) //PWM 4 Chanel 5 Timer 1 Word
#define PWM45T1H (*(unsigned char volatile xdata *)0xfc88) //PWM 4 Chanel 5 Timer 1 High Byte
#define PWM45T1L (*(unsigned char volatile xdata *)0xfc89) //PWM 4 Chanel 5 Timer 1 Low Byte
#define PWM45T2 (*(unsigned int  volatile xdata *)0xfc8a) //PWM 4 Chanel 5 Timer 2 Word
#define PWM45T2H (*(unsigned char volatile xdata *)0xfc8a) //PWM 4 Chanel 5 Timer 2 High Byte
#define PWM45T2L (*(unsigned char volatile xdata *)0xfc8b) //PWM 4 Chanel 5 Timer 2 Low Byte
#define PWM45CR (*(unsigned char volatile xdata *)0xfc8c) //PWM 4 Chanel 5 Control Register
   #define PWM45_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM45_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM45_ENI   0x04 //Enable Interrupt
   #define PWM45_INI   0x40 //Initial Output Level
   #define PWM45_ENO   0x80 //PWM Output Enable Bit
#define PWM45HLD (*(unsigned char volatile xdata *)0xfc8d) //PWM 4 Chanel 5 Level Hold Control
   #define PWM45_HLDL 0x01 //Hold Low Override
   #define PWM45_HLDH 0x02 //Hold High Override
#define PWM46T1 (*(unsigned int  volatile xdata *)0xfc90) //PWM 4 Chanel 6 Timer 1 Word
#define PWM46T1H (*(unsigned char volatile xdata *)0xfc90) //PWM 4 Chanel 6 Timer 1 High Byte
#define PWM46T1L (*(unsigned char volatile xdata *)0xfc91) //PWM 4 Chanel 6 Timer 1 Low Byte
#define PWM46T2 (*(unsigned int  volatile xdata *)0xfc92) //PWM 4 Chanel 6 Timer 2 Word
#define PWM46T2H (*(unsigned char volatile xdata *)0xfc92) //PWM 4 Chanel 6 Timer 2 High Byte
#define PWM46T2L (*(unsigned char volatile xdata *)0xfc93) //PWM 4 Chanel 6 Timer 2 Low Byte
#define PWM46CR (*(unsigned char volatile xdata *)0xfc94) //PWM 4 Chanel 6 Control Register
   #define PWM46_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM46_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM46_ENI   0x04 //Enable Interrupt
   #define PWM46_INI   0x40 //Initial Output Level
   #define PWM46_ENO   0x80 //PWM Output Enable Bit
#define PWM46HLD (*(unsigned char volatile xdata *)0xfc95) //PWM 4 Chanel 6 Level Hold Control
   #define PWM46_HLDL 0x01 //Hold Low Override
   #define PWM46_HLDH 0x02 //Hold High Override
#define PWM47T1 (*(unsigned int  volatile xdata *)0xfc98) //PWM 4 Chanel 7 Timer 1 Word
#define PWM47T1H (*(unsigned char volatile xdata *)0xfc98) //PWM 4 Chanel 7 Timer 1 High Byte
#define PWM47T1L (*(unsigned char volatile xdata *)0xfc99) //PWM 4 Chanel 7 Timer 1 Low Byte
#define PWM47T2 (*(unsigned int  volatile xdata *)0xfc9a) //PWM 4 Chanel 7 Timer 2 Word
#define PWM47T2H (*(unsigned char volatile xdata *)0xfc9a) //PWM 4 Chanel 7 Timer 2 High Byte
#define PWM47T2L (*(unsigned char volatile xdata *)0xfc9b) //PWM 4 Chanel 7 Timer 2 Low Byte
#define PWM47CR (*(unsigned char volatile xdata *)0xfc9c) //PWM 4 Chanel 7 Control Register
   #define PWM47_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM47_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM47_ENI   0x04 //Enable Interrupt
   #define PWM47_INI   0x40 //Initial Output Level
   #define PWM47_ENO   0x80 //PWM Output Enable Bit
#define PWM47HLD (*(unsigned char volatile xdata *)0xfc9d) //PWM 4 Chanel 7 Level Hold Control
   #define PWM47_HLDL 0x01 //Hold Low Override
   #define PWM47_HLDH 0x02 //Hold High Override
#define PWM5C (*(unsigned int  volatile xdata *)0xfca0) //PWM 5 Counter Word
#define PWM5CH (*(unsigned char volatile xdata *)0xfca0) //PWM 5 Counter High Byte
#define PWM5CL (*(unsigned char volatile xdata *)0xfca1) //PWM 5 Counter Low Byte
#define PWM5CKS (*(unsigned char volatile xdata *)0xfca2) //PWM 5 Clock Selection
   #define PWM_PS 0x0F //PWM System Clock Prescaler
   #define SELT2  0x10 //PWM Clock Source Selection
#define PWM5IF (*(unsigned char volatile xdata *)0xfca5) //PWM 5 Interrupt Flags
   #define C0IF 0x01 //Channel 0 Interrupt Flag
   #define C1IF 0x02 //Channel 1 Interrupt Flag
   #define C2IF 0x04 //Channel 2 Interrupt Flag
   #define C3IF 0x08 //Channel 3 Interrupt Flag
   #define C4IF 0x10 //Channel 4 Interrupt Flag
   #define C5IF 0x20 //Channel 5 Interrupt Flag
   #define C6IF 0x40 //Channel 6 Interrupt Flag
   #define C7IF 0x80 //Channel 7 Interrupt Flag
#define PWM5FDCR (*(unsigned char volatile xdata *)0xfca6) //PWM 5 Fault Detect Control Register
   #define FDIF    0x01 //Fault Detect Interrupt Flag
   #define FDIO    0x02 //IO Port Fault Detect
   #define FDCMP   0x04 //Comparator Fault Detect
   #define EFDI    0x08 //Enable Fault Detect Interrupt
   #define FLTFLIO 0x10 //Fault Detect IO Port Action
   #define ENFD    0x20 //Enable Fault Detect
   #define INVIO   0x40 //Invert IO Port Fault Detect Level
   #define INVCMP  0x80 //Invert Comparator Fault Detect Level
#define PWM50T1 (*(unsigned int  volatile xdata *)0xfcb0) //PWM 5 Chanel 0 Timer 1 Word
#define PWM50T1H (*(unsigned char volatile xdata *)0xfcb0) //PWM 5 Chanel 0 Timer 1 High Byte
#define PWM50T1L (*(unsigned char volatile xdata *)0xfcb1) //PWM 5 Chanel 0 Timer 1 Low Byte
#define PWM50T2 (*(unsigned int  volatile xdata *)0xfcb2) //PWM 5 Chanel 0 Timer 2 Word
#define PWM50T2H (*(unsigned char volatile xdata *)0xfcb2) //PWM 5 Chanel 0 Timer 2 High Byte
#define PWM50T2L (*(unsigned char volatile xdata *)0xfcb3) //PWM 5 Chanel 0 Timer 2 Low Byte
#define PWM50CR (*(unsigned char volatile xdata *)0xfcb4) //PWM 5 Chanel 0 Control Register
   #define PWM50_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM50_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM50_ENI   0x04 //Enable Interrupt
   #define PWM50_INI   0x40 //Initial Output Level
   #define PWM50_ENO   0x80 //PWM Output Enable Bit
#define PWM50HLD (*(unsigned char volatile xdata *)0xfcb5) //PWM 5 Chanel 0 Level Hold Control
   #define PWM50_HLDL 0x01 //Hold Low Override
   #define PWM50_HLDH 0x02 //Hold High Override
#define PWM51T1 (*(unsigned int  volatile xdata *)0xfcb8) //PWM 5 Chanel 1 Timer 1 Word
#define PWM51T1H (*(unsigned char volatile xdata *)0xfcb8) //PWM 5 Chanel 1 Timer 1 High Byte
#define PWM51T1L (*(unsigned char volatile xdata *)0xfcb9) //PWM 5 Chanel 1 Timer 1 Low Byte
#define PWM51T2 (*(unsigned int  volatile xdata *)0xfcba) //PWM 5 Chanel 1 Timer 2 Word
#define PWM51T2H (*(unsigned char volatile xdata *)0xfcba) //PWM 5 Chanel 1 Timer 2 High Byte
#define PWM51T2L (*(unsigned char volatile xdata *)0xfcbb) //PWM 5 Chanel 1 Timer 2 Low Byte
#define PWM51CR (*(unsigned char volatile xdata *)0xfcbc) //PWM 5 Chanel 1 Control Register
   #define PWM51_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM51_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM51_ENI   0x04 //Enable Interrupt
   #define PWM51_INI   0x40 //Initial Output Level
   #define PWM51_ENO   0x80 //PWM Output Enable Bit
#define PWM51HLD (*(unsigned char volatile xdata *)0xfcbd) //PWM 5 Chanel 1 Level Hold Control
   #define PWM51_HLDL 0x01 //Hold Low Override
   #define PWM51_HLDH 0x02 //Hold High Override
#define PWM52T1 (*(unsigned int  volatile xdata *)0xfcc0) //PWM 5 Chanel 2 Timer 1 Word
#define PWM52T1H (*(unsigned char volatile xdata *)0xfcc0) //PWM 5 Chanel 2 Timer 1 High Byte
#define PWM52T1L (*(unsigned char volatile xdata *)0xfcc1) //PWM 5 Chanel 2 Timer 1 Low Byte
#define PWM52T2 (*(unsigned int  volatile xdata *)0xfcc2) //PWM 5 Chanel 2 Timer 2 Word
#define PWM52T2H (*(unsigned char volatile xdata *)0xfcc2) //PWM 5 Chanel 2 Timer 2 High Byte
#define PWM52T2L (*(unsigned char volatile xdata *)0xfcc3) //PWM 5 Chanel 2 Timer 2 Low Byte
#define PWM52CR (*(unsigned char volatile xdata *)0xfcc4) //PWM 5 Chanel 2 Control Register
   #define PWM52_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM52_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM52_ENI   0x04 //Enable Interrupt
   #define PWM52_INI   0x40 //Initial Output Level
   #define PWM52_ENO   0x80 //PWM Output Enable Bit
#define PWM52HLD (*(unsigned char volatile xdata *)0xfcc5) //PWM 5 Chanel 2 Level Hold Control
   #define PWM52_HLDL 0x01 //Hold Low Override
   #define PWM52_HLDH 0x02 //Hold High Override
#define PWM53T1 (*(unsigned int  volatile xdata *)0xfcc8) //PWM 5 Chanel 3 Timer 1 Word
#define PWM53T1H (*(unsigned char volatile xdata *)0xfcc8) //PWM 5 Chanel 3 Timer 1 High Byte
#define PWM53T1L (*(unsigned char volatile xdata *)0xfcc9) //PWM 5 Chanel 3 Timer 1 Low Byte
#define PWM53T2 (*(unsigned int  volatile xdata *)0xfcca) //PWM 5 Chanel 3 Timer 2 Word
#define PWM53T2H (*(unsigned char volatile xdata *)0xfcca) //PWM 5 Chanel 3 Timer 2 High Byte
#define PWM53T2L (*(unsigned char volatile xdata *)0xfccb) //PWM 5 Chanel 3 Timer 2 Low Byte
#define PWM53CR (*(unsigned char volatile xdata *)0xfccc) //PWM 5 Chanel 3 Control Register
   #define PWM53_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM53_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM53_ENI   0x04 //Enable Interrupt
   #define PWM53_INI   0x40 //Initial Output Level
   #define PWM53_ENO   0x80 //PWM Output Enable Bit
#define PWM53HLD (*(unsigned char volatile xdata *)0xfccd) //PWM 5 Chanel 3 Level Hold Control
   #define PWM53_HLDL 0x01 //Hold Low Override
   #define PWM53_HLDH 0x02 //Hold High Override
#define PWM54T1 (*(unsigned int  volatile xdata *)0xfcd0) //PWM 5 Chanel 4 Timer 1 Word
#define PWM54T1H (*(unsigned char volatile xdata *)0xfcd0) //PWM 5 Chanel 4 Timer 1 High Byte
#define PWM54T1L (*(unsigned char volatile xdata *)0xfcd1) //PWM 5 Chanel 4 Timer 1 Low Byte
#define PWM54T2 (*(unsigned int  volatile xdata *)0xfcd2) //PWM 5 Chanel 4 Timer 2 Word
#define PWM54T2H (*(unsigned char volatile xdata *)0xfcd2) //PWM 5 Chanel 4 Timer 2 High Byte
#define PWM54T2L (*(unsigned char volatile xdata *)0xfcd3) //PWM 5 Chanel 4 Timer 2 Low Byte
#define PWM54CR (*(unsigned char volatile xdata *)0xfcd4) //PWM 5 Chanel 4 Control Register
   #define PWM54_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM54_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM54_ENI   0x04 //Enable Interrupt
   #define PWM54_INI   0x40 //Initial Output Level
   #define PWM54_ENO   0x80 //PWM Output Enable Bit
#define PWM54HLD (*(unsigned char volatile xdata *)0xfcd5) //PWM 5 Chanel 4 Level Hold Control
   #define PWM54_HLDL 0x01 //Hold Low Override
   #define PWM54_HLDH 0x02 //Hold High Override
#define PWM55T1 (*(unsigned int  volatile xdata *)0xfcd8) //PWM 5 Chanel 5 Timer 1 Word
#define PWM55T1H (*(unsigned char volatile xdata *)0xfcd8) //PWM 5 Chanel 5 Timer 1 High Byte
#define PWM55T1L (*(unsigned char volatile xdata *)0xfcd9) //PWM 5 Chanel 5 Timer 1 Low Byte
#define PWM55T2 (*(unsigned int  volatile xdata *)0xfcda) //PWM 5 Chanel 5 Timer 2 Word
#define PWM55T2H (*(unsigned char volatile xdata *)0xfcda) //PWM 5 Chanel 5 Timer 2 High Byte
#define PWM55T2L (*(unsigned char volatile xdata *)0xfcdb) //PWM 5 Chanel 5 Timer 2 Low Byte
#define PWM55CR (*(unsigned char volatile xdata *)0xfcdc) //PWM 5 Chanel 5 Control Register
   #define PWM55_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM55_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM55_ENI   0x04 //Enable Interrupt
   #define PWM55_INI   0x40 //Initial Output Level
   #define PWM55_ENO   0x80 //PWM Output Enable Bit
#define PWM55HLD (*(unsigned char volatile xdata *)0xfcdd) //PWM 5 Chanel 5 Level Hold Control
   #define PWM55_HLDL 0x01 //Hold Low Override
   #define PWM55_HLDH 0x02 //Hold High Override
#define PWM56T1 (*(unsigned int  volatile xdata *)0xfce0) //PWM 5 Chanel 6 Timer 1 Word
#define PWM56T1H (*(unsigned char volatile xdata *)0xfce0) //PWM 5 Chanel 6 Timer 1 High Byte
#define PWM56T1L (*(unsigned char volatile xdata *)0xfce1) //PWM 5 Chanel 6 Timer 1 Low Byte
#define PWM56T2 (*(unsigned int  volatile xdata *)0xfce2) //PWM 5 Chanel 6 Timer 2 Word
#define PWM56T2H (*(unsigned char volatile xdata *)0xfce2) //PWM 5 Chanel 6 Timer 2 High Byte
#define PWM56T2L (*(unsigned char volatile xdata *)0xfce3) //PWM 5 Chanel 6 Timer 2 Low Byte
#define PWM56CR (*(unsigned char volatile xdata *)0xfce4) //PWM 5 Chanel 6 Control Register
   #define PWM56_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM56_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM56_ENI   0x04 //Enable Interrupt
   #define PWM56_INI   0x40 //Initial Output Level
   #define PWM56_ENO   0x80 //PWM Output Enable Bit
#define PWM56HLD (*(unsigned char volatile xdata *)0xfce5) //PWM 5 Chanel 6 Level Hold Control
   #define PWM56_HLDL 0x01 //Hold Low Override
   #define PWM56_HLDH 0x02 //Hold High Override
#define PWM57T1 (*(unsigned int  volatile xdata *)0xfce8) //PWM 5 Chanel 7 Timer 1 Word
#define PWM57T1H (*(unsigned char volatile xdata *)0xfce8) //PWM 5 Chanel 7 Timer 1 High Byte
#define PWM57T1L (*(unsigned char volatile xdata *)0xfce9) //PWM 5 Chanel 7 Timer 1 Low Byte
#define PWM57T2 (*(unsigned int  volatile xdata *)0xfcea) //PWM 5 Chanel 7 Timer 2 Word
#define PWM57T2H (*(unsigned char volatile xdata *)0xfcea) //PWM 5 Chanel 7 Timer 2 High Byte
#define PWM57T2L (*(unsigned char volatile xdata *)0xfceb) //PWM 5 Chanel 7 Timer 2 Low Byte
#define PWM57CR (*(unsigned char volatile xdata *)0xfcec) //PWM 5 Chanel 7 Control Register
   #define PWM57_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM57_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM57_ENI   0x04 //Enable Interrupt
   #define PWM57_INI   0x40 //Initial Output Level
   #define PWM57_ENO   0x80 //PWM Output Enable Bit
#define PWM57HLD (*(unsigned char volatile xdata *)0xfced) //PWM 5 Chanel 7 Level Hold Control
   #define PWM57_HLDL 0x01 //Hold Low Override
   #define PWM57_HLDH 0x02 //Hold High Override
#define MD3 (*(unsigned char volatile xdata *)0xfcf0) //Operand 3 Data Register
#define MD2 (*(unsigned char volatile xdata *)0xfcf1) //Operand 2 Data Register
#define MD1 (*(unsigned char volatile xdata *)0xfcf2) //Operand 1 Data Register
#define MD0 (*(unsigned char volatile xdata *)0xfcf3) //Operand 0 Data Register
#define MD5 (*(unsigned char volatile xdata *)0xfcf4) //Operand 5 Data Register
#define MD4 (*(unsigned char volatile xdata *)0xfcf5) //Operand 4 Data Register
#define ARCON (*(unsigned char volatile xdata *)0xfcf6) //Multiply Divide Unit Array Control
   #define SC     0x1F //Shift Count
   #define ARMODE 0xE0 //Mode Select
#define OPCON (*(unsigned char volatile xdata *)0xfcf7) //Multiply Divide Unit Operation Control
   #define ENOP 0x01 //Enable Operation
   #define RST  0x02 //Software Reset
   #define MDOV 0x40 //Overflow Flag
#define P0INTE (*(unsigned char volatile xdata *)0xfd00) //Port 0 Interrupt Enable Register
   #define P00INTE 0x01 //
   #define P01INTE 0x02 //
   #define P02INTE 0x04 //
   #define P03INTE 0x08 //
   #define P04INTE 0x10 //
   #define P05INTE 0x20 //
   #define P06INTE 0x40 //
   #define P07INTE 0x80 //
#define P1INTE (*(unsigned char volatile xdata *)0xfd01) //Port 1 Interrupt Enable Register
   #define P10INTE 0x01 //
   #define P11INTE 0x02 //
   #define P12INTE 0x04 //
   #define P13INTE 0x08 //
   #define P14INTE 0x10 //
   #define P15INTE 0x20 //
   #define P16INTE 0x40 //
   #define P17INTE 0x80 //
#define P2INTE (*(unsigned char volatile xdata *)0xfd02) //Port 2 Interrupt Enable Register
   #define P20INTE 0x01 //
   #define P21INTE 0x02 //
   #define P22INTE 0x04 //
   #define P23INTE 0x08 //
   #define P24INTE 0x10 //
   #define P25INTE 0x20 //
   #define P26INTE 0x40 //
   #define P27INTE 0x80 //
#define P3INTE (*(unsigned char volatile xdata *)0xfd03) //Port 3 Interrupt Enable Register
   #define P30INTE 0x01 //
   #define P31INTE 0x02 //
   #define P32INTE 0x04 //
   #define P33INTE 0x08 //
   #define P34INTE 0x10 //
   #define P35INTE 0x20 //
   #define P36INTE 0x40 //
   #define P37INTE 0x80 //
#define P4INTE (*(unsigned char volatile xdata *)0xfd04) //Port 4 Interrupt Enable Register
   #define P40INTE 0x01 //
   #define P41INTE 0x02 //
   #define P42INTE 0x04 //
   #define P43INTE 0x08 //
   #define P44INTE 0x10 //
   #define P45INTE 0x20 //
   #define P46INTE 0x40 //
   #define P47INTE 0x80 //
#define P5INTE (*(unsigned char volatile xdata *)0xfd05) //Port 5 Interrupt Enable Register
   #define P50INTE 0x01 //
   #define P51INTE 0x02 //
   #define P52INTE 0x04 //
   #define P53INTE 0x08 //
   #define P54INTE 0x10 //
   #define P55INTE 0x20 //
#define P6INTE (*(unsigned char volatile xdata *)0xfd06) //Port 6 Interrupt Enable Register
   #define P60INTE 0x01 //
   #define P61INTE 0x02 //
   #define P62INTE 0x04 //
   #define P63INTE 0x08 //
   #define P64INTE 0x10 //
   #define P65INTE 0x20 //
   #define P66INTE 0x40 //
   #define P67INTE 0x80 //
#define P7INTE (*(unsigned char volatile xdata *)0xfd07) //Port 7 Interrupt Enable Register
   #define P70INTE 0x01 //
   #define P71INTE 0x02 //
   #define P72INTE 0x04 //
   #define P73INTE 0x08 //
   #define P74INTE 0x10 //
   #define P75INTE 0x20 //
   #define P76INTE 0x40 //
   #define P77INTE 0x80 //
#define P0INTF (*(unsigned char volatile xdata *)0xfd10) //Port 0 Interrupt Flag Register
   #define P00INTF 0x01 //
   #define P01INTF 0x02 //
   #define P02INTF 0x04 //
   #define P03INTF 0x08 //
   #define P04INTF 0x10 //
   #define P05INTF 0x20 //
   #define P06INTF 0x40 //
   #define P07INTF 0x80 //
#define P1INTF (*(unsigned char volatile xdata *)0xfd11) //Port 1 Interrupt Flag Register
   #define P10INTF 0x01 //
   #define P11INTF 0x02 //
   #define P12INTF 0x04 //
   #define P13INTF 0x08 //
   #define P14INTF 0x10 //
   #define P15INTF 0x20 //
   #define P16INTF 0x40 //
   #define P17INTF 0x80 //
#define P2INTF (*(unsigned char volatile xdata *)0xfd12) //Port 2 Interrupt Flag Register
   #define P20INTF 0x01 //
   #define P21INTF 0x02 //
   #define P22INTF 0x04 //
   #define P23INTF 0x08 //
   #define P24INTF 0x10 //
   #define P25INTF 0x20 //
   #define P26INTF 0x40 //
   #define P27INTF 0x80 //
#define P3INTF (*(unsigned char volatile xdata *)0xfd13) //Port 3 Interrupt Flag Register
   #define P30INTF 0x01 //
   #define P31INTF 0x02 //
   #define P32INTF 0x04 //
   #define P33INTF 0x08 //
   #define P34INTF 0x10 //
   #define P35INTF 0x20 //
   #define P36INTF 0x40 //
   #define P37INTF 0x80 //
#define P4INTF (*(unsigned char volatile xdata *)0xfd14) //Port 4 Interrupt Flag Register
   #define P40INTF 0x01 //
   #define P41INTF 0x02 //
   #define P42INTF 0x04 //
   #define P43INTF 0x08 //
   #define P44INTF 0x10 //
   #define P45INTF 0x20 //
   #define P46INTF 0x40 //
   #define P47INTF 0x80 //
#define P5INTF (*(unsigned char volatile xdata *)0xfd15) //Port 5 Interrupt Flag Register
   #define P50INTF 0x01 //
   #define P51INTF 0x02 //
   #define P52INTF 0x04 //
   #define P53INTF 0x08 //
   #define P54INTF 0x10 //
   #define P55INTF 0x20 //
#define P6INTF (*(unsigned char volatile xdata *)0xfd16) //Port 6 Interrupt Flag Register
   #define P60INTF 0x01 //
   #define P61INTF 0x02 //
   #define P62INTF 0x04 //
   #define P63INTF 0x08 //
   #define P64INTF 0x10 //
   #define P65INTF 0x20 //
   #define P66INTF 0x40 //
   #define P67INTF 0x80 //
#define P7INTF (*(unsigned char volatile xdata *)0xfd17) //Port 7 Interrupt Flag Register
   #define P70INTF 0x01 //
   #define P71INTF 0x02 //
   #define P72INTF 0x04 //
   #define P73INTF 0x08 //
   #define P74INTF 0x10 //
   #define P75INTF 0x20 //
   #define P76INTF 0x40 //
   #define P77INTF 0x80 //
#define P0IM0 (*(unsigned char volatile xdata *)0xfd20) //Port 0 Interrupt Mode Register 0
   #define P00IM0 0x01 //
   #define P01IM0 0x02 //
   #define P02IM0 0x04 //
   #define P03IM0 0x08 //
   #define P04IM0 0x10 //
   #define P05IM0 0x20 //
   #define P06IM0 0x40 //
   #define P07IM0 0x80 //
#define P1IM0 (*(unsigned char volatile xdata *)0xfd21) //Port 1 Interrupt Mode Register 0
   #define P10IM0 0x01 //
   #define P11IM0 0x02 //
   #define P12IM0 0x04 //
   #define P13IM0 0x08 //
   #define P14IM0 0x10 //
   #define P15IM0 0x20 //
   #define P16IM0 0x40 //
   #define P17IM0 0x80 //
#define P2IM0 (*(unsigned char volatile xdata *)0xfd22) //Port 2 Interrupt Mode Register 0
   #define P20IM0 0x01 //
   #define P21IM0 0x02 //
   #define P22IM0 0x04 //
   #define P23IM0 0x08 //
   #define P24IM0 0x10 //
   #define P25IM0 0x20 //
   #define P26IM0 0x40 //
   #define P27IM0 0x80 //
#define P3IM0 (*(unsigned char volatile xdata *)0xfd23) //Port 3 Interrupt Mode Register 0
   #define P30IM0 0x01 //
   #define P31IM0 0x02 //
   #define P32IM0 0x04 //
   #define P33IM0 0x08 //
   #define P34IM0 0x10 //
   #define P35IM0 0x20 //
   #define P36IM0 0x40 //
   #define P37IM0 0x80 //
#define P4IM0 (*(unsigned char volatile xdata *)0xfd24) //Port 4 Interrupt Mode Register 0
   #define P40IM0 0x01 //
   #define P41IM0 0x02 //
   #define P42IM0 0x04 //
   #define P43IM0 0x08 //
   #define P44IM0 0x10 //
   #define P45IM0 0x20 //
   #define P46IM0 0x40 //
   #define P47IM0 0x80 //
#define P5IM0 (*(unsigned char volatile xdata *)0xfd25) //Port 5 Interrupt Mode Register 0
   #define P50IM0 0x01 //
   #define P51IM0 0x02 //
   #define P52IM0 0x04 //
   #define P53IM0 0x08 //
   #define P54IM0 0x10 //
   #define P55IM0 0x20 //
#define P6IM0 (*(unsigned char volatile xdata *)0xfd26) //Port 6 Interrupt Mode Register 0
   #define P60IM0 0x01 //
   #define P61IM0 0x02 //
   #define P62IM0 0x04 //
   #define P63IM0 0x08 //
   #define P64IM0 0x10 //
   #define P65IM0 0x20 //
   #define P66IM0 0x40 //
   #define P67IM0 0x80 //
#define P7IM0 (*(unsigned char volatile xdata *)0xfd27) //Port 7 Interrupt Mode Register 0
   #define P70IM0 0x01 //
   #define P71IM0 0x02 //
   #define P72IM0 0x04 //
   #define P73IM0 0x08 //
   #define P74IM0 0x10 //
   #define P75IM0 0x20 //
   #define P76IM0 0x40 //
   #define P77IM0 0x80 //
#define P0IM1 (*(unsigned char volatile xdata *)0xfd30) //Port 0 Interrupt Mode Register 1
   #define P00IM1 0x01 //
   #define P01IM1 0x02 //
   #define P02IM1 0x04 //
   #define P03IM1 0x08 //
   #define P04IM1 0x10 //
   #define P05IM1 0x20 //
   #define P06IM1 0x40 //
   #define P07IM1 0x80 //
#define P1IM1 (*(unsigned char volatile xdata *)0xfd31) //Port 1 Interrupt Mode Register 1
   #define P10IM1 0x01 //
   #define P11IM1 0x02 //
   #define P12IM1 0x04 //
   #define P13IM1 0x08 //
   #define P14IM1 0x10 //
   #define P15IM1 0x20 //
   #define P16IM1 0x40 //
   #define P17IM1 0x80 //
#define P2IM1 (*(unsigned char volatile xdata *)0xfd32) //Port 2 Interrupt Mode Register 1
   #define P20IM1 0x01 //
   #define P21IM1 0x02 //
   #define P22IM1 0x04 //
   #define P23IM1 0x08 //
   #define P24IM1 0x10 //
   #define P25IM1 0x20 //
   #define P26IM1 0x40 //
   #define P27IM1 0x80 //
#define P3IM1 (*(unsigned char volatile xdata *)0xfd33) //Port 3 Interrupt Mode Register 1
   #define P30IM1 0x01 //
   #define P31IM1 0x02 //
   #define P32IM1 0x04 //
   #define P33IM1 0x08 //
   #define P34IM1 0x10 //
   #define P35IM1 0x20 //
   #define P36IM1 0x40 //
   #define P37IM1 0x80 //
#define P4IM1 (*(unsigned char volatile xdata *)0xfd34) //Port 4 Interrupt Mode Register 1
   #define P40IM1 0x01 //
   #define P41IM1 0x02 //
   #define P42IM1 0x04 //
   #define P43IM1 0x08 //
   #define P44IM1 0x10 //
   #define P45IM1 0x20 //
   #define P46IM1 0x40 //
   #define P47IM1 0x80 //
#define P5IM1 (*(unsigned char volatile xdata *)0xfd35) //Port 5 Interrupt Mode Register 1
   #define P50IM1 0x01 //
   #define P51IM1 0x02 //
   #define P52IM1 0x04 //
   #define P53IM1 0x08 //
   #define P54IM1 0x10 //
   #define P55IM1 0x20 //
#define P6IM1 (*(unsigned char volatile xdata *)0xfd36) //Port 6 Interrupt Mode Register 1
   #define P60IM1 0x01 //
   #define P61IM1 0x02 //
   #define P62IM1 0x04 //
   #define P63IM1 0x08 //
   #define P64IM1 0x10 //
   #define P65IM1 0x20 //
   #define P66IM1 0x40 //
   #define P67IM1 0x80 //
#define P7IM1 (*(unsigned char volatile xdata *)0xfd37) //Port 7 Interrupt Mode Register 1
   #define P70IM1 0x01 //
   #define P71IM1 0x02 //
   #define P72IM1 0x04 //
   #define P73IM1 0x08 //
   #define P74IM1 0x10 //
   #define P75IM1 0x20 //
   #define P76IM1 0x40 //
   #define P77IM1 0x80 //
#define P0WKUE (*(unsigned char volatile xdata *)0xfd40) //Port 0 Wake-up Enable Register
   #define P00WKUE 0x01 //
   #define P01WKUE 0x02 //
   #define P02WKUE 0x04 //
   #define P03WKUE 0x08 //
   #define P04WKUE 0x10 //
   #define P05WKUE 0x20 //
   #define P06WKUE 0x40 //
   #define P07WKUE 0x80 //
#define P1WKUE (*(unsigned char volatile xdata *)0xfd41) //Port 1 Wake-up Enable Register
   #define P10WKUE 0x01 //
   #define P11WKUE 0x02 //
   #define P12WKUE 0x04 //
   #define P13WKUE 0x08 //
   #define P14WKUE 0x10 //
   #define P15WKUE 0x20 //
   #define P16WKUE 0x40 //
   #define P17WKUE 0x80 //
#define P2WKUE (*(unsigned char volatile xdata *)0xfd42) //Port 2 Wake-up Enable Register
   #define P20WKUE 0x01 //
   #define P21WKUE 0x02 //
   #define P22WKUE 0x04 //
   #define P23WKUE 0x08 //
   #define P24WKUE 0x10 //
   #define P25WKUE 0x20 //
   #define P26WKUE 0x40 //
   #define P27WKUE 0x80 //
#define P3WKUE (*(unsigned char volatile xdata *)0xfd43) //Port 3 Wake-up Enable Register
   #define P30WKUE 0x01 //
   #define P31WKUE 0x02 //
   #define P32WKUE 0x04 //
   #define P33WKUE 0x08 //
   #define P34WKUE 0x10 //
   #define P35WKUE 0x20 //
   #define P36WKUE 0x40 //
   #define P37WKUE 0x80 //
#define P4WKUE (*(unsigned char volatile xdata *)0xfd44) //Port 4 Wake-up Enable Register
   #define P40WKUE 0x01 //
   #define P41WKUE 0x02 //
   #define P42WKUE 0x04 //
   #define P43WKUE 0x08 //
   #define P44WKUE 0x10 //
   #define P45WKUE 0x20 //
   #define P46WKUE 0x40 //
   #define P47WKUE 0x80 //
#define P5WKUE (*(unsigned char volatile xdata *)0xfd45) //Port 5 Wake-up Enable Register
   #define P50WKUE 0x01 //
   #define P51WKUE 0x02 //
   #define P52WKUE 0x04 //
   #define P53WKUE 0x08 //
   #define P54WKUE 0x10 //
   #define P55WKUE 0x20 //
#define P6WKUE (*(unsigned char volatile xdata *)0xfd46) //Port 6 Wake-up Enable Register
   #define P60WKUE 0x01 //
   #define P61WKUE 0x02 //
   #define P62WKUE 0x04 //
   #define P63WKUE 0x08 //
   #define P64WKUE 0x10 //
   #define P65WKUE 0x20 //
   #define P66WKUE 0x40 //
   #define P67WKUE 0x80 //
#define P7WKUE (*(unsigned char volatile xdata *)0xfd47) //Port 7 Wake-up Enable Register
   #define P70WKUE 0x01 //
   #define P71WKUE 0x02 //
   #define P72WKUE 0x04 //
   #define P73WKUE 0x08 //
   #define P74WKUE 0x10 //
   #define P75WKUE 0x20 //
   #define P76WKUE 0x40 //
   #define P77WKUE 0x80 //
#define PINIPL (*(unsigned char volatile xdata *)0xfd60) //IO Port Interrupt Priority Low
   #define P0IP 0x01 //
   #define P1IP 0x02 //
   #define P2IP 0x04 //
   #define P3IP 0x08 //
   #define P4IP 0x10 //
   #define P5IP 0x20 //
   #define P6IP 0x40 //
   #define P7IP 0x80 //
#define PINIPH (*(unsigned char volatile xdata *)0xfd61) //IO Port Interrupt Priority High
   #define P0IPH 0x01 //
   #define P1IPH 0x02 //
   #define P2IPH 0x04 //
   #define P3IPH 0x08 //
   #define P4IPH 0x10 //
   #define P5IPH 0x20 //
   #define P6IPH 0x40 //
   #define P7IPH 0x80 //
#define CKSEL (*(unsigned char volatile xdata *)0xfe00) //Clock Select Register
   #define MCKSEL 0x03 //Main Clock Source Selection
#define CLKDIV (*(unsigned char volatile xdata *)0xfe01) //Clock Frequency Division Register 
#define HIRCCR (*(unsigned char volatile xdata *)0xfe02) //High Accuracy Internal RC Control Register
   #define HIRCST 0x01 //Internal High Speed/Precision Oscillator Stability Indicator
   #define ENHIRC 0x80 //Enable Internal High Speed/Precision Clock Source
#define XOSCCR (*(unsigned char volatile xdata *)0xfe03) //External Oscillator Control Register
   #define XOSCST 0x01 //External Crystal Oscillator Stability Indicator
   #define XITYPE 0x40 //External Clock Source Type
   #define ENXOSC 0x80 //Enable External Crystal Clock Source
#define IRC32KCR (*(unsigned char volatile xdata *)0xfe04) //Internal 32K Oscillator Control Register
   #define IRC32KST 0x01 //Internal RC 32 KHz Oscillator Stability Indicator
   #define ENIRC32K 0x80 //Enable Internal RC 32 KHz Clock Source
#define MCLKOCR (*(unsigned char volatile xdata *)0xfe05) //Main Clock Output Control Register
   #define MCLKODIV 0x7F //Main Clock Output Division Coefficient
   #define MCLKO_S    0x80 //Main Clock Output Pin Selection
#define IRCDB (*(unsigned char volatile xdata *)0xfe06) //Internal RC High Speed Oscillator
   #define IRCDB_PAR 0xFF //
#define X32KCR (*(unsigned char volatile xdata *)0xfe08) //External 32 KHz Oscillator Control Register
   #define X32KST  0x01 //External 32 KHz Crystal Oscillator Stability Indicator
   #define GAIN32K 0x40 //External 32 KHz Crystal Oscillator Gain Control
   #define ENX32K  0x80 //Enable External 32 KHz Crystal Oscillator
#define P0PU (*(unsigned char volatile xdata *)0xfe10) //Port 0 Pull-up Resistor Control Register
   #define P00PU 0x01 //
   #define P01PU 0x02 //
   #define P02PU 0x04 //
   #define P03PU 0x08 //
   #define P04PU 0x10 //
   #define P05PU 0x20 //
   #define P06PU 0x40 //
   #define P07PU 0x80 //
#define P1PU (*(unsigned char volatile xdata *)0xfe11) //Port 1 Pull-up Resistor Control Register
   #define P10PU 0x01 //
   #define P11PU 0x02 //
   #define P12PU 0x04 //
   #define P13PU 0x08 //
   #define P14PU 0x10 //
   #define P15PU 0x20 //
   #define P16PU 0x40 //
   #define P17PU 0x80 //
#define P2PU (*(unsigned char volatile xdata *)0xfe12) //Port 2 Pull-up Resistor Control Register
   #define P20PU 0x01 //
   #define P21PU 0x02 //
   #define P22PU 0x04 //
   #define P23PU 0x08 //
   #define P24PU 0x10 //
   #define P25PU 0x20 //
   #define P26PU 0x40 //
   #define P27PU 0x80 //
#define P3PU (*(unsigned char volatile xdata *)0xfe13) //Port 3 Pull-up Resistor Control Register
   #define P30PU 0x01 //
   #define P31PU 0x02 //
   #define P32PU 0x04 //
   #define P33PU 0x08 //
   #define P34PU 0x10 //
   #define P35PU 0x20 //
   #define P36PU 0x40 //
   #define P37PU 0x80 //
#define P4PU (*(unsigned char volatile xdata *)0xfe14) //Port 4 Pull-up Resistor Control Register
   #define P40PU 0x01 //
   #define P41PU 0x02 //
   #define P42PU 0x04 //
   #define P43PU 0x08 //
   #define P44PU 0x10 //
   #define P45PU 0x20 //
   #define P46PU 0x40 //
   #define P47PU 0x80 //
#define P5PU (*(unsigned char volatile xdata *)0xfe15) //Port 5 Pull-up Resistor Control Register
   #define P50PU 0x01 //
   #define P51PU 0x02 //
   #define P52PU 0x04 //
   #define P53PU 0x08 //
   #define P54PU 0x10 //
   #define P55PU 0x20 //
#define P6PU (*(unsigned char volatile xdata *)0xfe16) //Port 6 Pull-up Resistor Control Register
   #define P60PU 0x01 //
   #define P61PU 0x02 //
   #define P62PU 0x04 //
   #define P63PU 0x08 //
   #define P64PU 0x10 //
   #define P65PU 0x20 //
   #define P66PU 0x40 //
   #define P67PU 0x80 //
#define P7PU (*(unsigned char volatile xdata *)0xfe17) //Port 7 Pull-up Resistor Control Register
   #define P70PU 0x01 //
   #define P71PU 0x02 //
   #define P72PU 0x04 //
   #define P73PU 0x08 //
   #define P74PU 0x10 //
   #define P75PU 0x20 //
   #define P76PU 0x40 //
   #define P77PU 0x80 //
#define P0NCS (*(unsigned char volatile xdata *)0xfe18) //Port 0 Schmidt Trigger Control Register
   #define P00NCS 0x01 //
   #define P01NCS 0x02 //
   #define P02NCS 0x04 //
   #define P03NCS 0x08 //
   #define P04NCS 0x10 //
   #define P05NCS 0x20 //
   #define P06NCS 0x40 //
   #define P07NCS 0x80 //
#define P1NCS (*(unsigned char volatile xdata *)0xfe19) //Port 1 Schmidt Trigger Control Register
   #define P10NCS 0x01 //
   #define P11NCS 0x02 //
   #define P12NCS 0x04 //
   #define P13NCS 0x08 //
   #define P14NCS 0x10 //
   #define P15NCS 0x20 //
   #define P16NCS 0x40 //
   #define P17NCS 0x80 //
#define P2NCS (*(unsigned char volatile xdata *)0xfe1a) //Port 2 Schmidt Trigger Control Register
   #define P20NCS 0x01 //
   #define P21NCS 0x02 //
   #define P22NCS 0x04 //
   #define P23NCS 0x08 //
   #define P24NCS 0x10 //
   #define P25NCS 0x20 //
   #define P26NCS 0x40 //
   #define P27NCS 0x80 //
#define P3NCS (*(unsigned char volatile xdata *)0xfe1b) //Port 3 Schmidt Trigger Control Register
   #define P30NCS 0x01 //
   #define P31NCS 0x02 //
   #define P32NCS 0x04 //
   #define P33NCS 0x08 //
   #define P34NCS 0x10 //
   #define P35NCS 0x20 //
   #define P36NCS 0x40 //
   #define P37NCS 0x80 //
#define P4NCS (*(unsigned char volatile xdata *)0xfe1c) //Port 4 Schmidt Trigger Control Register
   #define P40NCS 0x01 //
   #define P41NCS 0x02 //
   #define P42NCS 0x04 //
   #define P43NCS 0x08 //
   #define P44NCS 0x10 //
   #define P45NCS 0x20 //
   #define P46NCS 0x40 //
   #define P47NCS 0x80 //
#define P5NCS (*(unsigned char volatile xdata *)0xfe1d) //Port 5 Schmidt Trigger Control Register
   #define P50NCS 0x01 //
   #define P51NCS 0x02 //
   #define P52NCS 0x04 //
   #define P53NCS 0x08 //
   #define P54NCS 0x10 //
   #define P55NCS 0x20 //
#define P6NCS (*(unsigned char volatile xdata *)0xfe1e) //Port 6 Schmidt Trigger Control Register
   #define P60NCS 0x01 //
   #define P61NCS 0x02 //
   #define P62NCS 0x04 //
   #define P63NCS 0x08 //
   #define P64NCS 0x10 //
   #define P65NCS 0x20 //
   #define P66NCS 0x40 //
   #define P67NCS 0x80 //
#define P7NCS (*(unsigned char volatile xdata *)0xfe1f) //Port 7 Schmidt Trigger Control Register
   #define P70NCS 0x01 //
   #define P71NCS 0x02 //
   #define P72NCS 0x04 //
   #define P73NCS 0x08 //
   #define P74NCS 0x10 //
   #define P75NCS 0x20 //
   #define P76NCS 0x40 //
   #define P77NCS 0x80 //
#define P0SR (*(unsigned char volatile xdata *)0xfe20) //Port 0 Slew Rate Control Register
   #define P00SR 0x01 //
   #define P01SR 0x02 //
   #define P02SR 0x04 //
   #define P03SR 0x08 //
   #define P04SR 0x10 //
   #define P05SR 0x20 //
   #define P06SR 0x40 //
   #define P07SR 0x80 //
#define P1SR (*(unsigned char volatile xdata *)0xfe21) //Port 1 Slew Rate Control Register
   #define P10SR 0x01 //
   #define P11SR 0x02 //
   #define P12SR 0x04 //
   #define P13SR 0x08 //
   #define P14SR 0x10 //
   #define P15SR 0x20 //
   #define P16SR 0x40 //
   #define P17SR 0x80 //
#define P2SR (*(unsigned char volatile xdata *)0xfe22) //Port 2 Slew Rate Control Register
   #define P20SR 0x01 //
   #define P21SR 0x02 //
   #define P22SR 0x04 //
   #define P23SR 0x08 //
   #define P24SR 0x10 //
   #define P25SR 0x20 //
   #define P26SR 0x40 //
   #define P27SR 0x80 //
#define P3SR (*(unsigned char volatile xdata *)0xfe23) //Port 3 Slew Rate Control Register
   #define P30SR 0x01 //
   #define P31SR 0x02 //
   #define P32SR 0x04 //
   #define P33SR 0x08 //
   #define P34SR 0x10 //
   #define P35SR 0x20 //
   #define P36SR 0x40 //
   #define P37SR 0x80 //
#define P4SR (*(unsigned char volatile xdata *)0xfe24) //Port 4 Slew Rate Control Register
   #define P40SR 0x01 //
   #define P41SR 0x02 //
   #define P42SR 0x04 //
   #define P43SR 0x08 //
   #define P44SR 0x10 //
   #define P45SR 0x20 //
   #define P46SR 0x40 //
   #define P47SR 0x80 //
#define P5SR (*(unsigned char volatile xdata *)0xfe25) //Port 5 Slew Rate Control Register
   #define P50SR 0x01 //
   #define P51SR 0x02 //
   #define P52SR 0x04 //
   #define P53SR 0x08 //
   #define P54SR 0x10 //
   #define P55SR 0x20 //
#define P6SR (*(unsigned char volatile xdata *)0xfe26) //Port 6 Slew Rate Control Register
   #define P60SR 0x01 //
   #define P61SR 0x02 //
   #define P62SR 0x04 //
   #define P63SR 0x08 //
   #define P64SR 0x10 //
   #define P65SR 0x20 //
   #define P66SR 0x40 //
   #define P67SR 0x80 //
#define P7SR (*(unsigned char volatile xdata *)0xfe27) //Port 7 Slew Rate Control Register
   #define P70SR 0x01 //
   #define P71SR 0x02 //
   #define P72SR 0x04 //
   #define P73SR 0x08 //
   #define P74SR 0x10 //
   #define P75SR 0x20 //
   #define P76SR 0x40 //
   #define P77SR 0x80 //
#define P0DR (*(unsigned char volatile xdata *)0xfe28) //Port 0 Drive Current Control Register
   #define P00DR 0x01 //
   #define P01DR 0x02 //
   #define P02DR 0x04 //
   #define P03DR 0x08 //
   #define P04DR 0x10 //
   #define P05DR 0x20 //
   #define P06DR 0x40 //
   #define P07DR 0x80 //
#define P1DR (*(unsigned char volatile xdata *)0xfe29) //Port 1 Drive Current Control Register
   #define P10DR 0x01 //
   #define P11DR 0x02 //
   #define P12DR 0x04 //
   #define P13DR 0x08 //
   #define P14DR 0x10 //
   #define P15DR 0x20 //
   #define P16DR 0x40 //
   #define P17DR 0x80 //
#define P2DR (*(unsigned char volatile xdata *)0xfe2a) //Port 2 Drive Current Control Register
   #define P20DR 0x01 //
   #define P21DR 0x02 //
   #define P22DR 0x04 //
   #define P23DR 0x08 //
   #define P24DR 0x10 //
   #define P25DR 0x20 //
   #define P26DR 0x40 //
   #define P27DR 0x80 //
#define P3DR (*(unsigned char volatile xdata *)0xfe2b) //Port 3 Drive Current Control Register
   #define P30DR 0x01 //
   #define P31DR 0x02 //
   #define P32DR 0x04 //
   #define P33DR 0x08 //
   #define P34DR 0x10 //
   #define P35DR 0x20 //
   #define P36DR 0x40 //
   #define P37DR 0x80 //
#define P4DR (*(unsigned char volatile xdata *)0xfe2c) //Port 4 Drive Current Control Register
   #define P40DR 0x01 //
   #define P41DR 0x02 //
   #define P42DR 0x04 //
   #define P43DR 0x08 //
   #define P44DR 0x10 //
   #define P45DR 0x20 //
   #define P46DR 0x40 //
   #define P47DR 0x80 //
#define P5DR (*(unsigned char volatile xdata *)0xfe2d) //Port 5 Drive Current Control Register
   #define P50DR 0x01 //
   #define P51DR 0x02 //
   #define P52DR 0x04 //
   #define P53DR 0x08 //
   #define P54DR 0x10 //
   #define P55DR 0x20 //
#define P6DR (*(unsigned char volatile xdata *)0xfe2e) //Port 6 Drive Current Control Register
   #define P60DR 0x01 //
   #define P61DR 0x02 //
   #define P62DR 0x04 //
   #define P63DR 0x08 //
   #define P64DR 0x10 //
   #define P65DR 0x20 //
   #define P66DR 0x40 //
   #define P67DR 0x80 //
#define P7DR (*(unsigned char volatile xdata *)0xfe2f) //Port 7 Drive Current Control Register
   #define P70DR 0x01 //
   #define P71DR 0x02 //
   #define P72DR 0x04 //
   #define P73DR 0x08 //
   #define P74DR 0x10 //
   #define P75DR 0x20 //
   #define P76DR 0x40 //
   #define P77DR 0x80 //
#define P0IE (*(unsigned char volatile xdata *)0xfe30) //Port 0 Digital Input Enable Register
   #define P00IE 0x01 //
   #define P01IE 0x02 //
   #define P02IE 0x04 //
   #define P03IE 0x08 //
   #define P04IE 0x10 //
   #define P05IE 0x20 //
   #define P06IE 0x40 //
   #define P07IE 0x80 //
#define P1IE (*(unsigned char volatile xdata *)0xfe31) //Port 1 Digital Input Enable Register
   #define P10IE 0x01 //
   #define P11IE 0x02 //
   #define P12IE 0x04 //
   #define P13IE 0x08 //
   #define P14IE 0x10 //
   #define P15IE 0x20 //
   #define P16IE 0x40 //
   #define P17IE 0x80 //
#define P2IE (*(unsigned char volatile xdata *)0xfe32) //Port 2 Digital Input Enable Register
   #define P20IE 0x01 //
   #define P21IE 0x02 //
   #define P22IE 0x04 //
   #define P23IE 0x08 //
   #define P24IE 0x10 //
   #define P25IE 0x20 //
   #define P26IE 0x40 //
   #define P27IE 0x80 //
#define P3IE (*(unsigned char volatile xdata *)0xfe33) //Port 3 Digital Input Enable Register
   #define P30IE 0x01 //
   #define P31IE 0x02 //
   #define P32IE 0x04 //
   #define P33IE 0x08 //
   #define P34IE 0x10 //
   #define P35IE 0x20 //
   #define P36IE 0x40 //
   #define P37IE 0x80 //
#define P4IE (*(unsigned char volatile xdata *)0xfe34) //Port 4 Digital Input Enable Register
   #define P40IE 0x01 //
   #define P41IE 0x02 //
   #define P42IE 0x04 //
   #define P43IE 0x08 //
   #define P44IE 0x10 //
   #define P45IE 0x20 //
   #define P46IE 0x40 //
   #define P47IE 0x80 //
#define P5IE (*(unsigned char volatile xdata *)0xfe35) //Port 5 Digital Input Enable Register
   #define P50IE 0x01 //
   #define P51IE 0x02 //
   #define P52IE 0x04 //
   #define P53IE 0x08 //
   #define P54IE 0x10 //
   #define P55IE 0x20 //
#define P6IE (*(unsigned char volatile xdata *)0xfe36) //Port 6 Digital Input Enable Register
   #define P60IE 0x01 //
   #define P61IE 0x02 //
   #define P62IE 0x04 //
   #define P63IE 0x08 //
   #define P64IE 0x10 //
   #define P65IE 0x20 //
   #define P66IE 0x40 //
   #define P67IE 0x80 //
#define P7IE (*(unsigned char volatile xdata *)0xfe37) //Port 7 Digital Input Enable Register
   #define P70IE 0x01 //
   #define P71IE 0x02 //
   #define P72IE 0x04 //
   #define P73IE 0x08 //
   #define P74IE 0x10 //
   #define P75IE 0x20 //
   #define P76IE 0x40 //
   #define P77IE 0x80 //
#define RTCCR (*(unsigned char volatile xdata *)0xfe60) //Real Time Clock Control Register
   #define RUNRTC 0x01 //Real Time Clock Run-Stop
#define RTCCFG (*(unsigned char volatile xdata *)0xfe61) //Real Time Clock Config Register
   #define SETRTC 0x01 //Set Real Time Clock
   #define RTCCKS 0x02 //Real Time Clock Clock-Source Select
#define RTCIEN (*(unsigned char volatile xdata *)0xfe62) //Real Time Clock Interrupt Enable
   #define ESEC32I 0x01 //Enable 1/32s Interrupt
   #define ESEC8I  0x02 //Enable 1/8s Interrupt
   #define ESEC2I  0x04 //Enable 1/2s Interrupt
   #define ESECI   0x08 //Enable Seconds Interrupt
   #define EMINI   0x10 //Enable Minutes Interrupt
   #define EHOURI  0x20 //Enable Hourly Interrupt
   #define EDAYI   0x40 //Enable Daily Interrupt
   #define EALAI   0x80 //Enable Alarm Interrupt
#define RTCIF (*(unsigned char volatile xdata *)0xfe63) //Real Time Clock Interrupt Flag
   #define SEC32IF 0x01 //1/32s Interrupt Flag
   #define SEC8IF  0x02 //1/8s Interrupt Flag
   #define SEC2IF  0x04 //1/2s Interrupt Flag
   #define SECIF   0x08 //Seconds Interrupt Flag
   #define MINIF   0x10 //Minutes Interrupt Flag
   #define HOURIF  0x20 //Hourly Interrupt Flag
   #define DAYIF   0x40 //Daily Interrupt Flag
   #define ALAIF   0x80 //Alarm Interrupt Flag
#define ALAHOUR (*(unsigned char volatile xdata *)0xfe64) //Alarm Hour Value
#define ALAMIN (*(unsigned char volatile xdata *)0xfe65) //Alarm Minute Value
#define ALASEC (*(unsigned char volatile xdata *)0xfe66) //Alarm Second Value
#define ALASSEC (*(unsigned char volatile xdata *)0xfe67) //Alarm Subsecond 1/127s Value
#define INIYEAR (*(unsigned char volatile xdata *)0xfe68) //Initialize Year
#define INIMONTH (*(unsigned char volatile xdata *)0xfe69) //Initialize Month
#define INIDAY (*(unsigned char volatile xdata *)0xfe6a) //Initialize Day
#define INIHOUR (*(unsigned char volatile xdata *)0xfe6b) //Initialize Hour
#define INIMIN (*(unsigned char volatile xdata *)0xfe6c) //Initialize Minute
#define INISEC (*(unsigned char volatile xdata *)0xfe6d) //Initialize Second
#define INISSEC (*(unsigned char volatile xdata *)0xfe6e) //Initialize Subsecond 1/127s
#define YEAR (*(unsigned char volatile xdata *)0xfe70) //Current Year
#define MONTH (*(unsigned char volatile xdata *)0xfe71) //Current Month
#define DAY (*(unsigned char volatile xdata *)0xfe72) //Current Day
#define HOUR (*(unsigned char volatile xdata *)0xfe73) //Current Hour
#define MIN (*(unsigned char volatile xdata *)0xfe74) //Current Minute
#define SEC (*(unsigned char volatile xdata *)0xfe75) //Current Second
#define SSEC (*(unsigned char volatile xdata *)0xfe76) //Current Subsecond 1/127s
#define I2CCFG (*(unsigned char volatile xdata *)0xfe80) //I2C configuration
   #define MSSPEED 0x3F //I2C Bus Speed Selection
   #define MSSL    0x40 //Master or Slave Mode Select
   #define ENI2C   0x80 //Enable I2C Functionality
#define I2CMSCR (*(unsigned char volatile xdata *)0xfe81) //I2C Master Control
   #define MSCMD 0x0F //Master Command Execution
   #define EMSI  0x80 //Enable Master Interrupt
#define I2CMSST (*(unsigned char volatile xdata *)0xfe82) //I2C Master Status
   #define MSACKO 0x01 //Master Mode Output ACK
   #define MSACKI 0x02 //Master Mode Input ACK
   #define MSIF   0x40 //Master Mode Interrupt Flag
   #define MSBUSY 0x80 //Master Busy Flag
#define I2CSLCR (*(unsigned char volatile xdata *)0xfe83) //I2C Slave Control
   #define SLRST 0x01 //Slave Reset Mode
   #define ESTOI 0x08 //Enable Interrupt after STOP is received in Slave Mode
   #define ETXI  0x10 //Enable Interrupt after data is sent in Slave Mode
   #define ERXI  0x20 //Enable Interrupt after data is received in Slave Mode
   #define ESTAI 0x40 //Enable Interrupt after START is received in Slave Mode
#define I2CSLST (*(unsigned char volatile xdata *)0xfe84) //I2C Slave Status
   #define SLACKO 0x01 //Slave ACK Output Flag
   #define SLACKI 0x02 //Slave ACK Input Flag
   #define TXING  0x04 //Undocumented
   #define STOIF  0x08 //STOP signal Interrupt Flag
   #define TXIF   0x10 //Transmit Data Interrupt Flag
   #define RXIF   0x20 //Received Data Interrupt Flag
   #define STAIF  0x40 //START Interrupt Flag in Slave Mode
   #define SLBUSY 0x80 //Slave Busy Flag
#define I2CSLADR (*(unsigned char volatile xdata *)0xfe85) //I2C Slave Address
   #define MA    0x01 //Slave Device Address Matching
   #define SLADR 0xFE //Slave Device Address
#define I2CTXD (*(unsigned char volatile xdata *)0xfe86) //I2C Data Transmit Register
#define I2CRXD (*(unsigned char volatile xdata *)0xfe87) //I2C Data Receive Register
#define I2CMSAUX (*(unsigned char volatile xdata *)0xfe88) //I2C Master Auxiliary Control
   #define WDTA 0x01 //I2C Write Data Automatic Send Enable in Master Module
#define TM2PS (*(unsigned char volatile xdata *)0xfea2) //Timer 2 Prescaler
#define TM3PS (*(unsigned char volatile xdata *)0xfea3) //Timer 3 Prescaler
#define TM4PS (*(unsigned char volatile xdata *)0xfea4) //Timer 4 Prescaler
#define ADCTIM (*(unsigned char volatile xdata *)0xfea8) //ADC Timing Control
#define T3T4PS (*(unsigned char volatile xdata *)0xfeac) //Undocumented
#define PWM0C (*(unsigned int  volatile xdata *)0xff00) //PWM 0 Counter Word
#define PWM0CH (*(unsigned char volatile xdata *)0xff00) //PWM 0 Counter High Byte
#define PWM0CL (*(unsigned char volatile xdata *)0xff01) //PWM 0 Counter Low Byte
#define PWM0CKS (*(unsigned char volatile xdata *)0xff02) //PWM 0 Clock Selection
   #define PWM_PS 0x0F //PWM System Clock Prescaler
   #define SELT2  0x10 //PWM Clock Source Selection
#define PWM0TADC (*(unsigned int  volatile xdata *)0xff03) //PWM 0 Trigger ADC Count Word
#define PWM0TADCH (*(unsigned char volatile xdata *)0xff03) //PWM 0 Trigger ADC Count High Byte
#define PWM0TADCL (*(unsigned char volatile xdata *)0xff04) //PWM 0 Trigger ADC Count Low Byte
#define PWM0IF (*(unsigned char volatile xdata *)0xff05) //PWM 0 Interrupt Flags
   #define C0IF 0x01 //Channel 0 Interrupt Flag
   #define C1IF 0x02 //Channel 1 Interrupt Flag
   #define C2IF 0x04 //Channel 2 Interrupt Flag
   #define C3IF 0x08 //Channel 3 Interrupt Flag
   #define C4IF 0x10 //Channel 4 Interrupt Flag
   #define C5IF 0x20 //Channel 5 Interrupt Flag
   #define C6IF 0x40 //Channel 6 Interrupt Flag
   #define C7IF 0x80 //Channel 7 Interrupt Flag
#define PWM0FDCR (*(unsigned char volatile xdata *)0xff06) //PWM 0 Fault Detect Control Register
   #define FDIF    0x01 //Fault Detect Interrupt Flag
   #define FDIO    0x02 //IO Port Fault Detect
   #define FDCMP   0x04 //Comparator Fault Detect
   #define EFDI    0x08 //Enable Fault Detect Interrupt
   #define FLTFLIO 0x10 //Fault Detect IO Port Action
   #define ENFD    0x20 //Enable Fault Detect
   #define INVIO   0x40 //Invert IO Port Fault Detect Level
   #define INVCMP  0x80 //Invert Comparator Fault Detect Level
#define PWM00T1 (*(unsigned int  volatile xdata *)0xff10) //PWM 0 Chanel 0 Timer 1 Word
#define PWM00T1H (*(unsigned char volatile xdata *)0xff10) //PWM 0 Chanel 0 Timer 1 High Byte
#define PWM00T1L (*(unsigned char volatile xdata *)0xff11) //PWM 0 Chanel 0 Timer 1 Low Byte
#define PWM00T2 (*(unsigned int  volatile xdata *)0xff12) //PWM 0 Chanel 0 Timer 2 Word
#define PWM00T2H (*(unsigned char volatile xdata *)0xff12) //PWM 0 Chanel 0 Timer 2 High Byte
#define PWM00T2L (*(unsigned char volatile xdata *)0xff13) //PWM 0 Chanel 0 Timer 2 Low Byte
#define PWM00CR (*(unsigned char volatile xdata *)0xff14) //PWM 0 Chanel 0 Control Register
   #define PWM00_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM00_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM00_ENI   0x04 //Enable Interrupt
   #define PWM00_INI   0x40 //Initial Output Level
   #define PWM00_ENO   0x80 //PWM Output Enable Bit
#define PWM00HLD (*(unsigned char volatile xdata *)0xff15) //PWM 0 Chanel 0 Level Hold Control
   #define PWM00_HLDL 0x01 //Hold Low Override
   #define PWM00_HLDH 0x02 //Hold High Override
#define PWM01T1 (*(unsigned int  volatile xdata *)0xff18) //PWM 0 Chanel 1 Timer 1 Word
#define PWM01T1H (*(unsigned char volatile xdata *)0xff18) //PWM 0 Chanel 1 Timer 1 High Byte
#define PWM01T1L (*(unsigned char volatile xdata *)0xff19) //PWM 0 Chanel 1 Timer 1 Low Byte
#define PWM01T2 (*(unsigned int  volatile xdata *)0xff1a) //PWM 0 Chanel 1 Timer 2 Word
#define PWM01T2H (*(unsigned char volatile xdata *)0xff1a) //PWM 0 Chanel 1 Timer 2 High Byte
#define PWM01T2L (*(unsigned char volatile xdata *)0xff1b) //PWM 0 Chanel 1 Timer 2 Low Byte
#define PWM01CR (*(unsigned char volatile xdata *)0xff1c) //PWM 0 Chanel 1 Control Register
   #define PWM41_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM41_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM41_ENI   0x04 //Enable Interrupt
   #define PWM41_INI   0x40 //Initial Output Level
   #define PWM41_ENO   0x80 //PWM Output Enable Bit
#define PWM01HLD (*(unsigned char volatile xdata *)0xff1d) //PWM 0 Chanel 1 Level Hold Control
#define PWM02T1 (*(unsigned int  volatile xdata *)0xff20) //PWM 0 Chanel 2 Timer 1 Word
#define PWM02T1H (*(unsigned char volatile xdata *)0xff20) //PWM 0 Chanel 2 Timer 1 High Byte
#define PWM02T1L (*(unsigned char volatile xdata *)0xff21) //PWM 0 Chanel 2 Timer 1 Low Byte
#define PWM02T2 (*(unsigned int  volatile xdata *)0xff22) //PWM 0 Chanel 2 Timer 2 Word
#define PWM02T2H (*(unsigned char volatile xdata *)0xff22) //PWM 0 Chanel 2 Timer 2 High Byte
#define PWM02T2L (*(unsigned char volatile xdata *)0xff23) //PWM 0 Chanel 2 Timer 2 Low Byte
#define PWM02CR (*(unsigned char volatile xdata *)0xff24) //PWM 0 Chanel 2 Control Register
   #define PWM02_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM02_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM02_ENI   0x04 //Enable Interrupt
   #define PWM02_INI   0x40 //Initial Output Level
   #define PWM02_ENO   0x80 //PWM Output Enable Bit
#define PWM02HLD (*(unsigned char volatile xdata *)0xff25) //PWM 0 Chanel 2 Level Hold Control
   #define PWM02_HLDL 0x01 //Hold Low Override
   #define PWM02_HLDH 0x02 //Hold High Override
#define PWM03T1 (*(unsigned int  volatile xdata *)0xff28) //PWM 0 Chanel 3 Timer 1 Word
#define PWM03T1H (*(unsigned char volatile xdata *)0xff28) //PWM 0 Chanel 3 Timer 1 High Byte
#define PWM03T1L (*(unsigned char volatile xdata *)0xff29) //PWM 0 Chanel 3 Timer 1 Low Byte
#define PWM03T2 (*(unsigned int  volatile xdata *)0xff2a) //PWM 0 Chanel 3 Timer 2 Word
#define PWM03T2H (*(unsigned char volatile xdata *)0xff2a) //PWM 0 Chanel 3 Timer 2 High Byte
#define PWM03T2L (*(unsigned char volatile xdata *)0xff2b) //PWM 0 Chanel 3 Timer 2 Low Byte
#define PWM03CR (*(unsigned char volatile xdata *)0xff2c) //PWM 0 Chanel 3 Control Register
   #define PWM03_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM03_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM03_ENI   0x04 //Enable Interrupt
   #define PWM03_INI   0x40 //Initial Output Level
   #define PWM03_ENO   0x80 //PWM Output Enable Bit
#define PWM03HLD (*(unsigned char volatile xdata *)0xff2d) //PWM 0 Chanel 3 Level Hold Control
   #define PWM03_HLDL 0x01 //Hold Low Override
   #define PWM03_HLDH 0x02 //Hold High Override
#define PWM04T1 (*(unsigned int  volatile xdata *)0xff30) //PWM 0 Chanel 4 Timer 1 Word
#define PWM04T1H (*(unsigned char volatile xdata *)0xff30) //PWM 0 Chanel 4 Timer 1 High Byte
#define PWM04T1L (*(unsigned char volatile xdata *)0xff31) //PWM 0 Chanel 4 Timer 1 Low Byte
#define PWM04T2 (*(unsigned int  volatile xdata *)0xff32) //PWM 0 Chanel 4 Timer 2 Word
#define PWM04T2H (*(unsigned char volatile xdata *)0xff32) //PWM 0 Chanel 4 Timer 2 High Byte
#define PWM04T2L (*(unsigned char volatile xdata *)0xff33) //PWM 0 Chanel 4 Timer 2 Low Byte
#define PWM04CR (*(unsigned char volatile xdata *)0xff34) //PWM 0 Chanel 4 Control Register
   #define PWM04_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM04_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM04_ENI   0x04 //Enable Interrupt
   #define PWM04_INI   0x40 //Initial Output Level
   #define PWM04_ENO   0x80 //PWM Output Enable Bit
#define PWM04HLD (*(unsigned char volatile xdata *)0xff35) //PWM 0 Chanel 4 Level Hold Control
   #define PWM04_HLDL 0x01 //Hold Low Override
   #define PWM04_HLDH 0x02 //Hold High Override
#define PWM05T1 (*(unsigned int  volatile xdata *)0xff38) //PWM 0 Chanel 5 Timer 1 Word
#define PWM05T1H (*(unsigned char volatile xdata *)0xff38) //PWM 0 Chanel 5 Timer 1 High Byte
#define PWM05T1L (*(unsigned char volatile xdata *)0xff39) //PWM 0 Chanel 5 Timer 1 Low Byte
#define PWM05T2 (*(unsigned int  volatile xdata *)0xff3a) //PWM 0 Chanel 5 Timer 2 Word
#define PWM05T2H (*(unsigned char volatile xdata *)0xff3a) //PWM 0 Chanel 5 Timer 2 High Byte
#define PWM05T2L (*(unsigned char volatile xdata *)0xff3b) //PWM 0 Chanel 5 Timer 2 Low Byte
#define PWM05CR (*(unsigned char volatile xdata *)0xff3c) //PWM 0 Chanel 5 Control Register
   #define PWM05_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM05_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM05_ENI   0x04 //Enable Interrupt
   #define PWM05_INI   0x40 //Initial Output Level
   #define PWM05_ENO   0x80 //PWM Output Enable Bit
#define PWM05HLD (*(unsigned char volatile xdata *)0xff3d) //PWM 0 Chanel 5 Level Hold Control
   #define PWM05_HLDL 0x01 //Hold Low Override
   #define PWM05_HLDH 0x02 //Hold High Override
#define PWM06T1 (*(unsigned int  volatile xdata *)0xff40) //PWM 0 Chanel 6 Timer 1 Word
#define PWM06T1H (*(unsigned char volatile xdata *)0xff40) //PWM 0 Chanel 6 Timer 1 High Byte
#define PWM06T1L (*(unsigned char volatile xdata *)0xff41) //PWM 0 Chanel 6 Timer 1 Low Byte
#define PWM06T2 (*(unsigned int  volatile xdata *)0xff42) //PWM 0 Chanel 6 Timer 2 Word
#define PWM06T2H (*(unsigned char volatile xdata *)0xff42) //PWM 0 Chanel 6 Timer 2 High Byte
#define PWM06T2L (*(unsigned char volatile xdata *)0xff43) //PWM 0 Chanel 6 Timer 2 Low Byte
#define PWM06CR (*(unsigned char volatile xdata *)0xff44) //PWM 0 Chanel 6 Control Register
   #define PWM06_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM06_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM06_ENI   0x04 //Enable Interrupt
   #define PWM06_INI   0x40 //Initial Output Level
   #define PWM06_ENO   0x80 //PWM Output Enable Bit
#define PWM06HLD (*(unsigned char volatile xdata *)0xff45) //PWM 0 Chanel 6 Level Hold Control
   #define PWM06_HLDL 0x01 //Hold Low Override
   #define PWM06_HLDH 0x02 //Hold High Override
#define PWM07T1 (*(unsigned int  volatile xdata *)0xff48) //PWM 0 Chanel 7 Timer 1 Word
#define PWM07T1H (*(unsigned char volatile xdata *)0xff48) //PWM 0 Chanel 7 Timer 1 High Byte
#define PWM07T1L (*(unsigned char volatile xdata *)0xff49) //PWM 0 Chanel 7 Timer 1 Low Byte
#define PWM07T2 (*(unsigned int  volatile xdata *)0xff4a) //PWM 0 Chanel 7 Timer 2 Word
#define PWM07T2H (*(unsigned char volatile xdata *)0xff4a) //PWM 0 Chanel 7 Timer 2 High Byte
#define PWM07T2L (*(unsigned char volatile xdata *)0xff4b) //PWM 0 Chanel 7 Timer 2 Low Byte
#define PWM07CR (*(unsigned char volatile xdata *)0xff4c) //PWM 0 Chanel 7 Control Register
   #define PWM07_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM07_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM07_ENI   0x04 //Enable Interrupt
   #define PWM07_INI   0x40 //Initial Output Level
   #define PWM07_ENO   0x80 //PWM Output Enable Bit
#define PWM07HLD (*(unsigned char volatile xdata *)0xff4d) //PWM 0 Chanel 7 Level Hold Control
   #define PWM07_HLDL 0x01 //Hold Low Override
   #define PWM07_HLDH 0x02 //Hold High Override
#define PWM1C (*(unsigned int  volatile xdata *)0xff50) //PWM 1 Counter Word
#define PWM1CH (*(unsigned char volatile xdata *)0xff50) //PWM 1 Counter High Byte
#define PWM1CL (*(unsigned char volatile xdata *)0xff51) //PWM 1 Counter Low Byte
#define PWM1CKS (*(unsigned char volatile xdata *)0xff52) //PWM 1 Clock Selection
   #define PWM_PS 0x0F //PWM System Clock Prescaler
   #define SELT2  0x10 //PWM Clock Source Selection
#define PWM1IF (*(unsigned char volatile xdata *)0xff55) //PWM 1 Interrupt Flags
   #define C0IF 0x01 //Channel 0 Interrupt Flag
   #define C1IF 0x02 //Channel 1 Interrupt Flag
   #define C2IF 0x04 //Channel 2 Interrupt Flag
   #define C3IF 0x08 //Channel 3 Interrupt Flag
   #define C4IF 0x10 //Channel 4 Interrupt Flag
   #define C5IF 0x20 //Channel 5 Interrupt Flag
   #define C6IF 0x40 //Channel 6 Interrupt Flag
   #define C7IF 0x80 //Channel 7 Interrupt Flag
#define PWM1FDCR (*(unsigned char volatile xdata *)0xff56) //PWM 1 Fault Detect Control Register
   #define FDIF    0x01 //Fault Detect Interrupt Flag
   #define FDIO    0x02 //IO Port Fault Detect
   #define FDCMP   0x04 //Comparator Fault Detect
   #define EFDI    0x08 //Enable Fault Detect Interrupt
   #define FLTFLIO 0x10 //Fault Detect IO Port Action
   #define ENFD    0x20 //Enable Fault Detect
   #define INVIO   0x40 //Invert IO Port Fault Detect Level
   #define INVCMP  0x80 //Invert Comparator Fault Detect Level
#define PWM10T1 (*(unsigned int  volatile xdata *)0xff60) //PWM 1 Chanel 0 Timer 1 Word
#define PWM10T1H (*(unsigned char volatile xdata *)0xff60) //PWM 1 Chanel 0 Timer 1 High Byte
#define PWM10T1L (*(unsigned char volatile xdata *)0xff61) //PWM 1 Chanel 0 Timer 1 Low Byte
#define PWM10T2 (*(unsigned int  volatile xdata *)0xff62) //PWM 1 Chanel 0 Timer 2 Word
#define PWM10T2H (*(unsigned char volatile xdata *)0xff62) //PWM 1 Chanel 0 Timer 2 High Byte
#define PWM10T2L (*(unsigned char volatile xdata *)0xff63) //PWM 1 Chanel 0 Timer 2 Low Byte
#define PWM10CR (*(unsigned char volatile xdata *)0xff64) //PWM 1 Chanel 0 Control Register
   #define PWM10_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM10_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM10_ENI   0x04 //Enable Interrupt
   #define PWM10_INI   0x40 //Initial Output Level
   #define PWM10_ENO   0x80 //PWM Output Enable Bit
#define PWM10HLD (*(unsigned char volatile xdata *)0xff65) //PWM 1 Chanel 0 Level Hold Control
   #define PWM10_HLDL 0x01 //Hold Low Override
   #define PWM10_HLDH 0x02 //Hold High Override
#define PWM11T1 (*(unsigned int  volatile xdata *)0xff68) //PWM 1 Chanel 1 Timer 1 Word
#define PWM11T1H (*(unsigned char volatile xdata *)0xff68) //PWM 1 Chanel 1 Timer 1 High Byte
#define PWM11T1L (*(unsigned char volatile xdata *)0xff69) //PWM 1 Chanel 1 Timer 1 Low Byte
#define PWM11T2 (*(unsigned int  volatile xdata *)0xff6a) //PWM 1 Chanel 1 Timer 2 Word
#define PWM11T2H (*(unsigned char volatile xdata *)0xff6a) //PWM 1 Chanel 1 Timer 2 High Byte
#define PWM11T2L (*(unsigned char volatile xdata *)0xff6b) //PWM 1 Chanel 1 Timer 2 Low Byte
#define PWM11CR (*(unsigned char volatile xdata *)0xff6c) //PWM 1 Chanel 1 Control Register
   #define PWM11_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM11_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM11_ENI   0x04 //Enable Interrupt
   #define PWM11_INI   0x40 //Initial Output Level
   #define PWM11_ENO   0x80 //PWM Output Enable Bit
#define PWM11HLD (*(unsigned char volatile xdata *)0xff6d) //PWM 1 Chanel 1 Level Hold Control
   #define PWM11_HLDL 0x01 //Hold Low Override
   #define PWM11_HLDH 0x02 //Hold High Override
#define PWM12T1 (*(unsigned int  volatile xdata *)0xff70) //PWM 1 Chanel 2 Timer 1 Word
#define PWM12T1H (*(unsigned char volatile xdata *)0xff70) //PWM 1 Chanel 2 Timer 1 High Byte
#define PWM12T1L (*(unsigned char volatile xdata *)0xff71) //PWM 1 Chanel 2 Timer 1 Low Byte
#define PWM12T2 (*(unsigned int  volatile xdata *)0xff72) //PWM 1 Chanel 2 Timer 2 Word
#define PWM12T2H (*(unsigned char volatile xdata *)0xff72) //PWM 1 Chanel 2 Timer 2 High Byte
#define PWM12T2L (*(unsigned char volatile xdata *)0xff73) //PWM 1 Chanel 2 Timer 2 Low Byte
#define PWM12CR (*(unsigned char volatile xdata *)0xff74) //PWM 1 Chanel 2 Control Register
   #define PWM12_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM12_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM12_ENI   0x04 //Enable Interrupt
   #define PWM12_INI   0x40 //Initial Output Level
   #define PWM12_ENO   0x80 //PWM Output Enable Bit
#define PWM12HLD (*(unsigned char volatile xdata *)0xff75) //PWM 1 Chanel 2 Level Hold Control
#define PWM12_HLDL 0x01 //Hold Low Override
   #define PWM12_HLDH 0x02 //Hold High Override
   #define PWM43_HLDL 0x01 //Hold Low Override
   #define PWM43_HLDH 0x02 //Hold High Override
#define PWM13T1 (*(unsigned int  volatile xdata *)0xff78) //PWM 1 Chanel 3 Timer 1 Word
#define PWM13T1H (*(unsigned char volatile xdata *)0xff78) //PWM 1 Chanel 3 Timer 1 High Byte
#define PWM13T1L (*(unsigned char volatile xdata *)0xff79) //PWM 1 Chanel 3 Timer 1 Low Byte
#define PWM13T2 (*(unsigned int  volatile xdata *)0xff7a) //PWM 1 Chanel 3 Timer 2 Word
#define PWM13T2H (*(unsigned char volatile xdata *)0xff7a) //PWM 1 Chanel 3 Timer 2 High Byte
#define PWM13T2L (*(unsigned char volatile xdata *)0xff7b) //PWM 1 Chanel 3 Timer 2 Low Byte
#define PWM13CR (*(unsigned char volatile xdata *)0xff7c) //PWM 1 Chanel 3 Control Register
#define PWM13_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM13_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM13_ENI   0x04 //Enable Interrupt
   #define PWM13_INI   0x40 //Initial Output Level
   #define PWM13_ENO   0x80 //PWM Output Enable Bit
#define PWM13HLD (*(unsigned char volatile xdata *)0xff7d) //PWM 1 Chanel 3 Level Hold Control
   #define PWM13_HLDL 0x01 //Hold Low Override
   #define PWM13_HLDH 0x02 //Hold High Override
#define PWM14T1 (*(unsigned int  volatile xdata *)0xff80) //PWM 1 Chanel 4 Timer 1 Word
#define PWM14T1H (*(unsigned char volatile xdata *)0xff80) //PWM 1 Chanel 4 Timer 1 High Byte
#define PWM14T1L (*(unsigned char volatile xdata *)0xff81) //PWM 1 Chanel 4 Timer 1 Low Byte
#define PWM14T2 (*(unsigned int  volatile xdata *)0xff82) //PWM 1 Chanel 4 Timer 2 Word
#define PWM14T2H (*(unsigned char volatile xdata *)0xff82) //PWM 1 Chanel 4 Timer 2 High Byte
#define PWM14T2L (*(unsigned char volatile xdata *)0xff83) //PWM 1 Chanel 4 Timer 2 Low Byte
#define PWM14CR (*(unsigned char volatile xdata *)0xff84) //PWM 1 Chanel 4 Control Register
   #define PWM14_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM14_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM14_ENI   0x04 //Enable Interrupt
   #define PWM14_INI   0x40 //Initial Output Level
   #define PWM14_ENO   0x80 //PWM Output Enable Bit
#define PWM14HLD (*(unsigned char volatile xdata *)0xff85) //PWM 1 Chanel 4 Level Hold Control
   #define PWM14_HLDL 0x01 //Hold Low Override
   #define PWM14_HLDH 0x02 //Hold High Override
#define PWM15T1 (*(unsigned int  volatile xdata *)0xff88) //PWM 1 Chanel 5 Timer 1 Word
#define PWM15T1H (*(unsigned char volatile xdata *)0xff88) //PWM 1 Chanel 5 Timer 1 High Byte
#define PWM15T1L (*(unsigned char volatile xdata *)0xff89) //PWM 1 Chanel 5 Timer 1 Low Byte
#define PWM15T2 (*(unsigned int  volatile xdata *)0xff8a) //PWM 1 Chanel 5 Timer 2 Word
#define PWM15T2H (*(unsigned char volatile xdata *)0xff8a) //PWM 1 Chanel 5 Timer 2 High Byte
#define PWM15T2L (*(unsigned char volatile xdata *)0xff8b) //PWM 1 Chanel 5 Timer 2 Low Byte
#define PWM15CR (*(unsigned char volatile xdata *)0xff8c) //PWM 1 Chanel 5 Control Register
   #define PWM15_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM15_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM15_ENI   0x04 //Enable Interrupt
   #define PWM15_INI   0x40 //Initial Output Level
   #define PWM15_ENO   0x80 //PWM Output Enable Bit
#define PWM15HLD (*(unsigned char volatile xdata *)0xff8d) //PWM 1 Chanel 5 Level Hold Control
   #define PWM15_HLDL 0x01 //Hold Low Override
   #define PWM15_HLDH 0x02 //Hold High Override
#define PWM16T1 (*(unsigned int  volatile xdata *)0xff90) //PWM 1 Chanel 6 Timer 1 Word
#define PWM16T1H (*(unsigned char volatile xdata *)0xff90) //PWM 1 Chanel 6 Timer 1 High Byte
#define PWM16T1L (*(unsigned char volatile xdata *)0xff91) //PWM 1 Chanel 6 Timer 1 Low Byte
#define PWM16T2 (*(unsigned int  volatile xdata *)0xff92) //PWM 1 Chanel 6 Timer 2 Word
#define PWM16T2H (*(unsigned char volatile xdata *)0xff92) //PWM 1 Chanel 6 Timer 2 High Byte
#define PWM16T2L (*(unsigned char volatile xdata *)0xff93) //PWM 1 Chanel 6 Timer 2 Low Byte
#define PWM16CR (*(unsigned char volatile xdata *)0xff94) //PWM 1 Chanel 6 Control Register
   #define PWM16_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM16_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM16_ENI   0x04 //Enable Interrupt
   #define PWM16_INI   0x40 //Initial Output Level
   #define PWM16_ENO   0x80 //PWM Output Enable Bit
#define PWM16HLD (*(unsigned char volatile xdata *)0xff95) //PWM 1 Chanel 6 Level Hold Control
   #define PWM16_HLDL 0x01 //Hold Low Override
   #define PWM16_HLDH 0x02 //Hold High Override
#define PWM17T1 (*(unsigned int  volatile xdata *)0xff98) //PWM 1 Chanel 7 Timer 1 Word
#define PWM17T1H (*(unsigned char volatile xdata *)0xff98) //PWM 1 Chanel 7 Timer 1 High Byte
#define PWM17T1L (*(unsigned char volatile xdata *)0xff99) //PWM 1 Chanel 7 Timer 1 Low Byte
#define PWM17T2 (*(unsigned int  volatile xdata *)0xff9a) //PWM 1 Chanel 7 Timer 2 Word
#define PWM17T2H (*(unsigned char volatile xdata *)0xff9a) //PWM 1 Chanel 7 Timer 2 High Byte
#define PWM17T2L (*(unsigned char volatile xdata *)0xff9b) //PWM 1 Chanel 7 Timer 2 Low Byte
#define PWM17CR (*(unsigned char volatile xdata *)0xff9c) //PWM 1 Chanel 7 Control Register
   #define PWM17_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM17_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM17_ENI   0x04 //Enable Interrupt
   #define PWM17_INI   0x40 //Initial Output Level
   #define PWM17_ENO   0x80 //PWM Output Enable Bit
#define PWM17HLD (*(unsigned char volatile xdata *)0xff9d) //PWM 1 Chanel 7 Level Hold Control
   #define PWM17_HLDL 0x01 //Hold Low Override
   #define PWM17_HLDH 0x02 //Hold High Override
#define PWM2C (*(unsigned int  volatile xdata *)0xffa0) //PWM 2 Counter Word
#define PWM2CH (*(unsigned char volatile xdata *)0xffa0) //PWM 2 Counter High Byte
#define PWM2CL (*(unsigned char volatile xdata *)0xffa1) //PWM 2 Counter Low Byte
#define PWM2CKS (*(unsigned char volatile xdata *)0xffa2) //PWM 2 Clock Selection
   #define PWM_PS 0x0F //PWM System Clock Prescaler
   #define SELT2  0x10 //PWM Clock Source Selection
#define PWM2TADC (*(unsigned int  volatile xdata *)0xffa3) //PWM 2 Trigger ADC Count Word
#define PWM2TADCH (*(unsigned char volatile xdata *)0xffa3) //PWM 2 Trigger ADC Count High Byte
#define PWM2TADCL (*(unsigned char volatile xdata *)0xffa4) //PWM 2 Trigger ADC Count Low Byte
#define PWM2IF (*(unsigned char volatile xdata *)0xffa5) //PWM 2 Interrupt Flags
   #define C0IF 0x01 //Channel 0 Interrupt Flag
   #define C1IF 0x02 //Channel 1 Interrupt Flag
   #define C2IF 0x04 //Channel 2 Interrupt Flag
   #define C3IF 0x08 //Channel 3 Interrupt Flag
   #define C4IF 0x10 //Channel 4 Interrupt Flag
   #define C5IF 0x20 //Channel 5 Interrupt Flag
   #define C6IF 0x40 //Channel 6 Interrupt Flag
   #define C7IF 0x80 //Channel 7 Interrupt Flag
#define PWM2FDCR (*(unsigned char volatile xdata *)0xffa6) //PWM 2 Fault Detect Control Register
   #define FDIF    0x01 //Fault Detect Interrupt Flag
   #define FDIO    0x02 //IO Port Fault Detect
   #define FDCMP   0x04 //Comparator Fault Detect
   #define EFDI    0x08 //Enable Fault Detect Interrupt
   #define FLTFLIO 0x10 //Fault Detect IO Port Action
   #define ENFD    0x20 //Enable Fault Detect
   #define INVIO   0x40 //Invert IO Port Fault Detect Level
   #define INVCMP  0x80 //Invert Comparator Fault Detect Level
#define PWM20T1 (*(unsigned int  volatile xdata *)0xffb0) //PWM 2 Chanel 0 Timer 1 Word
#define PWM20T1H (*(unsigned char volatile xdata *)0xffb0) //PWM 2 Chanel 0 Timer 1 High Byte
#define PWM20T1L (*(unsigned char volatile xdata *)0xffb1) //PWM 2 Chanel 0 Timer 1 Low Byte
#define PWM20T2 (*(unsigned int  volatile xdata *)0xffb2) //PWM 2 Chanel 0 Timer 2 Word
#define PWM20T2H (*(unsigned char volatile xdata *)0xffb2) //PWM 2 Chanel 0 Timer 2 High Byte
#define PWM20T2L (*(unsigned char volatile xdata *)0xffb3) //PWM 2 Chanel 0 Timer 2 Low Byte
#define PWM20CR (*(unsigned char volatile xdata *)0xffb4) //PWM 2 Chanel 0 Control Register
   #define PWM20_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM20_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM20_ENI   0x04 //Enable Interrupt
   #define PWM20_INI   0x40 //Initial Output Level
   #define PWM20_ENO   0x80 //PWM Output Enable Bit
#define PWM20HLD (*(unsigned char volatile xdata *)0xffb5) //PWM 4 Chanel 0 Level Hold Control
   #define PWM20_HLDL 0x01 //Hold Low Override
   #define PWM20_HLDH 0x02 //Hold High Override
#define PWM21T1 (*(unsigned int  volatile xdata *)0xffb8) //PWM 2 Chanel 1 Timer 1 Word
#define PWM21T1H (*(unsigned char volatile xdata *)0xffb8) //PWM 2 Chanel 1 Timer 1 High Byte
#define PWM21T1L (*(unsigned char volatile xdata *)0xffb9) //PWM 2 Chanel 1 Timer 1 Low Byte
#define PWM21T2 (*(unsigned int  volatile xdata *)0xffba) //PWM 2 Chanel 1 Timer 2 Word
#define PWM21T2H (*(unsigned char volatile xdata *)0xffba) //PWM 2 Chanel 1 Timer 2 High Byte
#define PWM21T2L (*(unsigned char volatile xdata *)0xffbb) //PWM 2 Chanel 1 Timer 2 Low Byte
#define PWM21CR (*(unsigned char volatile xdata *)0xffbc) //PWM 2 Chanel 1 Control Register
   #define PWM21_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM21_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM21_ENI   0x04 //Enable Interrupt
   #define PWM21_INI   0x40 //Initial Output Level
   #define PWM21_ENO   0x80 //PWM Output Enable Bit
#define PWM21HLD (*(unsigned char volatile xdata *)0xffbd) //PWM 2 Chanel 1 Level Hold Control
   #define PWM21_HLDL 0x01 //Hold Low Override
   #define PWM21_HLDH 0x02 //Hold High Override
#define PWM22T1 (*(unsigned int  volatile xdata *)0xffc0) //PWM 2 Chanel 2 Timer 1 Word
#define PWM22T1H (*(unsigned char volatile xdata *)0xffc0) //PWM 2 Chanel 2 Timer 1 High Byte
#define PWM22T1L (*(unsigned char volatile xdata *)0xffc1) //PWM 2 Chanel 2 Timer 1 Low Byte
#define PWM22T2 (*(unsigned int  volatile xdata *)0xffc2) //PWM 2 Chanel 2 Timer 2 Word
#define PWM22T2H (*(unsigned char volatile xdata *)0xffc2) //PWM 2 Chanel 2 Timer 2 High Byte
#define PWM22T2L (*(unsigned char volatile xdata *)0xffc3) //PWM 2 Chanel 2 Timer 2 Low Byte
#define PWM22CR (*(unsigned char volatile xdata *)0xffc4) //PWM 2 Chanel 2 Control Register
   #define PWM22_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM22_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM22_ENI   0x04 //Enable Interrupt
   #define PWM22_INI   0x40 //Initial Output Level
   #define PWM22_ENO   0x80 //PWM Output Enable Bit
#define PWM22HLD (*(unsigned char volatile xdata *)0xffc5) //PWM 2 Chanel 2 Level Hold Control
   #define PWM22_HLDL 0x01 //Hold Low Override
   #define PWM42_HLDH 0x02 //Hold High Override
#define PWM23T1 (*(unsigned int  volatile xdata *)0xffc8) //PWM 2 Chanel 3 Timer 1 Word
#define PWM23T1H (*(unsigned char volatile xdata *)0xffc8) //PWM 2 Chanel 3 Timer 1 High Byte
#define PWM23T1L (*(unsigned char volatile xdata *)0xffc9) //PWM 2 Chanel 3 Timer 1 Low Byte
#define PWM23T2 (*(unsigned int  volatile xdata *)0xffca) //PWM 2 Chanel 3 Timer 2 Word
#define PWM23T2H (*(unsigned char volatile xdata *)0xffca) //PWM 2 Chanel 3 Timer 2 High Byte
#define PWM23T2L (*(unsigned char volatile xdata *)0xffcb) //PWM 2 Chanel 3 Timer 2 Low Byte
#define PWM23CR (*(unsigned char volatile xdata *)0xffcc) //PWM 2 Chanel 3 Control Register
   #define PWM23_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM23_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM23_ENI   0x04 //Enable Interrupt
   #define PWM23_INI   0x40 //Initial Output Level
   #define PWM23_ENO   0x80 //PWM Output Enable Bit
#define PWM23HLD (*(unsigned char volatile xdata *)0xffcd) //PWM 2 Chanel 3 Level Hold Control
   #define PWM23_HLDL 0x01 //Hold Low Override
   #define PWM23_HLDH 0x02 //Hold High Override
#define PWM24T1 (*(unsigned int  volatile xdata *)0xffd0) //PWM 2 Chanel 4 Timer 1 Word
#define PWM24T1H (*(unsigned char volatile xdata *)0xffd0) //PWM 2 Chanel 4 Timer 1 High Byte
#define PWM24T1L (*(unsigned char volatile xdata *)0xffd1) //PWM 2 Chanel 4 Timer 1 Low Byte
#define PWM24T2 (*(unsigned int  volatile xdata *)0xffd2) //PWM 2 Chanel 4 Timer 2 Word
#define PWM24T2H (*(unsigned char volatile xdata *)0xffd2) //PWM 2 Chanel 4 Timer 2 High Byte
#define PWM24T2L (*(unsigned char volatile xdata *)0xffd3) //PWM 2 Chanel 4 Timer 2 Low Byte
#define PWM24CR (*(unsigned char volatile xdata *)0xffd4) //PWM 2 Chanel 4 Control Register
   #define PWM24_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM24_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM24_ENI   0x04 //Enable Interrupt
   #define PWM24_INI   0x40 //Initial Output Level
   #define PWM24_ENO   0x80 //PWM Output Enable Bit
#define PWM24HLD (*(unsigned char volatile xdata *)0xffd5) //PWM 2 Chanel 4 Level Hold Control
   #define PWM24_HLDL 0x01 //Hold Low Override
   #define PWM24_HLDH 0x02 //Hold High Override
#define PWM25T1 (*(unsigned int  volatile xdata *)0xffd8) //PWM 2 Chanel 5 Timer 1 Word
#define PWM25T1H (*(unsigned char volatile xdata *)0xffd8) //PWM 2 Chanel 5 Timer 1 High Byte
#define PWM25T1L (*(unsigned char volatile xdata *)0xffd9) //PWM 2 Chanel 5 Timer 1 Low Byte
#define PWM25T2 (*(unsigned int  volatile xdata *)0xffda) //PWM 2 Chanel 5 Timer 2 Word
#define PWM25T2H (*(unsigned char volatile xdata *)0xffda) //PWM 2 Chanel 5 Timer 2 High Byte
#define PWM25T2L (*(unsigned char volatile xdata *)0xffdb) //PWM 2 Chanel 5 Timer 2 Low Byte
#define PWM25CR (*(unsigned char volatile xdata *)0xffdc) //PWM 2 Chanel 5 Control Register
   #define PWM25_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM25_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM25_ENI   0x04 //Enable Interrupt
   #define PWM25_INI   0x40 //Initial Output Level
   #define PWM25_ENO   0x80 //PWM Output Enable Bit
#define PWM25HLD (*(unsigned char volatile xdata *)0xffdd) //PWM 2 Chanel 5 Level Hold Control
   #define PWM25_HLDL 0x01 //Hold Low Override
   #define PWM25_HLDH 0x02 //Hold High Override
#define PWM26T1 (*(unsigned int  volatile xdata *)0xffe0) //PWM 2 Chanel 6 Timer 1 Word
#define PWM26T1H (*(unsigned char volatile xdata *)0xffe0) //PWM 2 Chanel 6 Timer 1 High Byte
#define PWM26T1L (*(unsigned char volatile xdata *)0xffe1) //PWM 2 Chanel 6 Timer 1 Low Byte
#define PWM26T2 (*(unsigned int  volatile xdata *)0xffe2) //PWM 2 Chanel 6 Timer 2 Word
#define PWM26T2H (*(unsigned char volatile xdata *)0xffe2) //PWM 2 Chanel 6 Timer 2 High Byte
#define PWM26T2L (*(unsigned char volatile xdata *)0xffe3) //PWM 2 Chanel 6 Timer 2 Low Byte
#define PWM26CR (*(unsigned char volatile xdata *)0xffe4) //PWM 2 Chanel 6 Control Register
   #define PWM26_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM26_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM26_ENI   0x04 //Enable Interrupt
   #define PWM26_INI   0x40 //Initial Output Level
   #define PWM26_ENO   0x80 //PWM Output Enable Bit
#define PWM26HLD (*(unsigned char volatile xdata *)0xffe5) //PWM 2 Chanel 7 Level Hold Control
   #define PWM26_HLDL 0x01 //Hold Low Override
   #define PWM26_HLDH 0x02 //Hold High Override
#define PWM27T1 (*(unsigned int  volatile xdata *)0xffe8) //PWM 2 Chanel 7 Timer 1 Word
#define PWM27T1H (*(unsigned char volatile xdata *)0xffe8) //PWM 2 Chanel 7 Timer 1 High Byte
#define PWM27T1L (*(unsigned char volatile xdata *)0xffe9) //PWM 2 Chanel 7 Timer 1 Low Byte
#define PWM27T2 (*(unsigned int  volatile xdata *)0xffea) //PWM 2 Chanel 7 Timer 2 Word
#define PWM27T2H (*(unsigned char volatile xdata *)0xffea) //PWM 2 Chanel 7 Timer 2 High Byte
#define PWM27T2L (*(unsigned char volatile xdata *)0xffeb) //PWM 2 Chanel 7 Timer 2 Low Byte
#define PWM27CR (*(unsigned char volatile xdata *)0xffec) //PWM 2 Chanel 7 Control Register
   #define PWM27_ENT1I 0x01 //Enable Trigger Point 1 Interrupt
   #define PWM27_ENT2I 0x02 //Enable Trigger Point 2 Interrupt
   #define PWM27_ENI   0x04 //Enable Interrupt
   #define PWM27_INI   0x40 //Initial Output Level
   #define PWM27_ENO   0x80 //PWM Output Enable Bit
#define PWM27HLD (*(unsigned char volatile xdata *)0xffed) //PWM 2 Chanel 7 Level Hold Control
   #define PWM27_HLDL 0x01 //Hold Low Override
   #define PWM27_HLDH 0x02 //Hold High Override

//Interrupt_Address = ( Interrupt_Number * 8 ) + 3
//Vectors are named after their corresponding IE, IP or IR register bit so
//that we don't have to invent names and can be more consistent across MCUs.
   #define X0_VECTOR   0  // 0x03  External Interrupt 0
   #define T0_VECTOR   1  // 0x0B  Timer 0
   #define X1_VECTOR   2  // 0x13  External Interrupt 1
   #define T1_VECTOR   3  // 0x1B  Timer 1
   #define S_VECTOR    4  // 0x23  Serial Port 1
   #define ADC_VECTOR  5  // 0x2B  Analog to Digital Converter
   #define LVD_VECTOR  6  // 0x33  Low Voltage Detect
   #define PCA_VECTOR  7  // 0x3B  Programmable Counter Array (CCP)
   #define S2_VECTOR   8  // 0x43  Serial Port 2
   #define SPI_VECTOR  9  // 0x4B  Serial Peripheral Interface
   #define X2_VECTOR   10 // 0x53  External Interrupt 2
   #define X3_VECTOR   11 // 0x5B  External Interrupt 3
   #define T2_VECTOR   12 // 0x63  Timer 2
   //       -          13    0x6B      -
   //       -          14    0x73  System Reserved
   //       -          15    0x7B  System Reserved
   #define X4_VECTOR   16 // 0x83  External Interrupt 4
   #define S3_VECTOR   17 // 0x8B  Serial Port 3
   #define S4_VECTOR   18 // 0x93  Serial Port 4
   #define T3_VECTOR   19 // 0x9B  Timer 3
   #define T4_VECTOR   20 // 0xA3  Timer 4
   #define CMP_VECTOR  21 // 0xAB  Comparator
   #define PWM0_VECTOR 22 // 0xB3  Pulse Width Modulator 0
   #define P0FD_VECTOR 23 // 0xBB  PWM 0 Fault Detect
   #define I2C_VECTOR  24 // 0xC3  Inter-Integrated Circuit (IIC)
   //       -          25 // 0xCB      -
   //       -          26 // 0xD3      -
   //       -          27 // 0xDB      -
   #define PWM1_VECTOR 28 // 0xE3  Pulse Width Modulator 1
   #define PWM2_VECTOR 29 // 0xEB  Pulse Width Modulator 2
   #define PWM3_VECTOR 30 // 0xF3  Pulse Width Modulator 3
   #define PWM4_VECTOR 31 // 0xFB  Pulse Width Modulator 4
   #define PWM5_VECTOR 32 // 0x103 Pulse Width Modulator 5
   #define P2FD_VECTOR 33 // 0x10B PWM 2 Fault Detect
   #define P4FD_VECTOR 34 // 0x113 PWM 4 Fault Detect
   #define TK_VECTOR   35 // 0x11B Touch Key

#endif
